      program block !Modified 1/16/97 to compute autocorrelation function
c prints: total number of blocks, effective number (if norms are different)
c   weighted average, error bars assuming blocking factors of 1, 2 , 4 .. 

c mnblk= maximum number of blocks/clone
c mnrb= log_2 (mnblk)
      parameter (mnblk=2096,mnrb=13)
      implicit real*8 (a-h,o-z)
      real*8 a(mnblk),norm(mnblk),a2(mnrb),am(mnrb),error(mnrb)
      integer ntblock(mnrb),nset(mnblk)

      top=0.d0
      bot=0.d0
      wtsq=0.d0
      iend=0
      iclast=1
      do irb=1,mnrb
       am(irb)=0.d0
       a2(irb)=0.d0
       ntblock(irb)=0
      enddo
c nset detects if blocks are missing or inconsistent.
        do i=1,mnblk
         nset(i)=0
        enddo

      do j=1,100000
c try to read a data record
      ! only one clone
      ic=1
      is=1
      an=1.d0 
C  INPUT DATA ON STANDARD INPUT
C   3 integers (clone number, set number , block number) +
C   2 REALS (block average and number of steps in that block)
C   YOU CAN CHANGE THIS TO  if you just have  ib and av
C      by taking off the comments
      read (*,*,end=3) ic, is, ib, av , an
c     read (*,*,end=3)  ib, av 

c finished one clone if ic changes
      if(ic.eq.iclast) go to 1

        go to 4
c set flag if end of file detected
3        iend=1
4       continue
!       write (*,*)'clone=',iclast,' number of blocks=',nblock
c add contributions of this clone to global averages
        do i=1,nblock
          if(nset(i).ne.nset(nblock)) then
            write (*,*)' missing block=',i,'clone=',ic
          endif
          top=top+norm(i)*a(i)
          bot=bot+norm(i)
          wtsq=wtsq+norm(i)**2
        enddo
        do i=1,mnblk
         nset(i)=0
        enddo

!beginning of new part
c compute autocorrelation. only works with one clone and norm(i)=constant.
! we cut off prints after correlation function goes negative.
!writes go on unit 1.
         write (1,*)' Autocorrelation function '
         write (1,*)' block autocor.fun. integral    error estimate '
         icf=1
         abar=top/bot
!        write (*,*) nblock,abar
         do k=0,nblock/2
          cf=0.d0
          do i=k+1,nblock
          cf=cf+(a(i)-abar)*(a(i-k)-abar)
          enddo
!         if(cf.le.0.d0)icf=-1!icf =-1 if cf after cf goes negative (not for MD)
          if(icf.gt.0) then
          cf=cf/(nblock-k)
          if(k.eq.0) var=cf
          cf=cf/var
          if(k.eq.0) then
            tcf=1.0d0
          else
           tcf=tcf+2.d0*cf
          endif
          write (1,'(i5,3e14.5)') k,cf,tcf,sqrt(tcf*var/(nblock-1.d0))
         endif
         enddo
!end of new part

c add to a2 and reblock
        do kkk=1,mnrb
c find mean and variance of current blocking
           ntblock(kkk)=ntblock(kkk)+nblock
           do k=1,nblock
             am(kkk)=am(kkk)+a(k)
             a2(kkk)=a2(kkk)+a(k)**2
           enddo
           nblock=nblock/2

           if(nblock.lt.1) go to 100
c reblock
           do k=1,nblock
             a(k)=.5d0*(a(2*k-1)+a(2*k))
           enddo
        enddo
100     continue

1     continue
      if(iend.ne.1) then
        iclast=ic
        nblock=ib
        a(ib)=av
        norm(ib)=an
        nset(ib)=is
      else
c finish up
        write (*,44)ntblock(1),bot**2/wtsq,top/bot
44      format(' no.blks=',i5,' eff.no.blks=',f7.2,' average ',e14.7)
c       write (*,*)' block size, no blocks, error'
        kmax=0
        do kkk=1,mnrb
c error bars are not reliable for less than 5? blocks
        if(ntblock(kkk).gt.3)then
         abar=am(kkk)/ntblock(kkk)
         arg=(a2(kkk)/ntblock(kkk)-abar**2)/float(ntblock(kkk)-1)
c account for loss of data due to blocking
c        arg=(2.d0**(kkk-1)*ntblock(kkk)*arg)/float(ntblock(1))
         if(arg.gt.0.) then
         kmax=kkk
         error(kkk)=sqrt(arg)
         else
         error(kkk)=0.d0
         endif
        endif
        enddo
        write (*,45) (error(k),k=1,kmax)
45      format(' blocked errors',10e12.5)
        stop
      endif

      enddo

      end
