      program gofr
c reads g(r) extends it, and fourier transforms it
c fort.8 will contain extended g(r)
c fort.9 will contain s(k)
      parameter (mnr=4,mx=5000,mnprm=12,nkv=61,ndim=3,mxv=400)
      implicit real*8 (a-h,o-z)
      parameter ( pi=3.1415926535)
      integer idim(mnr)
      real*8 serror(nkv),rv(mx),error(mx),grfit(mx),sofk(nkv),rkv(nkv)
     +,g(mx),rvv(mxv),cexpon(10),expon(10),pott(mxv)
      character  p(mnprm)*28,filen*14
      logical ifex

c reads a g(r) file makes a graph and does tail corrections
10    write (*,*) ' what run?'
      read (*,9) filen
9     format(a14)
      ln=index(filen,' ')-1
c does this file exist?
      inquire(file=filen(1:ln)//'.gr',exist=ifex)
      if(ifex) go to 20
      write (*,*)' file does not exist '
      go to 10

20    open(21,file=filen(1:ln)//'.gr',status='old',form='formatted')
      nr=0
      do 30 i=1,mnr
30    idim(i)=0
c get rank nr and the number of components for each rank tensor-index
      call checkrnk(21,nr,idim)
      ndata=1
      do 40 i=1,nr
40    ndata=ndata*idim(i)
      if(ndata.gt.mx) then
        write (*,*)' dimension of x too small '
        stop
      endif

50    if(ipickoff(21,p,n,mnprm).ne.0.or.n.le.0) then
        write (*,*)' data file empty ',n
        stop
      endif

      if(p(1).eq.'BEGIN') then
        read (21,*) (g(k),k=1,idim(1))
        read (21,*) (error(k),k=1,idim(1))
        go to 60
      elseif(p(1).eq.'GRID') then
        j=intread(p(2))
        call setgrid(mx,idim(1),rv,p(3))
      endif

      go to 50
60    close(21)
      iplot=1

      write (*,*)' input density'
      read (*,*) rho
      write (*,*)' input matching points'
      read (*,*) rfit,rmax
      lgtble=idim(1)
      dgofr=(rv(lgtble)-rv(1))/(lgtble-1)
      ifit=rfit/dgofr
      lgtble=rmax/dgofr
c integrat out to 3 times maximum 
      rint=3.*rv(lgtble)
      iint=rint/dgofr+.5
      do 400 i=1,lgtble
400   grfit(i)=g(i)
      do 410 i=lgtble+1,iint
       g(i)=0.
       error(i)=0.
c assume linear grid
410   rv(i)=rv(lgtble)+dgofr*(i-lgtble)
c now try and fit g(r)
      call fitg(grfit,dgofr,ifit,lgtble,iint,error)

      do i=1,1.5*lgtble
      write (8,100) rv(i),grfit(i),error(i)
      enddo

c do we want to recalculate the potential?
99      write (*,*) ' input prefix of dm file for potential, no to skip'
      read (*,9) filen
      ln=index(filen,' ')-1
      if(filen(1:ln).ne.'no') then
      open (3,file=filen(1:ln)//'.dm',status='unknown')
c loop thru file finding potential table and cutoffs
1     if(ipickoff(3,p,n,mnprm).eq.1)stop

      if(p(1).eq.'GRID') then
c input grid parameters
        nx=intread(p(2))
        call setgrid(mxv,nx,rvv,p(3))

      elseif(p(1).eq.'POT') then
        cutr=rlread(p(3))
        write (*,*) 'cutr =',cutr
      elseif(p(1).eq.'POTTAIL') then
        pot0 = rlread(p(2))
        ntail = intread(p(3))
        do i=1,ntail
          expon(i)=rlread(p(2*i+2))
          cexpon(i)=rlread(p(2*i+3))
        enddo
        write (*,*)' pot0 ntail ',pot0,ntail

      elseif(p(1).eq.'RANK') then
c input potential
        call findbegn(3)
        read (3,*) (pott(i),i=1,nx)
        write (*,*) ' read potential ',nx
c we are finished with the dm file
        go to 2
 
      endif
      go to 1
2     continue
        vn=.5*rho*sang(ndim)
        vtaila=vn*cutr**ndim*pot0/float(ndim)
        do i=1,ntail
           if(ndim+expon(i).ge.0.)stop
           vtaila=vtaila
     +      -vn*cexpon(i)*cutr**(ndim+expon(i))/(ndim+expon(i))
        enddo
c now integrate the potential
      vsr=0.
      vtail=0.
      verror=0.

      do i=1,iint
      vol=vn*dgofr*rv(i)**(ndim-1)
      if(rv(i).lt.cutr) then
       call interp(rv(i),ix,a1,a2,a3,a4)
       v=a1*pott(ix-1)+a2*pott(ix)+a3*pott(ix+1)+a4*pott(ix+2)
       vsr=vsr+vol*grfit(i)*v
       vtail=vtail+vol*pot0
       verror=verror+vol*pot0*(grfit(i)-1.)
      else
       v=0.
       do j=1,ntail
       v=v+cexpon(j)*rv(i)**expon(j)
       enddo

       vtail=vtail+vol*v
       verror=verror+vol*v*(grfit(i)-1.)
      endif
      enddo

      write (*,*)' short ranged potential ',vsr
      write (*,*)' vtail=',vtaila ,' vtail +vsr ',vtaila+vsr
      write (*,*)' error ',verror,' exact=', vsr+vtaila+verror

c       write (*,*)' analytic vtail=',vtaila,' diff= ', vtail-vtaila
        go to 99

      endif
c writeout s(k) 

      data dkv/.1/
      do k=1,nkv
      rkv(k)=dkv*(k-1)
      sofk(k)=0.
         do i=1,iint
         rr=rv(i)
        if(rkv(k).gt.0) then
         sofk(k)=sofk(k)+rr*(grfit(i)-1.)*sin(rkv(k)*rr)
        else
         sofk(k)=sofk(k)+rr**2*(grfit(i)-1.)
        endif
         enddo
        if(rkv(k).gt.0) then
         sofk(k)=1.+pi*4*rho*dgofr*sofk(k)/rkv(k)
        else
         sofk(k)=1.+pi*4*rho*dgofr*sofk(k)
        endif
      write (9,100) rkv(k),sofk(k), 0.
100   format(4f8.3)
      enddo

      inquire(file=filen(1:ln)//'.sk',exist=ifex)
      if(ifex.ne.0) then

      open(24,file=filen(1:ln)//'.sk',status='old',form='formatted')
      idim(1)=-nkv
      idim(2)=1
      idim(3)=1
      idim(4)=2
      call checkrnk(24,4,idim)

500    if(ipickoff(24,p,n,mnprm).ne.0.or.n.le.0) then
        write (*,*)' data file empty ',n
        stop
      endif
      if(p(1).eq.'GRID'.and.p(3).eq.'DISCRETE')then
      read (24,*) (rkv(l),l=1,idim(1))
      go to 501
      endif
      go to 500
501      call findbegn(24)

      read (24,*) (sofk(k),k=1,idim(1))
      read (24,*) (serror(k),k=1,idim(1))
      do k=1,idim(1)
      write (9,100) rkv(k),sofk(k),serror(k)
      enddo
      endif

      end

      subroutine fitg(g,dr,n1,n2,n3,eg)
      implicit real*8 (a-h,o-z)
      real*8 g(n3),eg(n2),ap(4),gr(4),h(25),w(25),am(4)
      common/cfit/r0t,drt,vgt(6000),gt(6000),b(4)
      common/cfit2/ngt
      external chisq

      nr=n2+1
c g(r) is fit from n1 up to n2
c we will replace g(r) by fit from n2+1 to n3
      ngt=n2-n1+1
      drt=dr
      r0t=dr*(n1-.5)
      do 1 i=1,ngt
      gt(i)=g(i+n1-1)-1.
      vgt(i)=1.
      if(eg(i+n1-1).gt.0.)vgt(i)=1./eg(i+n1-1)**2
1     continue
c now search for a good starting point
      chimin=1.e20
      do 400 i1=1,10
      am(1)=.4+.05*i1
      do 400 i2=1,10
      am(2)=1.1+.12*i2
      call chisq(np,am,chi)
      if(chi.gt.chimin) go to 401
      chimin=chi
      do 402 i=1,np
402   ap(i)=am(i)
401   continue
400   continue
      data np,eps,hh,ns,m,ip,dfn/2,1.e-5,1.e-5,300,1,301,-.9/
      do 5 i=1,np
5      am(i)=abs(ap(i))
      call va10a(chisq,np,ap,chi,gr,h,w,dfn,am,hh,eps,m,ns,ip,ie)
      call chisq(np,ap,chi)
      write (*,6) n1,n2,n3,chi,ap(1),ap(2)
6     format(' n1 n2 n3 ',3i6,'chi ap',3e13.5)
      do 3 i=n2+1,n3
      r=dr*(i-.5)
      call gfit(ap,r,w)
3     g(i)=1.+b(1)*w(1)+b(2)*w(2)
      return
      end

      subroutine chisq(np,a,chi)
      implicit real*8 (a-h,o-z)
      real*8 a(np),sa(4,4),sc(4),e(4)
      common/cfit/r0t,drt,vgt(6000),gt(6000),b(4)
      common/cfit2/ngt
c rot is r at first fitted value of g, drt is displacement
c ngt are number of g values; gt and vgt are g and weight
      chi=0.
      do 5 l=1,np
      sc(l)=0.
      do 5 k=1,np
5     sa(k,l)=0.
      r=r0t-drt
      do 1 i=1,ngt
      r=r+drt
      call gfit(a,r,e)
      do 11 l=1,np
      sc(l)=sc(l)+vgt(i)*gt(i)*e(l)
      do 11 k=1,np
11    sa(k,l)=sa(k,l)+vgt(i)*e(l)*e(k)
1     chi=chi+vgt(i)*gt(i)**2
3      det=sa(1,1)*sa(2,2)-sa(1,2)**2
      if(det.eq.0.) return
      b(1)=(sc(1)*sa(2,2)-sc(2)*sa(1,2))/det
      b(2)=(sa(1,1)*sc(2)-sa(1,2)*sc(1))/det
      do 30 l=1,np
30    chi=chi-b(l)*sc(l)
      return
      end

      subroutine gfit(a,r,e)
      real*8  a(4),e(2),r
      complex*8 a1,a2,a3
      a1=cmplx(-a(1)*a(1),a(2))
      a3=r*a1
      a2=cexp(a3)/r
      e(1)=real(a2)
      e(2)=-aimag(a2)
      return
      end
