      program  bayes
c perform Bayesian analysis of imaginary time correlation functions
c D. Ceperley, June 1994
      include 'mach.p'
       parameter (mne=30,mstates=1,mtimes=20,
     +,msq=1,ms1=2
     +,mvl=mtimes,mdata=mtimes,nprior=1,nh=400,mnh=6)

c ne/mne = total number of energy values
c
c nproj = 0 for e(-tau H) and 1 for (1+tau H)^-1
c tau etrial are defined above
c nskip and ntimes describe the times that h is written out
c nderv is the number of derivatives written out
c nstates/mstates is the total number of excited states
c hmc is the MC computed correlation functions
c nsig are the number of significant elements after the svd on covar
c u is the significant directions of data
c
c e are the fitted energy levels, ne are the number of them
c ndata/mdata = nderv*nstates**2*ntimes
      dimension delnewe(mdata),dele(mne,mdata),delta(mdata)
     +,step(ms1,mne),ynew(mdata),y(mne,mdata)
     +,nacc(ms1,mne),ntac(ms1,mne),av(ms1,mne),avsq(ms1,mne)
     +,dnew(ms1),s(mvl,mne),snew(mvl)
     +,hmc(mdata),u(mdata,mdata),pot0(mne)
     +,d(ms1,mne),xx(mdata),yy(mne,mdata),dna(mne)
     +,iseed(2),histo(nh,mnh),elow(mnh),dtbl(mnh)
     +,dhisto(nh,mnh),emax(mnh),emin(mnh)
       iseed(1)=44
       iseed(2)=66
c fudge factor of energy
       eoff=.5
c reasonable spreads in alpha
       alpha0=.0000001
       alpha1=10000.
       call iranset(iseed)

c read mc data
       call readdata(nderv,ntimes,nstates,tau,etrial,nskip,hmc
     + ,mdata,ndata,nproj)

      read (3,*) nsig,n
      write (*,*) ' number of data points ',nsig,n
      do 750 i=1,nsig  
750   read (3,751) (u(k,i),k=1,n) 
      nsites=20
      read (3,*) (pot0(i),i=1,nsites)
751   format(5e14.7) 
      do 10 il=1,nsig
      xx(il)=0.
      do 10 j=1,n
10    xx(il)=xx(il)+hmc(j)*u(j,il)
      read (3,*) ne
      write (*,*) ' number of energies ',ne
      if(ne.ge.mne)stop
      do 900 i=1,ne
      read (3,19) d(nstates+1,i),(d(is,i),is=1,nstates)
19    format(5e12.5)
c     write (6,19) (d(is,i),is=1,nstates+1)
900   continue


      nhisto=nstates+1
      nfsm=nstates+1
      ns1=nstates+1
      ns2=(nstates*(nstates+1))/2
      ntd=nderv*ntimes
c make sure states don't boil off
      d(ns1,ne+1)=2*d(ns1,ne)

      write (*,*)' input nsteps,nbbe  nblocks  cnvary'
      read (*,*) nsteps,nbbe,nblocks
     +,nvary
c     nvary=ne
      write (*,*)' input old parameters? yes =1'
      read (*,*) ifold
      if(ifold.eq.1) then
        do 965 ie=1,ne
        read(4,*) (d(is,ie),is=1,ns1)
965     read(4,*) (step(is,ie),is=1,ns1)
        read (4,*) alpha
        read (4,*) nhisto,(emax(i),emin(i),i=1,nhisto)
        do 966 i=1,nhisto
        dtbl(i)=(nh-1)/(3.*(emax(i)-emin(i)))
966     elow(i)=2*emin(i)-emax(i)

      else
         do 955 ie=1,ne
         do 955 is=1,ns1
955      step(is,ie)=.005 
         alpha=10.
         do 956 i=1,nhisto
         dtbl(i)=1./nh
         elow(i)=d(ns1,i)-.5
         emax(i)=d(ns1,i)
956      emin(i)=d(ns1,i)
         emax(nhisto)=d(ns1,ne+1)
      endif


      avchi=0.
      avalpha=0.
c  initial step size
      do 920 ie=1,ne
      dna(ie)=0.
      do 920 is=1,ns1
      ntac(is,ie)=0
      av(is,ie)=0.
920   avsq(is,ie)=0.
      chisq=0.

      do 300 iblk=-nbbe+1,nblocks

      chibl=0.
      do 301 ie=1,ne
      do 301 is=1,ns1
301   nacc(is,ie)=0

      do 112 isteps=1,nsteps

      chiold=chisq
      chisq=0.
      do 4 iep=1,ne
4     call pfunc(nproj,tau,d(nstates+1,iep),nskip,ntimes,s(iep))
      do 2 il=1,nsig
      delta(il)=-xx(il)
      do 1 iep=1,ne
      call findy(s(1,iep),y(iep,il),il,ntd,nstates,u,mdata)
      dele(iep,il)=trace(y(iep,il),d(1,iep),nstates)
1     delta(il)=delta(il)+dele(iep,il)
2     chisq=chisq+delta(il)**2
      if(abs(chisq-chiold).gt..001) then
       write (*,*) isteps,' chi**2 ',chisq,chiold
      endif

      priortot=0.
      do 110 ie=1,ne

      dnorm=0
      do 101 is=1,nstates
101   dnorm=dnorm+d(is,ie)**2
      if(iblk.gt.0)dna(ie)=dna(ie)+dnorm

c put energies in histogram
      ia=min(nhisto,ie)
      emax(ia)=max(emax(ia),d(ns1,ie))
      emin(ia)=min(emin(ia),d(ns1,ie))
      l=max(0.,min(nh-1.,dtbl(ia)*(d(ns1,ie)-elow(ia)) ))+1.
      dhisto(l,ia)=dhisto(l,ia)+dnorm
      histo(l,ia)=histo(l,ia)+1.

      pmult=alpha*(d(ns1,ie)+eoff)**nprior
      if(ie.lt.nfsm)pmult=0.

c subtract out Y component
       
      do 104 il=1,nsig
104   delta(il)=delta(il)-dele(ie,il)

      nsp=ns1
      if(ie.gt.nvary)nsp=nstates
      do 100 is=1,nsp
      enew=d(is,ie)+step(is,ie)*(ranf()-.5)

      if(is.eq.ns1) then
c this is really an energy move
c keep states ordered in energy and repelling
          rnew=1.
          rold=1.
          do 630 je=1,ne
          if(je.ne.ie) then
            rnew=rnew*(enew-d(ns1,je))
            rold=rold*(d(ns1,ie)-d(ns1,je))
          endif
630      continue
         if(ie.gt.1.and.enew.le.d(ns1,ie-1))rnew=0.
         if(enew.ge.d(ns1,ie+1))rnew=0.
         ratio=abs(rnew/rold)
         priornew=dnorm*alpha*(enew+eoff)**nprior
         if(ie.lt.nfsm) priornew=0.
         priorold=dnorm*pmult
         dprior=priornew-priorold

      call pfunc(nproj,tau,enew,nskip,ntimes,snew)
      do 52 il=1,nsig
      call findy(snew,ynew(1,il),il,ntd,nstates,u,mdata)
52    delnewe(il)=trace(ynew(1,il),d(1,ie),nstates)

      else
      ratio=1.
c this is a wavefunction move
      do 54 ii=1,nstates
54    dnew(ii)=d(ii,ie)
      dnew(is)=enew
      do 53 il=1,nsig
53    delnewe(il)=trace(y(1,ie,il),dnew,nstates)

      deldnorm=-d(is,ie)**2+enew**2
      dprior=pmult*deldnorm
      endif

      chinew=0.
      do 50 il=1,nsig
50    chinew=chinew+ (delta(il)+delnewe(il))**2

c     pacc=min(ratio*exp(-.5*(chinew-chisq+dprior)),1.)
      pacc=min(exp(-.5*(chinew-chisq)),1.)
      if(iblk.gt.0)then
      prej=1.-pacc
      av(is,ie)=av(is,ie)+    pacc*enew    +prej*d(is,ie)
      avsq(is,ie)=avsq(is,ie)+pacc*enew**2 +prej*d(is,ie)**2
      chibl=chibl            +pacc*chinew + prej*chisq
      endif
c accept or rject
      if(pacc.gt.ranf()) then
      chisq=chinew
      dnorm=dnorm+deldnorm

        if(is.eq.ns1)then
        do 65 ii=1,ns2
        do 65 il=1,nsig
65      yy(ii,ie,il)=ynew(ii,il)
        priorold=priornew
        endif

      do 67 il=1,nsig
67    dele(ie,il)=delnewe(il)
      nacc(is,ie)=nacc(is,ie)+1

      d(is,ie)=enew
      endif
100   continue
c restore delta
      do 105 il=1,nsig
105   delta(il)=delta(il)+dele(ie,il)
      priortot=priortot+priorold
110   continue


c now readjust alpha using priortot
      alpha=samx(priortot/alpha,alpha0,alpha1)
      if(iblk.gt.0) avalpha=avalpha+alpha
112   continue

c print out acceptance ratios, energies and error bars.
      n=iblk*nsteps
      do 200 ie=1,ne
      if(iblk.gt.0)dnorm=dna(ie)/n
      nsp=ns1
      if(ie.gt.nvary)nsp=nstates
      do 200 is=1,nsp
c adjust the step size
      ar=float(nacc(is,ie))/nsteps
      ntac(is,ie)=ntac(is,ie)+nacc(is,ie)
      if(ar.gt..8) step(is,ie)=1.5*step(is,ie)
      if(ar.lt..2) step(is,ie)=.7*step(is,ie)
      if(iblk.gt.0) then
      dbar=av(is,ie)/n
      err=sqrt(abs(avsq(is,ie)/n-dbar**2))
      if(is.eq.ns1)then 
       dbar=dbar+etrial
      write (*,201) is,ie,ntac(is,ie),step(is,ie),ar,dbar,err,dnorm
201   format(2i2,i7,e10.3,f6.3,3e14.6)
      endif
      endif
200   continue
      if(iblk.gt.0) then
      chibl=chibl/(nsteps*ne*ns1)
      avchi=avchi+chibl
      write (*,*)' average chisq ',avchi/iblk
      write (*,*)' averages alpha ',avalpha/(iblk*nsteps)
      endif
300   continue
        rewind 4
        do 960 ie=1,ne
        write(4,44) (d(is,ie),is=1,ns1)
960     write(4,44) (step(is,ie),is=1,ns1)
        write (4,44) alpha
        write (4,*) nhisto,(emax(i),emin(i),i=1,nhisto)
44      format(5e12.5)
c put out condensed table of histograms
      do 1020 ie=1,nhisto
      do 1021 l=1,nh
1021  if(histo(l,ie).gt.0) go to 1022
1022  nfirst=l
      do 1023 l=nh,1,-1
1023  if(histo(l,ie).gt.0) go to 1024
1024  nlast=l
      e0=elow(ie)+(nfirst-.5)/dtbl(ie)+etrial
      e1=elow(ie)+(nlast-.5)/dtbl(ie)+etrial

      if(ie.le.nstates) then
      write (2,*) 'RANK 1 ',nlast-nfirst+1
      write (2,1026)e0,e1
1026  format('GRID 1 LINEAR ',2f12.5)
      write (2,*)' BEGIN DATA '
      write (2,1025) (histo(l,ie),l=nfirst,nlast)
1025  format(10f10.0)
      else
      write (2,*) 'RANK 1 ',nlast-nfirst+1
      write (2,1026)max(e0-etrial,.01),e1-etrial
      write (2,*)' BEGIN DATA '
      write (2,1027) (dhisto(l,ie),l=nfirst,nlast)
1027  format(5e11.4)
      endif

1020  continue
      stop
      end
   
      function trace(y,d,ns)
      include 'mach.p'
      dimension y(2),d(ns)
      j=0
      trace=0.
      do 1 ia=1,ns
      do 1 ib=1,ia
      j=j+1
      x=d(ia)*d(ib)*y(j)
      trace=trace+x
1     continue
      return
      end

      subroutine findy(s,y,il,ntd,nstates,u,mdata)
      include 'mach.p'
      dimension y(2),s(ntd),u(mdata,mdata)
      j=0
      iab=0
      do 10 ia=1,nstates
      do 10 ib=1,ia
      iab=iab+1
      y(iab)=0.
      do 10 k=1,ntd
      j=j+1
      y(iab)=y(iab)+u(j,il)*s(k)
10    continue
      return
      end

      subroutine readdata(nderv,ntimes,nstates,tau,etrial,nskip,hmc
     + , mdata,ndata,nproj)
      include 'mach.p'
      character name*14,namet*14,title*60
      dimension hmc(mdata)
      logical ifex
41    write (*,*) ' input run id?'
      read (*,287) name
287   format(a14)
        ln=index(name,' ')-1
      namet=name(1:ln)//'.me'
      lnt=ln+3
c does this file exist?
        inquire(file=namet(1:lnt),exist=ifex)
        if(ifex) go to 40
         write (*,*)' file does not exist '
         go to 41
40     open(3,file=name(1:ln)//'.me')
      open(4,file=name(1:ln)//'.by')
      open(2,file=name(1:ln)//'.hs')
      write (*,*) ' file opened'

      read (3,*) nderv,nstates,ntimes,nskip,nproj
      write (*,91)nderv,nstates,ntimes,nskip,nproj
      if(nproj.gt.3.or.nproj.lt.1)stop

      read (3,*) tau,etrial
      write (*,*) tau,etrial
      ndata=(nderv*ntimes*nstates*(nstates+1))/2
      write (*,*)' total number of data elements ',ndata
      if(ndata.gt.mdata) then
        write (*,*)' not enough space for data ', ndata,mdata
        stop
      endif
      read (3,*) (hmc(i),i=1,ndata)
91    format(6i10)

      ntd=ntimes*nderv
      ndata=(ntd*nstates*(nstates+1))/2

      return
      end

      subroutine pfunc(nproj,tau,e,nskip,ntimes,s)
      include 'mach.p'
      dimension s(ntimes)

      x=tau*e
      if(nproj.eq.1) then
         xi=1./(1.+x)
         f=xi**nskip
      elseif(nproj.eq.2) then
         f=exp(-nskip*x)
      elseif(nproj.eq.3) then
         f=(1-x)**nskip
      endif

c fk=f**k
      fk=1.
      do 10 k=0,ntimes-1
      s(k+1)=fk
      fk=fk*f
10    continue

      return
      end

      function samx(s,x0,x1)
      include 'mach.p'
c returns a random number distributed according to e(-x)/x in (x0,x1)
      call eint(s*x0,e0,de0)
      call eint(s*x1,e1,de1)
      c=ranf()*(e0-e1)+e1
      xdn=x0
      xup=x1
      samx=.5*(x0+x1)
1     call eint(s*samx,e,de)
      dx=-(e-c)/(s*de)
      if(e.gt.c) then
          xdn=samx
          dx=min(dx,.8*(xup-xdn))
      else
        xup=samx
        dx=max(dx,-.8*(xup-xdn))
      endif
       samx=samx+dx
      if(abs(dx).gt.1.e-5*samx) go to 1
      return
      end

      subroutine eint(x,e1,de1)
      include 'mach.p'
      de1=-exp(-x)/x
      if(x.lt.1) then
         e1=-log(x)-.57721566+x*(.99999193+x*(-.24991055
     + +x*(.05519968+x*(-.00976004+x*.00107857) ) ) )
      else
        e1=-de1*(.250621+x*(2.334733+x))/(1.681534+x*(3.330657+x))
      endif
      return
      end

      function ranf()
      include 'mach.p'
      real*8 ran
      integer*4 M0, M1, M2, M3, Expo, S0, S1, S2, S3, seedhi, seedlo
      integer*4 a, b, c, d, iran(2)
      equivalence(iran, ran)
c     data seedlo,seedhi/16 651 885,2 868 876/
      common/cseed/seedhi,seedlo
      data M0,M1,M2,M3/0373,3707,1442,0647/
c     save seedlo,seedhi

c Split the 48 bit seed into four 12 bit chunks
      S3 = rshift(seedhi,12)
      S2 = and(seedhi,4095)
      S1 = rshift(seedlo,12)
      S0 = and(seedlo,4095)

c IEEE bias is 1023.  Exponent occupies bits 62-52, or 30-20 of the upper word.
      Expo = lshift(1023,20)

c multiply the 12 bit numbers into partial products, discarding terms which
c  are larger than 2^48-1, the max 48 bit integer on the cray.
      a = S0*M0
      b = S1*M0 + S0*M1
      c = S2*M0 + S1*M1 + S0*M2
      d = S3*M0 + S2*M1 + S1*M2 + S0*M3
 
c assemble the four 26-bit results into two words
      seedlo = a + lshift(and(b,4095),12)
      seedhi = rshift(seedlo,24) + rshift(b,12) + c + lshift(d,12)
c only want 24 bits in each word (together these make up the 48 bit integer)
      seedlo = and(seedlo,16 777 215)
      seedhi = and(seedhi,16 777 215)

c IEEE mantissa is 52 bits.  We have only 48 bits, so we shift our result 4
c   bits left.  32-(24+4) = 4 bits are still blank in the lower word, so we
c   grab the low 4 bits of seedhi to fill these.  Word is stored with most
c   significant bit at lowest address, so iran(2) is the low word of ran.
      iran(2) = or(lshift(seedlo,4),lshift(seedhi,28))
c place the remaining (24-4)=20 bits of seedhi in bits 20-0 of ran.
c Expo occupies bits 30-20.  Bit 31 (sign) is always zero.
      iran(1) = or(Expo,rshift(seedhi,4))

c The cray's floating point representation is 2^(exp-bias)*0.mantissa.
c The IEEE floating point representation is 2^(exp-bias)*1.mantissa.
c This step subtracts off this extra 1.0, so that we get the same floating pointc    number as on the cray.
      ranf=ran-1.0

      return
      end

      subroutine iranset(i)
      include 'mach.p'
      integer*4 seedlo, seedhi, i(2)
      common/cseed/seedhi,seedlo
c copy the value of x into equivalenced location
      if ((i(1).eq.0).and.(i(2).eq.0)) then
         seedlo = 16 651 885
         seedhi =  2 868 876
      else
         seedlo = or(and(i(2),16 777 215),1)
         seedhi =    and(i(1),16 777 215)
      endif
      write (6,1) i(1),i(2)
1     format(' random number seed set to ',2i10)
      return
      end
