c just to make some graphs 9/93
      program squarer
      implicit none
c version of 4/29/93 by D. Ceperley NCSA-UIUC
c  this program calculates the two particle density matrix 
c using singular value decomposition and analytic time derivatives
c reorder fitting terms as s2, z2; s4,s2.z2,z4; etc.
c put in reduction in maximum value of l.
c changes in output files from old (livermore ) code
c  grid is now more general, arbitary dimension:
c  the chisq for the fits are written at the end
c the format of the output file is a little different:  format(9e17.10)
c the 3 and higher order fits are ordered in powers of z**2 (not randomly)
c the potential is read in as a table

      integer mx,ldim,mtrm,mx2,mmt,mdata,mn,mnsq,nkv
      real*8 umax
      parameter (mx=150,ldim=64,mtrm=10,mx2=mx*(mx+1)/2)
      parameter (mmt=4,mdata=10000,mn=10,mnsq=5,nkv=9000,umax=3000000.)

c ldim are the maximum number of partial waves
c nmt is the order of the polynomial fit .le. mmt
c nx.le.mx are the number of radial grid points
c mdata is space for the polynomial fit
c ntemp.le.mnsq is number of density matrix files output
c nkv are total number of k-values in fourier transforms for sampling tables
c mn is the maximum number of parameters in an input line
c umax=largest argument of exponential function

      real*8 uold(0:ldim,mx2,2),unew(0:ldim,mx2,2),pott(mx)
     +,vint(mx),di(0:ldim,2),dj(0:ldim,2),rv(mx),gdx(mx,2),xint(8)
     +,weight(8),u2(2),t(mtrm),ufit(mtrm),cl(0:ldim)
     +,f(0:ldim,2),uend(2),chis(mx,mmt,2,mnsq),drt(mx),ua(2)
     +,udata(mdata,mtrm),b(mdata,2),v(mtrm,mtrm),w(mtrm)
     +,utemp(mdata,mtrm),di0(0:ldim,2),dj0(0:ldim,2),rho0(0:ldim,2)
     +,fitdm(mx,mtrm,mmt,mnsq,2),gfun(mx),rkv(nkv),samtab(mx,2,mnsq,2)
     +,gk(nkv)
     +,dmplot(mx,6),taus,alp,daws
      integer lpos(mx)
      integer nkt(mmt),ipoint,ln,ntypes,i,ngrid,n,nx,ntemp,ndim,nmt,luse
      integer nsquare,l,k,ntrm,itemp,ii,j,ipickoff,intread,isym,mdatam
      integer isq,ind,jl,lul,nint,nk,is,kp,indl,id,its,lmax,nc,ndata
      integer i1,ix,ix1,ix2,ix3,ix4,ic,k1,ktrm1,ktrm,ll,npv,ns,it,nneg
      real*8 ehbs2m,tlow,tau,tauhigh,taulow,zero,pi,cutl,rvmax,rvmin,dr
      real*8 dri,s,uu,rlread,etau,width,cut,delr,rbar,rk,wt,temp,rinv,up
      real*8 rr2,coefr,cp,s1,s2,s3,s4,e0,eul,c,rhol0,rhol,drhol0,gs
      real*8 corr,cutfit,err1,err2,sc,thetam,cmin,dc,dt,p11,r1,r2,z2,zn
      real*8 a1,a2,a3,a4,emax,vstar,ustar,cns,cll,wtinv,pf,rocut,rozero
      real*8 rozerod,ro,u,ud,wc,swc,wmax,thresh,chisq,sum,ftnorm,wdt,dk
      real*8 wtt,gwt,gfun0,delta,f1,f2,sdot,sang
      common /ipp/ipoint(628)
      
      character fname*14,p(mn)*28,grid(mn)*28

      data pi/3.14159265358979/
c these hermite coefs are from a-s table 25.10
      data nk/8/
      data xint/.27348 10461 3815,.82295 14491 4466,1.38025 85391 9888
     +,1.95178 79909 1625, 2.54620 21578 4748,3.17699 91619 7996
     +,3.86944 79048 6012,4.68873 89393 0582/
      data weight/.54737 52050 378,.55244 19573 675,.56321 78290 882
     +,.58124 72754 009,.60973 69582 560,.65575 56728 761
     +,.73824 56222 777, .93687 44928 841/

      write (*,*)' input prefix of files '
      read (*,99) fname
99    format(a14)
      ln=index(fname,' ')-1
      open (3,file=fname(1:ln)//'.dm',status='unknown')
c*** read input file dm

      ntypes=0
      ehbs2m=0.
      tlow=0.

c input hbar energy units and length units
1     if(ipickoff(3,p,n,mn).eq.1)stop

      if(p(1).eq.'TYPE') then
c input type of particles and lambda
        ntypes=ntypes+1
        ehbs2m=ehbs2m+rlread(p(3))

      elseif(p(1).eq.'GRID') then
c save away grid
        do i=1,n
          grid(i)=p(i)
        enddo
        ngrid=n
c input grid parameters
        nx=intread(p(2))
        call setgrid(mx,nx,rv,grid(3))
        do i=2,nx-1
          drt(i)=.5*abs(rv(i+1)-rv(i-1))
        enddo
        drt(1)=abs(rv(2)-rv(1))
        drt(nx)=abs(rv(nx)-rv(nx-1))
  

      elseif(p(1).eq.'SQUARER') then
c now input parameters having to do with squaring
c tlow is the  lowest temperature calculated(true temperature)
        tlow=rlread(p(2))
        if(tlow.le.0.) stop
c  ntemp is number of temperatures output.
        ntemp=intread(p(3))
        if(ntemp.lt.1.or.ntemp.gt.mnsq)stop
c spatial dimensionality (1,2,3)
        ndim=intread(p(4))
        write (*,*) 'dimensionality=',ndim
c nmt is the number of approximations generated (1=diagonal etc.)
        nmt=intread(p(5))
        if(nmt.gt.mmt.or.nmt.lt.1)stop
c number of partial waves
        luse=intread(p(6))
c number of squarings from lowest temperature
        nsquare=intread(p(7))
c nsquare .le.0 is flag for primitive approximation
        if(nsquare.le.0) then
            write (*,*) 'primitive approximation'
            nmt=1
        else
           if(nsquare.lt.ntemp) then
            write (*,*) 'nsquare.lt.ntemp'
            stop
           endif
           tau=1./(2**nsquare*tlow)
        endif
        write (*,*) 'lowest temp=',tlow,' no. squarings=',nsquare
     +    ,' no. temps=',ntemp,' no. fits=',nmt

c initial tau
        tauhigh=1./tlow
        taulow=tauhigh/2**(ntemp-1)
        
 
        if(ndim.eq.1) then
         zero=0.
         luse=0
         cl(0)=1.
        elseif(ndim.eq.2) then
         zero=0.
         cl(0)=.5/pi
         do l=1,ldim
           cl(l)=1./pi
         enddo
        elseif(ndim.eq.3) then
         zero=0.
         do l=0,ldim
           cl(l)=(2*l+1)/(4.*pi)
         enddo
        else  
          write (*,*) 'error in ndim'
          stop
        endif
        if(luse.gt.ldim) then
         write (*,*)luse.gt.ldim
         stop
        endif

      elseif(p(1).eq.'RANK') then
c check to see if all other data is present before continuing
        if(nx.eq.0)stop
        if(ehbs2m.le.0)stop
        if(ntypes.ne.2)stop
        if(tlow.le.0.) stop
c input potential
        call findbegn(3)
        read (3,*) (pott(i),i=1,nx)
        go to 2

      endif
      go to 1
2     continue
c
c****end of input section***********************************
c
      cutl=-log(1.e-10)

c these are the appended max and min of our grid.
      rvmax=2*rv(nx)-rv(nx-2)
      rvmin=max(2*rv(1)-rv(3),zero)

c set up pointers to store 1/2 of matrix
      ipoint(1)=0
      do 33 i=2,nx
33    ipoint(i)=ipoint(i-1)+i-1
c pointers for fitting expansion
      nkt(1)=1
      do  k=2,nmt
       if(ndim.eq.1) then
         nkt(k)=k-1
       else
         nkt(k)=k*(k+1)/2-1
       endif
      enddo
      ntrm=nkt(nmt)
      if(ntrm.gt.mtrm) then
       write (*,*) 'ntrm.gt.mtrm '
       stop
      end if

c the following if has an else at line 203 and ends to line 633
c     if(nsquare.le.0) then
c primitive approximation

c find laplacian of potential
       do i=2,nx-1
        dr=.5*(rv(i+1)-rv(i-1))
        dri=1./dr
        gfun(i)=dri**2*(pott(i+1)+pott(i-1)-2*pott(i))
     +          +(ndim-1)*(pott(i+1)-pott(i-1))/(2*dr*rv(i))
        dmplot(i,3)=(pott(i+1)-pott(i-1))/(rv(i+1)-rv(i-1))
       enddo
       gfun(1)=gfun(2)
       gfun(nx)=0.
       dmplot(1,3)=dmplot(2,3)
       dmplot(nx,3)=0.

       do 4000 itemp=1,ntemp
        taus=taulow*2.**(itemp-1)
        s=taus*ehbs2m/6.

        do 4000 i=1,nx
        dmplot(i,1)=taus*pott(i)
        dmplot(i,2)=dmplot(i,1)+taus*s*gfun(i)
        dmplot(i,3)=dmplot(i,2)-.5*s*(taus*dmplot(i,3))**2
         fitdm(i,1,1,itemp,1)= dmplot(i,3)
4000   fitdm(i,1,1,itemp,2)=2*s*gfun(i)-1.5*s*tau*dmplot(i,3)**2

c     else


c vint(i) will be the integral from rv(mx) to rv(i) of v(r)
       vint(nx)=0.
       do ii=nx-1,1,-1
        vint(ii)=vint(ii+1)+.5*(rv(ii+1)-rv(ii))*(pott(ii+1)+pott(ii))
       enddo
 
c initialize uold; first the diagonal
       do 8 i=1,nx
        do 8 l=0,luse
         uold(l,isym(i,i),1)=min(tau*pott(i),umax)
8      uold(l,isym(i,i),2)=pott(i)
 
       do 6 i=1,nx
        do 6 j=1,i-1
c initial density matrix is the integral from ri to rj of potential
         uu=-(vint(i)-vint(j))/(rv(i)-rv(j))
         do 6 l=0,luse
          uold(l,isym(i,j),1)=min(uu*tau ,umax)
6      uold(l,isym(i,j),2)=uu  
 
c *********begin matrix squaring master loop (ends at line 631)************
c
       mdatam=0
       do 100 isq=1,nsquare
        etau=tau*ehbs2m
        width=sqrt(2*etau)
c integrate to 10^-20 of peak value
        cut=sqrt(-2*etau*log(1.e-20))
c for simpsom's integration
        delr=.1*width

c loop over all i and j values
        do 110 i=1,nx
         do 110 j=i,1,-1
          ind=isym(i,j)
          if(abs(rv(j)-rv(i)).lt.cut) then
           jl=j
           lul=min(luse,2+int(sqrt(cutl*rv(i)*rv(j)/(2*etau))) ) 

           rbar=.5*(rv(i)+rv(j))
           do 120 l=0,lul
            unew(l,ind,1)=0.
120        unew(l,ind,2)=0.

           if(rbar-width*xint(nk).lt.zero) then
c do simpsons rule if region of integration includes origin
            rk=0.
            nint=int((rbar+width*xint(nk))/delr)
           else
            nint=2*nk
           endif

c now integrate over r
           do 132 k=1,nint

            if(rbar-width*xint(nk).lt.zero) then
c note the origin is excluded since rhol vanishes there.
             rk=rk+delr
             wt=.666666666666*delr
             if(mod(k,2).eq.1)wt=wt*2
            else
             kp=(k-1)/2+1
             is=mod(k,2)
             rk=rbar+width*(2*is-1)*xint(kp)
             wt=weight(kp)*width
            endif
            call denmat(rk,i,rv(i),uold,ldim,nx,di,etau,ehbs2m,mx2,di0
     +              ,lul,ndim)
            call denmat(rk,j,rv(j),uold,ldim,nx,dj,etau,ehbs2m,mx2,dj0
     +              ,lul,ndim)
            do 130 l=0,lul
              unew(l,ind,1)=unew(l,ind,1)+wt*di(l,1)*dj(l,1)
130         unew(l,ind,2)=unew(l,ind,2)+.5*wt*
     +                            (di(l,2)*dj(l,1)+di(l,1)*dj(l,2))
132        continue
           call fdenmt(rv(i),rv(j),rho0,2*etau,ldim,ehbs2m,lul,ndim)

           do l=0,lul
            temp=-log(unew(l,ind,1)/rho0(l,1))
            unew(l,ind,2)=-unew(l,ind,2)/unew(l,ind,1)+rho0(l,2)
            unew(l,ind,1)=temp
           enddo

c extrapolate in l
           do l=lul+1,luse
            unew(l,ind,1)=2*unew(l-1,ind,1)-unew(l-2,ind,1)
            unew(l,ind,2)=2*unew(l-1,ind,2)-unew(l-2,ind,2)
           enddo

          else
c go outwards from the diagonal using classical value instead
           rinv=1./(rv(j)-rv(i))
           up=-rinv*(vint(j)-vint(jl))
           uu=2*tau*up
           rr2=rinv*(rv(jl)-rv(i))
           indl=isym(i,jl)
           do l=0,luse
            unew(l,ind,1)=uu+rr2*unew(l,indl,1)
            unew(l,ind,2)=up+rr2*unew(l,indl,2)
           enddo
          endif

110     continue

c copy new values of density matrix into old array
        do 199 id=1,2
         do 199 i=1,nx
          do 199 j=1,i
           ind=isym(i,j)
           do 199 l=0,luse
199     uold(l,ind,id)=min(unew(l,ind,id),umax)

c double tau
        tau=2*tau
        etau=tau*ehbs2m
        write (*,*) ' finished tau= ', tau 
c now do fits to polynomials
        its=isq-nsquare+ntemp

c the next if ends to line 628
        if(its.gt.0) then

c now compute diagonal elements
         lmax=1
         do 595 i=1,nx
 
          coefr=sqrt(4*pi*etau)**ndim/rv(i)**(ndim-1)
          cp=.5*ndim/tau
          lul=min(luse,2+int(sqrt(cutl*rv(i)**2/etau)) ) 
          call fdenmt(rv(i),rv(i),dj,etau,ldim,ehbs2m,lul,ndim)
 
          s1=0.
          s2=1.
          s3=0.
          s4=0.
          id=isym(i,i)
          e0=uold(0,id,1)
  
          do l=0,lul
           eul=exp(-uold(l,id,1)+e0)
 
           if(s2.gt.1.e-5) then
            corr=eul*s2
            f(l,1)=s1+corr
            f(l,2)=s3-uold(l,id,2)*corr-s4*eul
           else
            lpos(i)=l-1
            go to 7229
           endif
  
           c=cl(l)*coefr
           rhol0=c*dj(l,1)
           rhol=rhol0*eul
           s1=s1+rhol
           s2=s2-rhol0
           drhol0=rhol0*(dj(l,2)+cp)
           s3=s3+drhol0*eul-uold(l,id,2)*rhol
           s4=s4+drhol0
          enddo
 
c lpos is the last value of l giving reasonable values for sum rule
          lpos(i)=lul

7229      gs=f(lpos(i),1)
          if(gs.le.0) then
           write (*,*) ' sum negative ',lpos(i),lul,rv(i),gs
           stop
          endif
          gdx(i,1)=min(umax,e0-log(gs))
          gdx(i,2)=-f(lpos(i),2)/gs
 
c convergance criterea for density matrix
          do l=0,lpos(i)-1
           if(abs(f(l,1)-gs).gt.1.e-4*gs.and.gdx(i,1).lt.7.)
     &        lmax=max(lmax,l)
          enddo

595      continue

         write (*,*) ' begin fits lmax = ',lmax

c we cut off fit at 10**-3=e**-7 of peak value
         cutfit=-4*etau*log(1.e-4)
c loop over rbar
         err1=0.
         err2=0.

         do 600 i=1,nx

          lul=lpos(i)
          e0=uold(0,isym(i,i),1)
          sc=sqrt(cutfit)
          if(sc.ge.rv(i)) then
           thetam=pi
           cmin=-1.
          else
           thetam=asin(sc/rv(i))
           cmin=cos(thetam)
          endif
c nc is the number of angular integration points
          nc=min(1.*mx2,max(1.001+30.*(1.-cmin),11.))
c this  is spacing in cos(theta) (ndim=3) or theta (ndim=2)
          dc=(1.-cmin)/(nc-1.)
          dt=thetam/(nc-1.)
          if(ndim.eq.1)nc=1
          ndata=0
c zero relevant arrays
          u2(1)=0
          u2(2)=0
          p11=0.

c compute legendre polynomials
          if(ndim.eq.3)call vlegp(unew,ldim,dc,nc,luse)
          if(ndim.eq.2)call vcos(unew,ldim,dt,nc,luse)

c now loop over r1
          do 602 i1=1,nx
           r1=rv(i1)
           r2=2.*rv(i)-r1
           z2=(r1-r2)**2
  
c consider (r1,r2) as a fitting point if it is reasonable
           if(abs(r1-r2).le.cut.and.r2.ge.rvmin.and.r2.le.rvmax) then

            if(ndim.gt.1)then
             zn=1.
             do k=2,nmt
              zn=zn*z2
              t(nkt(k))=zn
             enddo
            endif
 
            wt=(r1*r2)**(ndim-1)*drt(i1)
c now set up density matrix values at r2
            call interp(r2,ix,a1,a2,a3,a4)
            ix1=isym(ix-1,i1)
            ix2=isym(ix,i1)
            ix3=isym(ix+1,i1)
            ix4=isym(ix+2,i1)
 
            call fdenmt(r2,r1,dj,etau,ldim,ehbs2m,lul-1,ndim)
            do 604 l=0,lul
             emax=e0-a1*uold(l,ix1,1)-a2*uold(l,ix2,1)
     +                -a3*uold(l,ix3,1)-a4*uold(l,ix4,1)
             di(l,1)=exp(emax)
604         di(l,2)=a1*uold(l,ix1,2)+a2*uold(l,ix2,2)
     +               +a3*uold(l,ix3,2)+a4*uold(l,ix4,2)
            vstar=di(lul,1)
            ustar=di(lul,2)

            cns=(r1*r2)**(-.5*(ndim-1))
            do 605 l=0,lul-1
             cll=cl(l)*cns*dj(l,1)
             f(l,1)=cll*(di(l,1)-vstar)
605         f(l,2)=f(l,1)*dj(l,2)+cll*(-di(l,2)*di(l,1)+ustar*vstar)
c this is the end point value
            uend(1)=.5*(gdx(i1,1)+a1*gdx(ix-1,1)+a2*gdx(ix,1)
     +                  +a3*gdx(ix+1,1)+a4*gdx(ix+2,1)) -e0
            uend(2)=.5*(gdx(i1,2)+a1*gdx(ix-1,2)+a2*gdx(ix,2)
     +                     +a3*gdx(ix+1,2)+a4*gdx(ix+2,2))

            wtinv=.25/etau
            pf=(4*pi*etau)**(-.5*ndim)
            rocut=1.e-4*pf*exp(-uend(1) ) 
c now integrate over cos(theta)
            do 610 ic=1,nc
             c=1.-dc*(ic-1)
             if(ndim.eq.2)c=cos(dt*(ic-1))
             s2=r1*r1+r2*r2-2*r1*r2*c

             if(s2.le.cutfit) then

c define independant t variables by recursion
              t(1)=s2
              do k=2,nmt
               if(ndim.eq.1) then
                t(k)=t(k-1)*s2
               else
                do j=1,k
                 t(nkt(k)+j)=t(nkt(k)+j-k)*s2
                enddo
               endif
              enddo

              rozero=pf*exp(-wtinv*s2)
              rozerod=(-.5*ndim+wtinv*s2)/tau
              ro=rozero*vstar+sdot(lul,f(0,1),1,unew(0,ic,1),1)
 
              if(ro.gt.rocut ) then
               u=-log(ro/rozero)
               ud=(rozero*vstar*(ustar-rozerod)
     +          -sdot(lul,f(0,2),1,unew(0,ic,1),1))/ro+rozerod
               wc=wt*ro
               if(abs(c).gt..999)wc=.5*wc
               ua(1)=u-uend(1)
               ua(2)=ud-uend(2)
               if(ic.eq.1.and.i.eq.i1) then
                err1=max(err1,abs(ua(1)) )
                err2=max(err2,abs(ua(2)) )
               endif

c add to least squares arrays
               ndata=ndata+1
               if(ndata.gt.mdata) then
                write (*,*)' mdata too small '
                stop
               endif

               swc=sqrt(wc)
               do k1=1,ntrm
                udata(ndata,k1)=swc*t(k1)
               enddo
 
               p11=p11+wc
               do id=1,2
                b(ndata,id)=swc*ua(id)
                u2(id)=u2(id)+wc*ua(id)**2
               enddo

              endif
             endif
610         continue

           endif
602       continue
          mdatam=max(mdatam,ndata)
c now do least squares fit
          do 700 ktrm1=1,nmt
           ktrm=nkt(ktrm1)
           do 700 id=1,2
 
            if(ktrm1.eq.1) then

             if(p11.le.0) then
              if(id.eq.1)write (*,*) i, ' p11=0 ',rv(i)
              chis(i,1,id,its)=0.
             else
              chis(i,1,id,its)=sqrt(u2(id)/p11)
             endif
             ufit(1)=gdx(i,id)

            else

             if(id.eq.1) then
c do this once since udata is independant of id
              do 718  k1=1,ktrm
               do 718 ll=1,ndata
718           utemp(ll,k1)=udata(ll,k1)
c now set up rhs and lhs and solve linear equations
              call svdcmp(utemp,ndata,ktrm,mdata,mtrm,w,v)
              npv=0
              wmax=0.
              do 720 j=1,ktrm
720           wmax=max(w(j),wmax)
              thresh=1.e-10*wmax
              do j=1,ktrm
               if(w(j).lt.thresh) w(j)=0.
               if(w(j).ge.thresh) npv=npv+1
              enddo
c             if(npv.le.1)write(*,*)' i ktrm npv ',i,ktrm,npv
             endif
             call svbksb(utemp,w,v,ndata,ktrm,mdata,mtrm,b(1,id),ufit)
             chisq=0.
             do 722 ii=1,ndata
              sum=-b(ii,id)
              do 723 k=1,ktrm
723           sum=sum+ufit(k)*udata(ii,k)
722          chisq=chisq+sum**2
             if(p11.ne.0)then
              chis(i,ktrm1,id,its)=sqrt(chisq/p11)
             else
              do k=1,ktrm
               ufit(k)=0
              enddo
             endif
 
            endif

c save data 
            do 217 k=1,ktrm
217         fitdm(i,k,ktrm1,its,id)=ufit(k)

700       continue
600      continue
c subtract potential from diagonal part
         do 650 i=1,nx
650      fitdm(i,1,1,its,2)=fitdm(i,1,1,its,2)-pott(i)
c end of polynomial fit
         if(max(err1,err2).gt.1.e-5) then
           write (*,*) ' errors=',err1,err2
         endif
c readjust luse?
c        luse=min(luse,lmax+5) 
c        if(ndim.eq.1)luse=0

        endif

100    continue
       write (*,*) 'mdata ',mdatam,mdata
c     endif

c now write out all the data
      do 2000 id=1,2
       do 2000 k=1,nmt
        ns=nkt(k)
        if(k.gt.1)ns=ns+1
        write (3,*)'RANK 3 ',nx,' ',ns,' ',ntemp
        grid(2)='1 '
        call echo(3,grid,ngrid)
        write (3,*)'LABEL 1 r'
        write (3,889)  3,taulow,tauhigh
889     format(' GRID ',i3,' LOG ',2e17.9)
        write (3,*)'LABEL 2 terms'
        write (3,*)'LABEL 3 time'
        write (3,*)'BEGIN density matrix table fit=',k,' derv = ',id
        do 2000 l=1,ntemp
c first diagonal
         write (3,888) (fitdm(i,1,1,l,id),i=1,nx)
c now off-diagonal
         if(k.gt.1) then
          do 2001 j=1,nkt(k)
2001      write (3,888) (fitdm(i,j,k,l,id),i=1,nx)
         endif
888      format(5e17.9)
2000  continue

c now do sampling tables
c convolute with a gaussian to find sampling functions
      if(ndim.eq.1)ftnorm=1./(2*pi)
      if(ndim.eq.2)ftnorm=1.
      if(ndim.eq.3)ftnorm=2./pi

c     write (38,*)'RANK 3 ',nx,' 2 ',ntemp
c     call echo(38,grid,ngrid)
c     write (38,*)' BEGIN gfun'

      do 3000 l=1,ntemp
       wdt=.5*ehbs2m*taulow*2**(l-1)

c first make a table of gfun(r)=exp(-u(r))-1
       do 3132 i=1,nx
        u=fitdm(i,1,1,l,1)
        gfun(i)=exp(-u)-1.
3132   if(ndim.ge.2) gfun(i)=gfun(i)*rv(i)

c gaussian will drop by a factor of 1.e-9 at edge of grid
       dk=sqrt(-2*log(1.e-9)/wdt)/nkv
c make a grid in k-space
       do 3150 k=1,nkv
3150   rkv(k)=k*dk
c take fourier transform into gk
       call strans(gfun,rv,nx,gk,rkv,nkv,ndim)

       if(ndim.eq.2) then
        do 3051 k=1,nkv
3051    gk(k)=rkv(k)*gk(k)
       endif

c now multiply by a gaussian-to perform convolution
c l=1 is for mover-nonmover , l=2 is for mover-mover
       do 3070 j=1,2
        do 3054 k=1,nkv
3054    gk(k)=gk(k)*exp(-.5*wdt*rkv(k)**2)
c now transform back
        call strans(gk,rkv,nkv,gfun,rv,nx,ndim)

c normalize and take logarithm
        if(ndim.eq.3) then
         do 3052 i=1,nx
3052     gfun(i)=ftnorm*gfun(i)/rv(i)
        elseif(ndim.le.2) then
         do i=1,nx
          gfun(i)=ftnorm*gfun(i)
         enddo
        endif

c find value at r=0 and interpolate from that
        wtt=1./(2*j*wdt)
        gwt=.5*sang(ndim)*(wtt/pi)**(.5*ndim)
        gfun0=0.
        do i=1,nx-1
          if(i.eq.1) then
            delta=gwt*rv(2)
          else
            delta=gwt*(rv(i+1)-rv(i-1))
          endif
          gfun0=gfun0+delta*rv(i)**(ndim-1)
     +       *exp(-fitdm(i,1,1,l,1)-wtt*rv(i)**2)
        enddo
        gfun0=-log(gfun0)

        do i=nx,1,-1
         if(gfun(i).le.-.999) go to 707
        enddo
        i=-1
707     nneg=i
        if(nneg.ge.nx-2)stop
        f1=(-log(gfun(nneg+2)+1.)-gfun0)/rv(nneg+2)**2
        f2=(-log(gfun(nneg+3)+1.)-gfun0)/rv(nneg+3)**2
        a2=(f2-f1)/(rv(nneg+3)**2-rv(nneg+2)**2)
        a1=f1-a2*rv(nneg+2)**2

        do i=1,nx
         if(i.le.nneg+1)then
c now interpolate assuming gfun=gfun0+ cnst*r**2
          gfun(i)=gfun0+rv(i)**2*(a1+a2*rv(i)**2)
         else
          gfun(i)=-log(1.+gfun(i))
         endif
        enddo

c     write (38,*) (gfun(i),i=1,nx)

        if(ndim.eq.1) then
         do i=2,nx-1
c this is first derivative for the drift -wdt*(dw/dr)
          samtab(i,j,l,1)=-wdt*(gfun(i+1)-gfun(i-1))/(rv(i+1)-rv(i-1))
c this is second derivative for the covariance matrix
          samtab(i,j,l,2)=-wdt**2*( gfun(i+1)+gfun(i-1)-2*gfun(i) )
     +                     /(.5*(rv(i+1)-rv(i-1)) )**2
         enddo

        else
         do i=2,nx-1
c this is first derivative for the drift -wdt*(1/r)*(dw/dr)
          samtab(i,j,l,1)=-wdt*(gfun(i+1)-gfun(i-1))
     +                     /((rv(i+1)-rv(i-1))*rv(i))
c this is second derivative for the covariance matrix
c    -wdt**2 (1/r)*d/dr[ (1/r)*(dw/dr) ]
          samtab(i,j,l,2)=wdt*(-samtab(i,j,l,1)-wdt*(gfun(i+1)
     &                     +gfun(i-1)-2*gfun(i) )
     &                    /(.5*(rv(i+1)-rv(i-1)))**2  )  /rv(i)**2
         enddo
        endif

        do id=1,2
         samtab(1,j,l,id)=samtab(2,j,l,id)
         samtab(nx,j,l,id)=0.
        enddo
3070   continue

3000  continue

      do 3010 id=1,2
       write (3,*)'RANK 3 ',nx,' 2 ',ntemp
       write (3,*)'LABEL 1 r'
       write (3,*)'LABEL 2 movers/nonmovers'
       write (3,*)'LABEL 3 time'
       write (3,889)  3 ,taulow,tauhigh
       call echo(3,grid,ngrid)
       write (3,*)'BEGIN sampling table  ',2+id
       do 3510 l=1,ntemp
        do 3510 j=1,2
3510   write (3,888)(samtab(i,j,l,id),i=1,nx)
3010  continue
      close(3)


c write out chi^2 for the fit
      open (4,file=fname(1:ln)//'.ch',status='unknown')
      write (4,*)' RANK 4 ',nx,nmt,' 2 ',ntemp
      write (4,*)'LABEL 1 r'
      call echo(4,grid,ngrid)
      write (4,*)'LABEL 2 order'
      write (4,*)'LABEL 3 u and du/dt'
      write (4,*)'LABEL 4 time'
      write (4,889)  4 ,taulow,tauhigh
      write (4,*)' BEGIN chi'
      write (4,*)((((chis(i,l,k,it),i=1,nx),l=1,nmt),k=1,2),it=1,ntemp)
c find effective potential

c first make a table of gfun(r)=u(r)
       do i=1,nx
        gfun(i)= min(pott(i),tlow*100)
        if(ndim.ge.2) gfun(i)=gfun(i)*rv(i)
       enddo
       dk= 6*nx/(nkv*rv(nx))
c make a grid in k-space
       do k=1,nkv
         rkv(k)=k*dk
       enddo

c take fourier transform into gk
       call strans(gfun,rv,nx,gk,rkv,nkv,ndim)
       if(ndim.eq.2) then
        do k=1,nkv
        gk(k)=rkv(k)*gk(k)
       enddo

       endif
        do k=1,nkv
         alp=sqrt(.25*ehbs2m*rkv(k)**2*tauhigh)
         gk(k)=tauhigh*gk(k)*daws(alp)/alp
         enddo
c now transform back
        call strans(gk,rkv,nkv,gfun,rv,nx,ndim)
        if(ndim.eq.3) then
         do i=1,nx
         gfun(i)=ftnorm*gfun(i)/rv(i)
         enddo
        elseif(ndim.le.2) then
         do i=1,nx
          gfun(i)=ftnorm*gfun(i)
         enddo
        endif

c write out graphing tables
        do i=1,nx
        write (88,8888) rv(i),(dmplot(i,l),l=1,3)
     +   ,fitdm(i,1,1,ntemp,1),gfun(i),(chis(i,l,1,ntemp),l=1,nmt)
8888      format(11f13.5)
        enddo
      end

      subroutine denmat(r,i,ri,u,ldim,nx,d,et,ehbs2m,mx2,d0,lu,ndim)
      implicit none
      integer i,ldim,nx,mx2,lu,ndim,ix,i1,i2,i3,i4,l,isym
      real*8 r,ri,et,ehbs2m,a1,a2,a3,a4
      real*8 u(0:ldim,mx2,2),d(0:ldim,2),d0(0:ldim,2)
c finds density matrix at point (r,r(i),et)
c do cubic interpolation on uold table
      call fdenmt(r,ri,d0,et,ldim,ehbs2m,lu,ndim)
      call interp(r,ix,a1,a2,a3,a4)
      i1=isym(ix-1,i)
      i2=isym(ix,i)
      i3=isym(ix+1,i)
      i4=isym(ix+2,i)
      do l=0,lu
       d(l,1)=d0(l,1)*exp(-a1*u(l,i1,1)-a2*u(l,i2,1)
     +        -a3*u(l,i3,1)-a4*u(l,i4,1) )
c this should be the time derivative of the density matrix
       d(l,2)=d(l,1)*(d0(l,2)-
     + (a1*u(l,i1,2)+a2*u(l,i2,2)+a3*u(l,i3,2)+a4*u(l,i4,2))  )
       d0(l,2)=d0(l,1)*d0(l,2)
      enddo
      return
      end

      subroutine fdenmt(ri,rj,d,et,ldim,ehbs2m,lu,ndim)
      implicit none
c modify to calculate the logrithmic derivative wrt to et
      integer ldim,lu,ndim,l,nout
      real*8 ri,rj,et,ehbs2m,pi,eps,wi,arg,eti,cc,a,zero
      real*8 d(0:ldim,2)
      save pi,eps
      data pi/3.14159265358979/
      data eps/1.e-7/
      wi=.25/et
      arg=2*wi*ri*rj
      eti=ehbs2m/et

      if(ndim.eq.1)then 

       arg=wi*(ri-rj)**2
       d(0,1)=exp(-arg)/sqrt(4*pi*et)
       d(0,2)=eti*(-.5+arg)

      elseif(ndim.eq.2) then
c numerical recipes desn't work? 1/22/93
c     call bessi(lu,arg,d,eps)
c slatec works better!!
       zero=0
       call besi(arg,zero,2,lu+1,d,nout)
       cc=sqrt(ri*rj)*exp(-(ri-rj)**2*wi)/(2*et)
       do l=0,lu
        d(l,1)=d(l,1)*cc
       enddo
       a=-1+(ri**2+rj**2)*wi
       d(0,2)=eti*(a-arg*d(1,1)/d(0,1))
       do l=1,lu
        d(l,2)=eti*(a+l-arg*d(l-1,1)/d(l,1))
       enddo

      elseif(ndim.eq.3) then

       d(0,1)=(exp(-(ri-rj)**2*wi)-exp(-(ri+rj)**2*wi))/sqrt(4*pi*et)
       a=-.5+(ri**2+rj**2)*wi
       d(0,2)=eti*(a-arg/tanh(arg))
       if(lu.gt.0) then
        call vmsbi(arg,d(0,1),eps,lu+1)
        do l=1,lu
         d(l,2)=eti*(a+l-arg*d(l-1,1)/d(l,1))
        enddo
       endif

      endif

      return
      end

      subroutine vmsbi(x,bsl,eps,numerm)
      implicit none
      integer numerm,nnu,nm1,kk,n,isamax
      real*8 bsl(numerm),rat(128),d(128),v(128),test(128)
      real*8 x,eps,rx,ot,xi,xi2,xi3,xi4,aa
c bsl(i,x)=e**-x*sqrt(2pix)*i(i-.5,x) ; i is modified spherical 
c                                            bessel function
c for i ranging from 1 to numerm; eps is convergance criterion
      if(x.le.5.*numerm) then

       if(numerm.gt.128)stop
       rx=2./x
       do 1 nnu=2,numerm
        d(nnu)=1.e20*(nnu+.5)*rx
        v(nnu)=1./((nnu-.5)*rx)
1      rat(nnu)=1./((nnu-.5)*rx)
       do 10 nm1=1,400
        ot=nm1-.5
        do 3 nnu=2,numerm
         d(nnu)=(nnu+ot)*rx+1./d(nnu)
3       v(nnu)=1./((nnu+ot)*rx+v(nnu))
        do 4 nnu=2,numerm
4       test(nnu)=d(nnu)*v(nnu)
        do 5 nnu=2,numerm
5       rat(nnu)=rat(nnu)*test(nnu)
        if(nm1.le.5) go to 10
        do 6 nnu=2,numerm
6       test(nnu)=abs(test(nnu))-1.
        kk=isamax(numerm-1,test(2),1)
        if(abs(test(kk+1)).lt.eps) go to 15
10     continue
15     continue
       do 20 nnu=2,numerm
20     bsl(nnu)=bsl(nnu-1)*rat(nnu)

      else

c asymptotic expansion
       xi=1./x
       xi2=xi*xi
       xi3=xi2*xi
       xi4=xi3*xi
       aa=bsl(1)
       do 110 n=1,numerm-1
110    bsl(n+1)=aa*exp(-.5*n*(n+1)*xi)*(1.-.25*n*(n+1)*xi2+
     $     .041666667*n*(n+1)*(n-2)*(n+3)*xi3+
     $     .03125*n*(n+1)*(5*n*n+5*n-12)*xi4)

      endif

      return
      end

      subroutine vlegp(p,ldim,dc,nc,lu)
      implicit none
c vector legendre polynomial table
      real*8 p(0:ldim,nc),dc,x,a1,a2
      integer ldim,nc,lu,i,l
      do 1 i=2,nc
       p(0,i)=1.
1     p(1,i)=1.-dc*(i-1)
c use recurrence relations in the increasing l direction
      do 2 l=1,lu-1
       x=1./(l+1)
       a1=x*(l+l+1)
       a2=-x*l
       do 3 i=2,nc
3      p(l+1,i)=p(1,i)*a1*p(l,i)+a2*p(l-1,i)
2     continue
      do 4 l=0,lu
4     p(l,1)=1.
      return
      end

      subroutine vcos(p,ldim,dc,nc,lu)
      implicit none
      real*8 p(0:ldim,nc),dc
      integer l,i,lu,ldim,nc
      do 1 l=0,lu
       do 1 i=1,nc
1     p(l,i)=cos(dc*(i-1)*l)
      return
      end

      function isym(i,j)
      implicit none
c routine to find index in packed table
      integer ipoint,isym,i,j,i1,i2
      common /ipp/ipoint(628)
      i1=min(i,j)
      i2=i+j-i1
      isym=i1+ipoint(i2)
      return
      end

      subroutine strans(gr,rv,nr,gk,rkv,nk,ndim)
      implicit none
      real*8 gr(nr),gk(nk),rv(nr),rkv(nk)
      real*8 g0,wt,bessj0
      integer nr,nk,ndim,k,i
c puts the  transform of gr into gk (from 0 to rv)
c     integral of cos(kr)*gr(r)     if ndim=1
c     integral of jo(kr) *gr(r)     if ndim=2
c     integral of sin(kr)*gr(r)     if ndim=3
 
      g0=0.
      if(ndim.eq.1)g0=.5*gr(1)*rv(1)
      do k=1,nk
       gk(k)= g0
      enddo
 
      do 1 i=1,nr
       wt=.5*gr(i)
       if(i.eq.1) then
        wt=wt*rv(2)
       elseif(i.eq.nr) then
        wt=wt*(rv(nr)-rv(nr-1))
       else
        wt=wt*(rv(i+1)-rv(i-1))
       endif
 
       if(ndim.eq.1) then
        do  k=1,nk
         gk(k)=gk(k)+wt*cos(rv(i)*rkv(k))
        enddo
       elseif(ndim.eq.2) then
        do  k=1,nk
         gk(k)=gk(k)+wt*bessj0(rv(i)*rkv(k))
        enddo
       elseif(ndim.eq.3) then
        do  k=1,nk
         gk(k)=gk(k)+wt*sin(rv(i)*rkv(k))
        enddo
       endif

1     continue
      return
      end
