      program ocset
      include 'mach.p'
c generates fnpimc input for one component systems 
c version of 4/22/93, D. Ceperley UIUC

      integer mnp,mnkv,mnsh,ndim,mn,ncell,kmult,nppss,iseed,lvl
     &,ntail,ln,ld,j,n,lpt,ntemp,nmt,i,nparts,nxtalp,l,lf,nspins
     &,nref,nk,nvects,nexp,k,nb,np,nl,nhits,intread,ipickoff,nslices
     &,nlvls,mdim
      real*8 tpiell,rkcomp,rk,u,wsites,expon,cexpon,charge,rho
     &,hbs2m,tlow,cutr,rs,accuracy,alpha,pot0,vol,rnn,enorm
     &,e2,vn,sang,vtail,ptail,temp,tau,beta,del,xx,ranf,cutk
     &,cc,zz,gr,gr0,theta,q,arg,pi,tn,s,vself,gam,rlread,tslice
     &,ti

      parameter (mnp=250,mnkv=1000,mnsh=200,mdim=3,mn=10)
      parameter (pi=3.14159265358979)
      dimension tpiell(mdim),ncell(3),rkcomp(mdim,mnkv),rk(mnsh)
     +,kmult(mnsh),u(mnsh,3),nppss(2),wsites(mdim,mnp),iseed(2)
     +,expon(20),cexpon(20)
      character qid*8,filen*24,ptype*5,dmfile*10,p(mn)*28

      real*8 ell(3),el2(3)

      iseed(2)=111
      iseed(1)=0
      call iranset(iseed)
      ntail=-1
      charge=0.

      write (*,*) 'input name of run'
      read (*,55) qid
55    format(a)
      ln=index(qid//' ',' ')-1
      open(1,file=qid(1:ln)//'.sy',status='unknown')
c auxillary file
      open(7,file=qid(1:ln)//'.os',status='unknown')
c input name of density matrix file
      write (*,*) 'input dm file '
      read (*,55) dmfile
      ld=index(dmfile,' ')-1
      open(8,file=dmfile(1:ld)//'.dm')
      rho=0.

1     j=ipickoff(8,p,n,mn)

      if(p(1).eq.'UNITS') then
       call echo(1,p,n)

      elseif(p(1).eq.'TYPE') then
c particle label
      ptype=p(2)
      lpt=index(ptype,' ')-1
      hbs2m=rlread(p(3))

      elseif(p(1).eq.'SQUARER') then
c read squaring parameters
      tlow=rlread(p(2))
      ntemp=intread(p(3))
      ndim=intread(p(4))
      if(ndim.lt.2.or.ndim.gt.3)stop
      nmt=intread(p(5))

      elseif(p(1).eq.'POT')then
c look at potential
      cutr=rlread(p(3))

      if(p(2).eq.'SCCOUL') then
       rs=rlread(p(5))
       rho=3/(4*pi*rs**3)

      elseif(p(2).eq.'COUL') then
       charge=rlread(p(4))
       accuracy=rlread(p(5))
       alpha=-.5*log(accuracy*cutr/abs(charge))/cutr**2
      endif

      elseif(p(1).eq.'POTTAIL') then
       pot0=rlread(p(2))
       ntail=intread(p(3))
       if(ntail.lt.0)stop
       do i=1,ntail
        expon(i)=rlread(p(2+2*i))
        cexpon(i)=rlread(p(3+2*i))
      enddo

      elseif(p(1).eq.'RANK') then
       go to 2
      endif
      go to 1

2     continue
c read number of particles
      write (*,*) 'input: nparts '
      read (*,*) nparts
      if(nparts.gt.mnp) stop
      if(rho.eq.0) then
          write (*,*)' input density '
          read (*,*) rho
      endif
      write (7,*)  'rho = ',rho
      vol=nparts/rho
c read input crystal structure
      write (*,*) 'input crystal number of unit cells in each direction'
      write (*,*) 'crystal:1=sc,2=bcc,3=hcp,4=fcc(3d),3=triangular(2d)'
      read (*,*) nxtalp,(ncell(l),l=1,ndim)
      call sites(1,wsites,nparts,ndim,nxtalp,vol,ncell,ell,rnn,mdim)

c energy normalization
      enorm=nparts
      write (1,89)' ENORM ',enorm
89    format(a10,e17.8)

c cutoff radial tables at 1/2 the smallest box dimension
      e2=.5*ell(1)
      do 10 l=1,ndim
      tpiell(l)=2*pi/ell(l)
10    e2=min(e2,.5*ell(l))
      if(e2.lt.cutr)then
        write (*,*) ' potential sticks out of box ',cutr,e2
        stop
      endif
      write (1,88) (ell(l),l=1,ndim)
88    format(' BOXSIZE',3e18.10)


c do tail corrections
c vtail=.5*rho*integral( missing potential )
      if(ntail.gt.0) then
        vn=.5*rho*sang(ndim)
        vtail=vn*cutr**ndim*pot0/float(ndim)
        do i=1,ntail
           if(ndim+expon(i).ge.0.)stop
           vtail=vtail
     +      -vn*cexpon(i)*cutr**(ndim+expon(i))/(ndim+expon(i))
        enddo
        write (1,89)' VTAIL ',vtail
        ptail=rho*vtail
        write (1,89)' PTAIL ',ptail
      endif

      write (*,*) ' possible fits=',nmt
      write (*,*) ' possible tslice ',(tlow*2**(l-1),l=1,ntemp)
      write (*,*) ' input physical temperature, tslice '
      read (*,*) temp,tau
      tslice=0.
      do l=1,ntemp
      if(abs(tau/(tlow*2**(l-1))-1.).lt..001) then
        tslice=tlow*2**(l-1)
        nlvls=ntemp-l+1
      endif
      enddo

      if(tslice.eq.0.)stop
      nslices=tslice/temp+.001
      beta=nslices/tslice
      write (*,*)' nslices = ',nslices,' temp ',1./beta
      write (1,89)' BETA ',beta
      write (1,*)' NSLICES ',nslices

      do 20 l=1,ndim
      el2(l)=.5*ell(l)
20    tpiell(l)=2*pi/ell(l)

      filen=qid(1:ln)//'.'//ptype(1:lpt)//'.ic'
      lf=index(filen,' ')-1
c add some random displacements
c     do 555 l=1,ndim
c     del=.01*ell(l)
c     do 555 i=1,nparts
c     xx=wsites(l,i)+del*(ranf()-.5)
c     if(xx.gt.el2(l))  xx=xx-ell(l)
c     if(xx.lt.-el2(l)) xx=xx+ell(l)
c555   wsites(l,i)=xx
c write out coordinates
      call writecon(wsites,ndim,nparts,ell,filen,mdim)

      write (*,*) 'input: nspins nppss '
      read (*,*) nspins,(nppss(j),j=1,nspins)
c     nspins=0

      if(nspins.eq.1) then
      write (1,71)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
71     format('TYPE ',a3,e17.9,3i5,' ',a14)
      elseif(nspins.eq.2) then
      write (1,72)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
72     format('TYPE ',a3,e17.9,4i5,' ',a14)
      elseif(nspins.eq.0) then
      write (1,73)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
73     format('TYPE ',a3,e17.9,2i5,' ',a14)
      endif

      write (1,*) 'POT PAIR  ',ptype,' ',ptype,' '
     +   ,dmfile(1:ld)//'.dm' 
      write (1,*) ' GAMMA 3 ',ptype,' ',float(nparts)
c     write (1,*) 'FREESAMP'
c     write (1,*) 'DISPLACE ',ptype,' ',0.5

      if(nspins.gt.0) then
      write (*,*) 'input nref (0 1 or 2)'
      read (*,*) nref
      write (1,*) 'NREF ',nref
      endif

c if charged construct the long ranged potential
      if(charge.ne.0) then 
       cutk=2*cutr*alpha
       call shells(ndim,tpiell,cutk,nk,rkcomp,rk(1),kmult
     +,nvects,mnkv,mnsh,mdim)
       write (*,*)' number of k-vectors ',nk,nvects
       write (1,*)'POT EWALD ',cutk,' ',qid(1:ln)//'.lr'
      open(2,file=qid(1:ln)//'.lr',status='unknown')
c write header
       write (2,*)'RANK 5 ',nk,' 1 1 3 ',nlvls
       write (2,*)'BEGIN k-space action'

       nexp=1
       cc=charge*pi**(.5*ndim)/(vol*gam(.5*nexp))
       zz=.5*(ndim-nexp)
       do k=1,nk
       call gammi(gr,zz,rk(k)**2/(4*alpha),gr0)
c this is the potential
       u(k,1)=cc*gr*(.5*rk(k))**(-ndim+nexp)
       enddo

       do lvl=1,nlvls
       ti=2**(lvl-1)/tslice
       do k=1,nk
c now rpa for the density matrix and its time derivative
       arg=1.+2*u(k,1)*nparts/(hbs2m*rk(k)**2)
       theta=.5*rk(k)**2*hbs2m*ti
       if(arg.le.0)then
         q=sqrt(-arg)
         if(q*theta.ge..5*pi)stop
         tn=tan(theta*q)
         s=q*(1-q*tn)/(q+tn)
       elseif(arg.eq.0)then
         s=1./(1+theta)
       elseif(arg.gt.0)then
         q=sqrt(arg)
         tn=tanh(theta*q)
         s=q*(1+q*tn)/(q+tn)
       endif
c u(k,2) is the action
       u(k,2)=(-1.+s)/float(nparts)
c u(k,3) is the beta derivative of the action
       u(k,3)=-hbs2m*rk(k)**2*u(k,2)*(1+.5*nparts*u(k,2))
       enddo

       do i=1,3
       write (2,*)(u(k,i),k=1,nk)
       enddo
       enddo
       close(2)

       u(0,1)= -cc/(zz*alpha**zz)
c tail corrections correction to total potential/particle
       vself=-charge*alpha**(.5*nexp)/(nexp*gam(.5*nexp))
       vn=.5*rho*sang(ndim)*cutr**ndim*pot0/float(ndim)
       vtail=vself+vn +.5*nparts*u(0,1)
        write (1,89)' VTAIL ',vtail
        ptail=rho*vtail
        write (1,89)' PTAIL ',ptail
      else

c define cutk
      cutk=3.1*(nparts/vol)**(1./ndim)
      write (1,89)' CUTK ',cutk
      endif
      write (1,*)'RESTART'

      write (*,*)' input blocks passes, levels for omove '
      read (*,*) nb,np,nl
      if(nb.gt.0)write (1,*) 'OMOVE ',nb,' ',np,' ',nl
      write (*,*)' input blocks, passes, levels, hitsfor select '
      read (*,*) nb,np,nl,nhits
      if(nb.gt.0)write (1,*) 'SELECT ',nb,' ',np,' ',nl,' ',nhits
      stop
      end 
