	program	vtest
	implicit double precision (a-h, o-z)
	parameter (a0  = 0.529911706)
	do	10	i	= 1, 200
	  r	= 0.1*i
          write (9,6) r/a0,vext(r,1),r,vhfd(r)
6       format(4e15.7)
   10	continue
	stop
	end

	DOUBLE PRECISION FUNCTION VEXT(R, IPOT)
	implicit double precision (a-h, o-z)
C
C	This is a function for the impurity potential
C	in a doped droplet calculation. For the
C	time being, just zero.
C
	parameter (eps = 1.97D-4)
	parameter (rm  = 7.970)
	parameter (a1  = 0.95)
	parameter (a2  = 0.92)
	parameter (c6  = 39.2/rm**6)
	parameter (c8  = 920/rm**8)
	parameter (c10 = 21000/rm**10)
	parameter (x2  = 1.55)
	parameter (x1  = 1.0945321014347)
	parameter (b1  =-1.4775000000000D-04)
	parameter (b2  = 2.9589547075942D-04)
	parameter (b3  =-9.3606142295334D-04)
	parameter (b4  = 8.8471726308431D-04)
	parameter (a0  = 0.529911706)
	parameter (Ha  = 2*1.578935D5)
	DIMENSION C(10)
	PARAMETER (MAX=8)
C
C	IPOT	=	1:	Neon
C	IPOT	=	2:	Argon
C	IPOT	=	3:	Krypton
C	IPOT	=	4:	Xenon
C	IPOT	=	5:	SF_6
C	IPOT	=	10:	Old Xenon
C
C	Helium - rare gas atom potentials from
C	K. T. Tang and P. Toennies, Z. Physik D 1, 91 ((1986)
C
	DIMENSION A(4), B(4), D06(4), D08(4), D10(4)
	DATA	A	/ 50.36 ,     75.87  ,  103.98  ,    74.90  /
	DATA	B	/  2.370,      2.059 ,    2.000 ,     1.818 /
	DATA	D06	/  3.1455,     9.7697,   14.1123,    21.5674/
	DATA	D08	/ 32.7279,   152.8468,  219.0360,   430.1480/
	DATA	D10	/443.864 ,  3249.728 , 4886.143 , 10610.21  /

C	INCLUDE 'COMMON.FOR'
	VEXT	= 0.D0
	IF (IPOT.LE. 0)	RETURN
	IF (IPOT.LE. 4) THEN
	  X	=	R/A0
	  BR	=	B(IPOT)*X
	  EB	=	DEXP(-BR)
	  V0	=	A(IPOT)*EB
	  C(3)	=	D06(IPOT)
	  C(4)	=	D08(IPOT)
	  C(5)	=	D10(IPOT)
	  DO	10	I	= 6, MAX
	    C(I)	= (C(I-1)/C(I-2))**3*C(I-3) 
   10	  CONTINUE
	  DO	30	I	= 3, MAX
	    DC	=	1.
	    CC	=	1.
	    DO	20	K	= 1, 2*I
	      DC	= BR*DC/K
	      CC	= CC + DC
   20	    CONTINUE
	    CC	= 1.-CC*EB
	    V0	= V0 - CC*C(I)/X**(2*I)
   30	  CONTINUE
	  vext	= dmin1(9999.d0,v0*Ha)
	  RETURN
	END IF
	IF (IPOT.EQ.10)	THEN
C
C	old Xenon-He potential
C
	  X	= (3.679/R)**6
	  VEXT	= 4.*25.18*(X**2-X)
	  vext	= dmin1(9999d0,vext)
C
C		Fudge things for inititating
C
	ELSE IF (IPOT.EQ.5)	THEN
C
C	SF_6 potential from Pack et al. (J. Chem. Phys. 80, 4940 (1984)
C
	  x= r/(a0*rm)
	  if (x .le. 1) then
	    v= eps*(exp(-2d0*a1*rm*(x-1.d0)) - 2.D0*exp(-a1*rm*(x-1.d0)))
	  else if ((x.gt.1) .and. (x.le.x1)) then
	    v= eps*(exp(-2d0*a2*rm*(x-1.d0)) - 2.D0*exp(-a2*rm*(x-1.d0)))
	  else if ((x.gt.x1) .and. (x.le.x2)) then
	    v= b1+(x-x1)*(b2+(x-x2)*(b3+(x-x1)*b4))
	  else if (x.gt.x2) then
	    v= -c6/x**6 - c8/x**8 - c10/x**10
	  end if
	  vext = v*Ha
	END IF
	RETURN
	END

      function vhfd(r)
      implicit real*8 (a-h,o-z)
      parameter(echg=1.6021917e-19)
      parameter(dkbolt=1.380622e-23)
      parameter(evtokb=(echg/dkbolt))
      parameter(rm=3.029)
      parameter(sig=2.699)
      parameter(eps=0.001827*evtokb)
      parameter(alfa=4.031)
      parameter(beta=0.0987)
      parameter(a=797.*evtokb)
      parameter(d=1.28)
      parameter(c6=1.810*evtokb)
      parameter(c8=5.503*evtokb)
      parameter(c10=20.5*evtokb)
      parameter(c12=96.*evtokb)
      parameter(c14=554.*evtokb)
      parameter(drm=d*rm)

      vhf=a*exp(-r*(alfa+r*beta))
      ri2=1./(r*r)
      ri6=ri2*ri2*ri2
      vd=-ri6*(c6+ri2*(c8+ri2*(c10+ri2*(c12+ri2*c14))))
      if(r.lt.drm)then
        f=drm/r-1.
        vd=vd*exp(-f*f)
      endif
      vhfd=vhf+vd
      return
      end
