      program qmcdm
      include 'mach.p'
      parameter (mx=127,ndim=2,mnsys1=260,mdiv=8,mnts=700,mlevels=4
     +, mterms=10,mnprm=10)
      dimension r(mx,ndim,mnsys1),dm(mx,mdiv),ekin(mx,mdiv),wt(mx)
     +,intv(2,mnsys1),time(mnsys1),ebeta(mx,mnsys1),spring(mx)
     +,dmtable(mnts,4,mterms,mlevels),dmtabled(mnts,4,mterms,mlevels)
     +,rv(mx),rav(ndim),virial(mx,mnsys1),cvirial(mx),idim(5)
     +,evir(mx,mdiv),rdiff(ndim),u(mdiv),e1(mdiv),e2(mdiv)
c    +,vmin(mdiv)
       common/ch/hbs2m,pot(mnts,4)
       character fname*14,p(10)*28
c************************************************************
c this program calculates the two particle density matrix by
c bisection Monte Carlo
c and compares to that generated in a table.
c************************************************************

      ifout=0
      write (*,*)' input prefix of files '
      read (*,99) fname
99    format(a14)
      ln=index(fname,' ')-1
      open (21,file=fname(1:ln)//'.dm',status='unknown')

      hbs2m=0.
      ntypes=0
      mdim=0
1     j=ipickoff(21,p,n,10)

      if(p(1).eq.'TYPE')then
       hbs2m=hbs2m+rlread(p(3))
       ntypes=ntypes+1

      elseif(p(1).eq.'SQUARER') then
        mdim=intread(p(4))
        if(ndim.ne.mdim) stop

      elseif(p(1).eq.'GRID') then
        nx=intread(p(2))
        call setgrid(mnts,nx,rv,p(3))
        write (*,*) nx,rv(1),rv(nx)

      endif

      if(ntypes.ne.2.or.mdim.eq.0)go to 1

        idim(1)=nx
        idim(2)=1
        call checkrnk(21,2,idim)
        call findbegn(21)
        read (21,*) (pot(i,1),i=1,nx)
        pot(nx,1)=0.
        call spline(pot,nx,mnts,1)
        write (6,*)' finished reading potential'

      write (*,*) ' input temp '
c beta is the 1/temperature
      read (*,*) temp
      beta=1./temp
      write (*,*)' no terms in action '
      read (*,*) ntermact
        call readseln(dmtable,mnts,4,mterms,mlevels
     +,ntermact,nlvld,beta,nx,1,nx)
        call readseln(dmtabled,mnts,4,mterms,mlevels
     +,ntermact,nlvld,beta,nx,2,nx)

      write (*,*) ' input nsteps ndiv '
      read (*,*) nsteps, ndiv
      nbs=1+2**ndiv
      if(nbs.gt.mnsys1)stop
      if(ndiv.gt.mdiv)stop
c nsteps=no. of mc samples to be done (*mx)
c ndiv = number of bisections (work goes as nsteps*2**ndiv)

500   write (*,*) ' diffusion length ',sqrt(2*ndim*hbs2m*beta)
c point to calculate density matrix
      write (*,*) ' input rbar s z '
      read (*,*) rbar,s,z
      if(rbar.le.0.) stop
      ra=rbar+.5*z
      rb=rbar-.5*z
      ct=(ra**2+rb**2-s**2)/(2*ra*rb)
      write (*,*)' ra=',ra,' rb=',rb,' cos(theta)=',ct
      if(abs(ct).gt.1.or.ra.le.0.or.rb.le.0) go to 500
      xb=rb*ct
      yb=rb*sqrt(1-ct**2)
      do 38 k=1,mx
      do 38 l=1,ndiv
      ekin(k,l)=0.
      evir(k,l)=0.
38    dm(k,l)=0.

c endpoints
      do 10 k=1,mx
      r(k,1,1)=ra
      r(k,1,2)=xb
      do 11 l=2,ndim
      r(k,l,1)=0.
11    r(k,l,2)=0.
10    r(k,2,2)=yb

      do l=1,ndim
      rav(l)=.5*(r(1,l,1)+r(1,l,2))
      rdiff(l)=r(1,l,2)-r(1,l,1)
      enddo
      write (*,*) ' rav ',(rav(l),l=1,ndim)
      write (*,*) ' rdiff ',(rdiff(l),l=1,ndim)

      time(1)=0.
      time(2)=beta
      do 12 j=1,2
12    call en(r(1,1,j),ebeta(1,j),mx,ndim,beta,virial(1,j),rav)
      vbar=.5*(ebeta(1,1)+ebeta(1,2))
      write (*,*) ' average potential ',vbar
      write (*,*) 'virial',virial(1,1),virial(1,2)

c compare tablulated results
      utab= offd(ra,rb,s,dmtable,ntermact)
      write (*,*) ' density matrix table=',utab,' primitive=',beta*vbar
      eprim=ndim/(2*beta)-s**2/(4*hbs2m*beta**2)+vbar
      etab= offd(ra,rb,s,dmtabled,ntermact)+eprim
      write (*,*) 'local energy tab=',etab,' primitive=',eprim

c      do idiv=1,ndiv
c      vmin(idiv)=1.e10
c      enddo

       betai=1./beta
c loop over number of monte carlo steps
      do 1001 isteps=1,nsteps
      intv(1,1)=1
      intv(2,1)=2
c loop over number of bisections
      nint=1
      nsl=2
      tau=beta
      do 1000 idiv=1,ndiv
      tau=.5*tau
c now bisect each of them
      nint0=nint
      do 100 l=1,nint0
      call bsect(intv,time,l,nint,nsl,hbs2m,r,mx*ndim)
100   call en(r(1,1,nsl),ebeta(1,nsl),mx,ndim,tau,virial(1,nsl),rav)

      do 960 k=1,mx
      spring(k)=.5*ndim/tau
      cvirial(k)=.5*ndim*betai
960   wt(k)=0.

      do k=1,nint
      if(intv(1,k).eq.1) k1=intv(2,k)
      if(intv(2,k).eq.2) km=intv(1,k)
      enddo

      cns=1./(4*hbs2m*tau*beta)
      do l=1,ndim
      do k=1,mx
      cvirial(k)=cvirial(k)-.5*cns*rdiff(l)
     +     *(rdiff(l)-r(k,l,km)+r(k,l,k1))
      enddo
      enddo

      aa=.5/nint
      do l=3,nsl
      do k=1,mx
      cvirial(k)=cvirial(k)-aa*virial(k,l)
      enddo
      enddo

      do 965 j=1,nint
      i1=intv(1,j)
      i2=intv(2,j)
      do 965 l=1,ndim
      do 965 k=1,mx
965   spring(k)=spring(k)-cns*(r(k,l,i1)-r(k,l,i2))**2

c integrate them up
      do 975 l=1,nsl
      ww=tau
      if(l.le.2) ww=.5*tau
      do 975 k=1,mx
975   wt(k)=wt(k)+ww*ebeta(k,l)

      do 990 k=1,mx
c     vmin(idiv)=min(vmin(idiv),wt(k))
      w=exp(-wt(k))
      ekin(k,idiv)=ekin(k,idiv)+w*(wt(k)*betai+spring(k))
      evir(k,idiv)=evir(k,idiv)+w*(wt(k)*betai+cvirial(k))
990   dm(k,idiv)=dm(k,idiv)+w
1000  continue
c if needed dump out a path
c     if(ifout.eq.0) then
c     do k=1,mx
c     if(ranf().lt.exp(vcut-wt(k))) then
c        ifout=1
c write out configuration in normal time order
c         tnow=0
c         tau=beta/(nsl-1)
c         do i1=1,nsl
c find minimum t
c            do i2= 1,nsl
c            if(abs(time(i2)-tnow).le..1*tau) then
c              write (20,21) time(i2),(r(k,l,i2),l=1,ndim)
c21             format(4f10.5)
c            endif
c            enddo
c         tnow=tnow+tau
c         enddo
c         go to 1001
c     endif
c     enddo
c     endif
c1001 continue

      write (*,*)'       u        error             E            error'
c find the mean and standard deviation of dm and energy
      nblock=mx
      do 1030 idiv=1,ndiv
      av=0.
      sq=0.
      ave=0.
      sqe=0.
      avv=0.
      sqv=0.
      t1=0
      t2=0
      t3=0

      do k=1,nblock
c density matrix
           value=-log(dm(k,idiv)/(nsteps))
           av=av+value
           sq=sq+value**2
           t1=t1+dm(k,idiv)
c standard energy
           eav=ekin(k,idiv)/dm(k,idiv)
           ave=ave+eav
           sqe=sqe+eav**2
           t2=t2+ekin(k,idiv)
c virial energy
           vav=evir(k,idiv)/dm(k,idiv)
           avv=avv+vav
           sqv=sqv+vav**2
           t3=t3+evir(k,idiv)
      enddo

      av=av/nblock
      err=sqrt(abs(sq/nblock-av**2)/(nblock-1.))
      avt=-log(t1/(nsteps*nblock))
      u(idiv)=avt

      ave=ave/nblock
      erre=sqrt(abs(sqe/nblock-ave**2)/(nblock-1.))
      avet=t2/t1
      e1(idiv)=avet

      avv=avv/nblock
      errv=sqrt(abs(sqv/nblock-avv**2)/(nblock-1.))
      avvt=t3/t1
      e2(idiv)=avvt

      write (*,1020) idiv,avt,err,avet,erre,avvt,errv
      write (*,1021) (avt-av)/nblock,(avet-ave)/nblock,(avvt-avv)/nblock
c    + ,vmin(idiv)
1020  format('   ',i1,6e12.5)
1021  format('bias',3(12x,e12.5),e12.5)
1022  format('extr',3(e12.5,12x))
1023  format('chisq',3(e12.5,12x))
1030  continue
c ASSUMING tau^2 extrapolation
      write (*,1022) (4*u(ndiv)-u(ndiv-1))/3
     +,(4*e1(ndiv)-e1(ndiv-1))/3
     +,(4*e2(ndiv)-e2(ndiv-1))/3
      write (*,1023) ((4*u(ndiv)-u(ndiv-1))/3-utab)/err
     +,((4*e1(ndiv)-e1(ndiv-1))/3-etab)/erre
     +,((4*e2(ndiv)-e2(ndiv-1))/3-etab)/errv
      go to 500
      end
 
      subroutine en(r,ebeta,mx,ndim,tau,f,rbar)
      include 'mach.p'
      parameter (mxx=127,mnts=700)
       common/ch/hbs2m,pot(mnts,4)
      dimension r(mx,ndim),ebeta(mx),rr(mxx),p(mxx),ind(mxx)
     +,f(mx),dvdr(mxx),rbar(ndim),rdpdr(mxx)

      if(ndim.eq.1) then
      do 1 k=1,mx
      f(k)=0.
1     rr(k)=r(k,1)

      elseif(ndim.eq.2) then
      do 2 k=1,mx
      f(k)=0.
2     rr(k)=sqrt(r(k,1)**2+r(k,2)**2)

      elseif(ndim.eq.3) then
      do 3 k=1,mx
      f(k)=0.
3     rr(k)=sqrt(r(k,1)**2+r(k,2)**2+r(k,3)**2)
      endif

c convert to a grid
      call ti(rr,ind,p,mx,rdpdr)
      call evpol(pot,ind,p,mx,mnts,ebeta,rdpdr,dvdr)

      do l=1,ndim
      do k=1,mx
      f(k)=f(k)-dvdr(k)*r(k,l)*(r(k,l)-rbar(l))
      enddo
      enddo

      return
      end

      subroutine ti(r,ind,rem,n,rdxdr)
      include 'mach.p'
      dimension ind(n),r(n),rem(n),rdxdr(n)
      character gtype*8
      common/gcom/gtype,dri,di,x0,rr,nx

      if(gtype.eq.'LINEAR') then
      do j=1,n
      x=x0+dri*r(j)
      ind(j)=max(1,min(nx,ifix(x)))
      rem(j)=x-ind(j)
      rdxdr(j)=dri/r(j)
      enddo

      elseif(gtype.eq.'POWER') then
      do j=1,n
      x=x0+(dri*(r(j)-rr))**di
      ind(j)=max(1,min(nx,ifix(x)))
      rem(j)=x-ind(j)
      enddo
      stop

      elseif(gtype.eq.'LOG') then
      do j=1,n
      x=1+x0*log(dri*r(j))
      ind(j)=max(1,min(nx,ifix(x)))
      rem(j)=x-ind(j)
      rdxdr(j)=x0/r(j)**2
      enddo
      endif

      return
      end

      subroutine evpol(pot,ind,p,mx,mnts,ebeta,rdpdr,dvdr)
      include 'mach.p'
      dimension pot(mnts,4),ebeta(mx),ind(mx),p(mx),dvdr(mx),rdpdr(mx)
      do 4 k=1,mx
      dvdr(k)=rdpdr(k)*(pot(ind(k),2)+p(k)*(2.*pot(ind(k),3)
     +    +3.*p(k)*pot(ind(k),4) ) )
4     ebeta(k)=pot(ind(k),1)+p(k)*(pot(ind(k),2)+p(k)*(pot(ind(k),3)
     +    +p(k)*pot(ind(k),4)))
      return
      end

      function offd(r1,r2,s,table,nterm)
      include 'mach.p'
      parameter (mxx=127,mnts=700)
      dimension table(mnts,4,nterm),var(10),rdpdr(mxx),dvdr(mxx)
       common/ch/hbs2m,pot(mnts,4)
        call ti(r1,ind,p,1,rdpdr)
        call evpol(table,ind,p,1,mnts,e1,rdpdr,dvdr)
        call ti(r2,ind,p,1,rdpdr)
        call evpol(table,ind,p,1,mnts,e2,rdpdr,dvdr)
        rb=.5*(r1+r2)
        call ti(rb,ind,p,1,rdpdr)
       var(1)=s**2
       var(2)=(r1-r2)**2
      offd=.5*(e1+e2)
      if(nterm.gt.1) 
     +  offd=offd+vsum1(1,ind,p,table(1,1,2),mnts,var,nterm-1,1,4)
      return
      end

      subroutine bsect(intv,time,l,nint,nsl,hbs2m,r,mx)
      include 'mach.p'
      dimension intv(2,1),time(1),r(mx,1)
       i1=intv(1,l)
       i2=intv(2,l)
      nint=nint+1
      nsl=nsl+1
      time(nsl)=.5*(time(i1)+time(i2))
      width=hbs2m*(time(i2)-time(i1))
      if(width.le.0)then
        write (*,*)' width<0 ',width,time(i2),time(i1),hbs2m
        stop
      endif
      intv(2,l)=nsl
      intv(1,nint)=nsl
      intv(2,nint)=i2
CDIR$ IVDEP
      do 100 k=1,mx
100   r(k,nsl)=cos(3.14159265357*ranf())*sqrt(-width*log(ranf()))
     ++.5*(r(k,i1)+r(k,i2))
      return
      end
