      program qmcdm3
c sept 14,1993
      implicit real*8 (a-h,o-z)
      parameter (mx=64,mdim=3,mnsys1=260,mdiv=8,mnts=400,mlevels=5
     +, mterms=10,mnprm=10,mnp=3)
      dimension r(mx,mdim,mnp,mnsys1),dm(mx,mdiv),ekin(mx,mdiv),wt(mx)
     +,intv(2,mnsys1),time(mnsys1),ebeta(mx,mnsys1),spring(mx)
     +,rv(mx),rav(mdim,mnp),virial(mx,mnsys1),cvirial(mx),idim(5)
     +,evir(mx,mdiv),rdiff(mdim,mnp),u(mdiv),e1(mdiv),e2(mdiv)
     +,mult(mx),utab(mx,2),wtb(mnts,4),fi(3)
       common/ch/hbs2m,pot(mnts,4)
     +,dmtable(mnts,4,mterms,mlevels,2),ntermact
       character fname*14,p(10)*28
c************************************************************
c this program calculates the two particle density matrix by
c bisection Monte Carlo
c and compares to that generated in a table.
c for several particles
c************************************************************
      open(1,file='qmcdm.co',status='unknown')
      write (*,*)' input prefix of files '
c     read (*,99) fname
      read (1,99) fname
99    format(a14)
      ln=index(fname,' ')-1
      open (21,file=fname(1:ln)//'.dm',status='unknown')
      write (*,*)'file opened'

      hbs2m=0.
      ntypes=0
      ndim=0
1     j=ipickoff(21,p,n,10)

      if(p(1).eq.'TYPE')then
       hbs2m=rlread(p(3))
       ntypes=ntypes+1
       write (*,*)' type read'

      elseif(p(1).eq.'SQUARER') then
        write (*,*) 'squarer'
        ndim=intread(p(4))
        if(ndim.gt.mdim) stop

      elseif(p(1).eq.'GRID') then
        write (*,*) 'grid'
        nx=intread(p(2))
        call setgrid(mnts,nx,rv,p(3))
        write (*,*) nx,rv(1),rv(nx)

      endif

      if(ntypes.ne.2.or.ndim.eq.0)go to 1

        idim(1)=nx
        idim(2)=1
        call checkrnk(21,2,idim)
        call findbegn(21)
        read (21,*) (pot(i,1),i=1,nx)
        pot(nx,1)=0.
        call spline(pot,nx,mnts,1)
        write (*,*)' finished reading potential'

c beta is the 1/temperature
      read (1,*) temp
      write (*,*) ' input temp ',temp
      beta=1./temp
      write (*,*)' no terms in action '
      read (1,*) ntermact
        call readseln(dmtable,mnts,4,mterms,mlevels
     +,ntermact,nlvld,beta,nx,1,nx)
        call readseln(dmtable(1,1,1,1,2),mnts,4,mterms,mlevels
     +,ntermact,nlvld,beta,nx,2,nx)

c     do i=1,10
c     rv=1.5+.25*i
c     call ti(rv,ind,p,1,rdpdr)
c      uu=0.
c     call evpol(dmtable,ind,p,1,mnts,uu,rdpdr,duu)
c     write (*,*) rv(1),uu,duu, -.25*hbs2m*beta*(rv(1)*duu)**2
c     enddo
c      stop

500   write (*,*) ' diffusion length ',sqrt(2*ndim*hbs2m*beta),ndim
c     write (*,*)' ifout <0 to stop '
c     read (*,*) ifout
c     if(ifout.lt.0) stop

c point to calculate density matrix
c nparts= number of particles
c nsteps=no. of mc samples to be done (*mx)
c ndiv = number of bisections (work goes as nsteps*2**ndiv)
      read (1,*) nparts,nsteps,ndiv,np
      write  (*,*) ' nparts=',nparts,' nsteps =',nsteps,' ndiv=',ndiv
      write (*,*) ' np ',np
      nbs=1+2**ndiv
      if(nbs.gt.mnsys1)stop
      if(ndiv.gt.mdiv)stop
      if(nparts.gt.mnp)stop
      if(np.lt.1.or.np.gt.mx)stop

      do j=1,2
      do ip=1,nparts
      read (1,*) (r(1,l,ip,j),l=1,ndim)
      enddo
      enddo
      close(1)
c determine 3-body correction
c firt open file
c     open(22,file='fsq')
c     idim(1)=-mnts
c     call checkrnk(22,1,idim)
c     nwx=idim(1)
c     write (*,*) nwx
c     call findbegn(22)
c     read(22,*)(wtb(i,1),i=1,nwx)
c     wtb(nwx,1)=0.
c     call spline(wtb,nwx,mnts,1)
c     rw1=1.75
c     rwn=4.
c     nwm=10
c     wdri=(nwm-1)/(rwn-rw1)
c     wx0=1-wdri*rw1
      
c     id=1
c     fsq=0.
c      do i=1,nparts
c       do l=1,ndim
c          fi(l)=0.
c       enddo

c      do j=1,nparts
c      if(i.ne.j) then
c find pair distance
c      rsq=0
c       do l=1,ndim
c       rsq=rsq+(r(1,l,i,id)-r(1,l,j,id))**2
c       enddo
c      rr=sqrt(rsq)
c find potential at thisdistance
c       x=wx0+wdri*rr
c       iw=max(1,min(nwx,ifix(x)))
c       remx=x-iw
c       wij=wtb(iw,1)+remx*(wtb(iw,2)+remx*(wtb(iw,3)+remx*wtb(iw,4)))
c       write (*,*) i,j,rr,wij
c       fsq=fsq+rsq*wij**2
c       do l=1,ndim
c       fi(l)=fi(l)+(r(1,l,i,id)-r(1,l,j,id))*wij
c       enddo
       
c      endif
c      enddo

c      do l=1,ndim
c      fsq=fsq-fi(l)**2
c      enddo
c      enddo
c      write (*,*)' 3-body potential',hbs2m*fsq

c replicate
      do 222 k=2,mx
      do 222 ip=1,nparts
      do 222 l=1,ndim
      do 222 id=1,2
222   r(k,l,ip,id)=r(1,l,ip,id)

c initialize final averages
      do 38 k=1,mx
      do 38 l=1,mdiv
      ekin(k,l)=0.
      evir(k,l)=0.
38    dm(k,l)=0.

c these are for the virial estimator
      s2=0
      do ip=1,nparts
      do l=1,ndim
      rav(l,ip)=.5*(r(1,l,ip,1)+r(1,l,ip,2))
      rdiff(l,ip)=r(1,l,ip,2)-r(1,l,ip,1)
      s2=s2+rdiff(l,ip)**2
      enddo
      write (*,*) ip,' rav ',(rav(l,ip),l=1,ndim)
      write (*,*) ip,' rdiff ',(rdiff(l,ip),l=1,ndim)
      enddo
      write (*,*) ' s2 = ',s2

      time(1)=0.
      time(2)=beta
      do 12 j=1,2
12    call en(r(1,1,1,j),mx,mdim,np,ndim,nparts,ebeta(1,j),virial(1,j)
     +  ,rav)
      vbar=.5*(ebeta(1,1)+ebeta(1,2))
      write (*,*) ' average potential ',vbar,ebeta(1,1),ebeta(1,2)
      write (*,*) 'virial',virial(1,1),virial(1,2)

c compare tablulated results
      s0=s2/(4*hbs2m*beta)
c we need to sum over pairs
      call toffd(r,r(1,1,1,2),mx,mdim,1,ndim,nparts,utab)
      eprim=nparts*ndim/(2*beta)-s2/(4*hbs2m*beta**2)+vbar
      utab(1,2)=utab(1,2)+eprim
      write (*,*) ' density matrix table=',utab(1,1)+s0
     +  ,' primitive=',beta*vbar+s0
      write (*,*) ' corrected ', utab(1,1)+hbs2m*fsq
      write (*,*) 'local energy tab=',utab(1,2)
     + ,' primitive=',eprim

       call second(t0)
       betai=1./beta

c loop over number of monte carlo steps
      do 1001 isteps=1,nsteps
      intv(1,1)=1
      intv(2,1)=2
c loop over number of bisections
      nint=1
      nsl=2
      tau=beta
      do 1000 idiv=1,ndiv
      tau=.5*tau
c now bisect each of them
      nint0=nint
      do 100 l=1,nint0
      call bsect(intv,time,l,nint,nsl,hbs2m,r,mx,mdim,mnp,np,ndim
     +   ,nparts)
100   call en(r(1,1,1,nsl),mx,mdim,np,ndim,nparts,ebeta(1,nsl)
     +   ,virial(1,nsl),rav)

      do 960 k=1,np
      spring(k)=.5*ndim*nparts/tau
      cvirial(k)=.5*ndim*nparts*betai
960   wt(k)=0.

      do k=1,nint
      if(intv(1,k).eq.1) k1=intv(2,k)
      if(intv(2,k).eq.2) km=intv(1,k)
      enddo

      cns=1./(4*hbs2m*tau*beta)
      do j=1,nparts
      do l=1,ndim
      do k=1,np
      cvirial(k)=cvirial(k)-.5*cns*rdiff(l,j)
     +     *(rdiff(l,j)-r(k,l,j,km)+r(k,l,j,k1))
      enddo
      enddo
      enddo

      aa=.5/nint
      do l=3,nsl
      do k=1,np
      cvirial(k)=cvirial(k)-aa*virial(k,l)
      enddo
      enddo

      do 965 j=1,nint
      i1=intv(1,j)
      i2=intv(2,j)
      do 965 i=1,nparts
      do 965 l=1,ndim
      do 965 k=1,np
965   spring(k)=spring(k)-cns*(r(k,l,i,i1)-r(k,l,i,i2))**2

c integrate them up
      do 975 l=1,nsl
      ww=tau
      if(l.le.2) ww=.5*tau
      do 975 k=1,np
975   wt(k)=wt(k)+ww*ebeta(k,l)

      sw=0
      do 990 k=1,np
      w=exp(-wt(k))
      sw=sw+w
      ekin(k,idiv)=ekin(k,idiv)+w*(wt(k)*betai+spring(k))
      evir(k,idiv)=evir(k,idiv)+w*(wt(k)*betai+cvirial(k))
990   dm(k,idiv)=dm(k,idiv)+w

c now we do branching
c     a=pop/sw
c     new=0
c     do k=1,np
c     mult(k)=wt(k)*a+ranf()
c     new=new+mult(k)
c     enddo
c     write (*,*) new

1000  continue
c if needed dump out a path
c     if(ifout.eq.0) then
c     do k=1,np
c     if(ranf().lt.exp(vcut-wt(k))) then
c        ifout=1
c write out configuration in normal time order
c         tnow=0
c         tau=beta/(nsl-1)
c         do i1=1,nsl
c find minimum t
c            do i2= 1,nsl
c            if(abs(time(i2)-tnow).le..1*tau) then
c              write (20,21) time(i2),(r(k,l,i2),l=1,ndim)
21             format(4f10.5)
c            endif
c            enddo
c         tnow=tnow+tau
c         enddo
c         go to 1001
c     endif
c     enddo
c     endif
 1001  continue

      write (*,*)'       u        error             E            error'
c find the mean and standard deviation of dm and energy
      nblock=np
      do 1030 idiv=1,ndiv
      av=0.
      sq=0.
      ave=0.
      sqe=0.
      avv=0.
      sqv=0.
      t1=0
      t2=0
      t3=0

      do k=1,nblock
c density matrix
           value=-log(dm(k,idiv)/(nsteps))
           av=av+value
           sq=sq+value**2
           t1=t1+dm(k,idiv)
c standard energy
           eav=ekin(k,idiv)/dm(k,idiv)
           ave=ave+eav
           sqe=sqe+eav**2
           t2=t2+ekin(k,idiv)
c virial energy
           vav=evir(k,idiv)/dm(k,idiv)
           avv=avv+vav
           sqv=sqv+vav**2
           t3=t3+evir(k,idiv)
      enddo

      av=av/nblock
      err=sqrt(abs(sq/nblock-av**2)/(nblock-1.))
      avt=-log(t1/(nsteps*nblock))
      u(idiv)=avt

      ave=ave/nblock
      erre=sqrt(abs(sqe/nblock-ave**2)/(nblock-1.))
      avet=t2/t1
      e1(idiv)=avet

      avv=avv/nblock
      errv=sqrt(abs(sqv/nblock-avv**2)/(nblock-1.))
      avvt=t3/t1
      e2(idiv)=avvt

      write (*,1020) idiv,avt+s0,err,avet,erre
     +  ,avvt,errv
      write (*,1021) (avt-av)/nblock,(avet-ave)/nblock
     +   ,(avvt-avv)/nblock
1020  format('   ',i1,6e12.5)
1021  format('bias',3(12x,e12.5),e12.5)
1022  format('extr',3(e12.5,12x))
1023  format('chisq',3(e12.5,12x))
1030  continue
c ASSUMING tau^2 extrapolation
      write (*,1022) (4*u(ndiv)-u(ndiv-1))/3+s0
     +,(4*e1(ndiv)-e1(ndiv-1))/3
     +,(4*e2(ndiv)-e2(ndiv-1))/3
      write (*,1023) ((4*u(ndiv)-u(ndiv-1))/3-utab(1,1))/err
     +,((4*e1(ndiv)-e1(ndiv-1))/3-utab(1,2))/erre
     +,((4*e2(ndiv)-e2(ndiv-1))/3-utab(1,2))/errv
      call second(t1)
      write (*,*) 'time ',(t1-t0), 'seconds'
c     go to 500
      end
 
      subroutine en(r,mx,mdim,nx,ndim,nparts,ebeta,f,rbar)
c     include 'mach.p'
      implicit real*8 (a-h,o-z)
      parameter (mxx=127,mnts=400,mlevels=5,mterms=10)
       common/ch/hbs2m,pot(mnts,4)
     +,dmtable(mnts,4,mterms,mlevels,2),ntermact
      dimension r(mx,mdim,nparts),ebeta(mx),rr(mxx),p(mxx),ind(mxx)
     +,f(mx),dvdr(mxx),rbar(mdim,nparts),rdpdr(mxx)

      do k=1,nx
      f(k)=0
      ebeta(k)=0
      enddo

      do i=2,nparts
      do j=1,i-1

      if(ndim.eq.1) then
      do 1 k=1,nx
1     rr(k)=r(k,1,i)-r(k,1,j)

      elseif(ndim.eq.2) then
      do 2 k=1,nx
2     rr(k)=sqrt((r(k,1,i)-r(k,1,j))**2 +(r(k,2,i)-r(k,2,j))**2)

      elseif(ndim.eq.3) then
      do 3 k=1,nx
3     rr(k)=sqrt( (r(k,1,i)-r(k,1,j))**2 +(r(k,2,i)-r(k,2,j))**2
     + + (r(k,3,i)-r(k,3,j))**2   )
      endif

c convert to a grid
      call ti(rr,ind,p,nx,rdpdr)
      call evpol(pot,ind,p,nx,mnts,ebeta,rdpdr,dvdr)

      do l=1,ndim
      do k=1,nx
      f(k)=f(k)-dvdr(k)* (r(k,l,i)-r(k,l,j) )
     +   *(r(k,l,i)-r(k,l,j)-rbar(l,i)+rbar(l,j))
      enddo
      enddo

      enddo
      enddo

      return
      end

      subroutine ti(r,ind,rem,n,rdxdr)
c     include 'mach.p'
      implicit real*8 (a-h,o-z)
      dimension ind(n),r(n),rem(n),rdxdr(n)
      character gtype*8
      common/gcom/gtype,dri,di,x0,rr,nx

      if(gtype.eq.'LINEAR') then
      do j=1,n
      x=x0+dri*r(j)
      ind(j)=max(1,min(nx,ifix(x)))
      rem(j)=x-ind(j)
      rdxdr(j)=dri/r(j)
      enddo

      elseif(gtype.eq.'POWER') then
      do j=1,n
      x=x0+(dri*(r(j)-rr))**di
      ind(j)=max(1,min(nx,ifix(x)))
      rem(j)=x-ind(j)
      enddo
      stop

      elseif(gtype.eq.'LOG') then
      do j=1,n
      x=1+x0*log(dri*r(j))
      ind(j)=max(1,min(nx,ifix(x)))
      rem(j)=x-ind(j)
      rdxdr(j)=x0/r(j)**2
      enddo
      endif

      return
      end

      subroutine evpol(pot,ind,p,mx,mnts,ebeta,rdpdr,dvdr)
c     include 'mach.p'
      implicit real*8 (a-h,o-z)
      dimension pot(mnts,4),ebeta(mx),ind(mx),p(mx),dvdr(mx),rdpdr(mx)
      do 4 k=1,mx
      dvdr(k)=rdpdr(k)*(pot(ind(k),2)+p(k)*(2.*pot(ind(k),3)
     +    +3.*p(k)*pot(ind(k),4) ) )
4     ebeta(k)=ebeta(k)+pot(ind(k),1)+p(k)*(pot(ind(k),2)+p(k)*
     +  (pot(ind(k),3)+p(k)*pot(ind(k),4))   )
      return
      end

      subroutine toffd(r1,r2,mx,mdim,nx,ndim,nparts,u)
c     include 'mach.p'
      implicit real*8 (a-h,o-z)
      parameter (mxx=127,mnts=400,mlevels=5,mterms=10)
       common/ch/hbs2m,pot(mnts,4)
     +,dmtable(mnts,4,mterms,mlevels,2),ntermact
      dimension r1(mx,mdim,nparts),r2(mx,mdim,nparts),u(mx,2)
     + ,rr1(mxx),rr2(mxx),p(mxx),ind(mxx),rb(mxx)
     +,dvdr(mxx),rdpdr(mxx), var(mxx,10)
     +,uend(mxx,2)
 
c we will calculate u and udot
      do l=1,2
      do k=1,nx
      uend(k,l)=0
      u(k,l)=0
      enddo 
      enddo 
 
      do i=2,nparts
      do j=1,i-1
 
      if(ndim.eq.1) then
      do 1 k=1,nx
      var(k,1)=(r1(k,1,i)-r1(k,1,j)-r2(k,1,i)+r2(k,1,j))**2 
      rr1(k)=r1(k,1,i)-r1(k,1,j)
1     rr2(k)=r2(k,1,i)-r2(k,1,j)
 
      elseif(ndim.eq.2) then
      do 2 k=1,nx
      var(k,1)=(r1(k,1,i)-r1(k,1,j)-r2(k,1,i)+r2(k,1,j))**2 
     +      +  (r1(k,2,i)-r1(k,2,j)-r2(k,2,i)+r2(k,2,j))**2 
      rr1(k)=sqrt((r1(k,1,i)-r1(k,1,j))**2 +(r1(k,2,i)-r1(k,2,j))**2)
2     rr2(k)=sqrt((r2(k,1,i)-r2(k,1,j))**2 +(r2(k,2,i)-r2(k,2,j))**2)
 
      elseif(ndim.eq.3) then
      do 3 k=1,nx
      var(k,1)=(r1(k,1,i)-r1(k,1,j)-r2(k,1,i)+r2(k,1,j))**2 
     +    +    (r1(k,2,i)-r1(k,2,j)-r2(k,2,i)+r2(k,2,j))**2 
     +    +    (r1(k,3,i)-r1(k,3,j)-r2(k,3,i)+r2(k,3,j))**2 
      rr1(k)=sqrt( (r1(k,1,i)-r1(k,1,j))**2 +(r1(k,2,i)-r1(k,2,j))**2
     + + (r1(k,3,i)-r1(k,3,j))**2   )
3     rr2(k)=sqrt( (r2(k,1,i)-r2(k,1,j))**2 +(r2(k,2,i)-r2(k,2,j))**2
     + + (r2(k,3,i)-r2(k,3,j))**2   )
      endif
 
c convert to a grid
      call ti(rr1,ind,p,nx,rdpdr)
      call evpol(dmtable,ind,p,nx,mnts,uend,rdpdr,dvdr)
      call evpol(dmtable(1,1,1,1,2),ind,p,nx,mnts,uend(1,2),rdpdr,dvdr)
      call ti(rr2,ind,p,nx,rdpdr)
      call evpol(dmtable,ind,p,nx,mnts,uend,rdpdr,dvdr)
      call evpol(dmtable(1,1,1,1,2),ind,p,nx,mnts,uend(1,2),rdpdr,dvdr)
 

c now off-diagonal terms
      if(ntermact.gt.1) then
        do k=1,nx
        rb(k)=.5*(rr1(k)+rr2(k))
        var(k,2)=(rr1(k)-rr2(k))**2
        enddo

        call ti(rb,ind,p,nx,rdpdr)

       call vsum2(nx,ind,p,dmtable(1,1,2,1,1),mnts,var,ntermact-1
     +  ,mxx,4,ndim,u)
       call vsum2(nx,ind,p,dmtable(1,1,2,1,2),mnts,var,ntermact-1
     +  ,mxx,4,ndim,u(1,2))
      endif
 
      enddo
      enddo
        do l=1,2
        do k=1,nx
        u(k,l)=u(k,l)+.5*uend(k,l)
        enddo
        enddo
 
      return
      end

      subroutine bsect(intv,time,l,nint,nsl,hbs2m,r,mx,mdim,mnp,nx,ndim
     +   ,nparts)
c     include 'mach.p'
      implicit real*8 (a-h,o-z)
      dimension intv(2,1),time(1),r(mx,mdim,mnp,1)
       i1=intv(1,l)
       i2=intv(2,l)
      nint=nint+1
      nsl=nsl+1
      time(nsl)=.5*(time(i1)+time(i2))
      width=hbs2m*(time(i2)-time(i1))
      if(width.le.0)then
        write (*,*)' width<0 ',width,time(i2),time(i1),hbs2m
     & , nint,nsl,nx,nparts,i1,i2,(time(l),l=1,nsl)
        write (*,*) l,(intv(1,k),intv(2,k),k=1,l)
        stop
      endif
      intv(2,l)=nsl
      intv(1,nint)=nsl
      intv(2,nint)=i2
      do 100 ip=1,nparts
      do 100 j=1,ndim
CDIR$ IVDEP
      do 100 k=1,nx
100   r(k,j,ip,nsl)=cos(3.14159265357*ranf())*sqrt(-width*log(ranf()))
     ++.5*(r(k,j,ip,i1)+r(k,j,ip,i2))
      return
      end

      subroutine vsum2(m,i,p,t,n,var,nterm,mnp,morder,idim,u)
c     include 'mach.p'
      implicit real*8 (a-h,o-z)
c we assume the ordering of terms from squarer
c idim=1 1 d tables , idim=2 full tables.

      real*8 p,t,var
      integer i,n,nterm,mnp,morder,nkt,k,l,j,m,idim

      dimension i(m),p(m),t(n,morder,nterm),var(mnp,nterm),u(m)

c determine the expansion coeeficents

      if(idim.eq.1) then
         do 400 l=2,nterm
         do 400 j=1,m
400      var(j,l)=var(j,l-1)*var(j,1)
      else
       if(nterm.gt.2) then
        nkt=2
        k=1
c go to one higher order
50      k=k+1
c multiply by s**2
        do 30 l=1,k
        do 30 j=1,m
30      var(j,nkt+l)=var(j,nkt+l-k)*var(j,1)
c multiply by z**2
        do j=1,m
          var(j,nkt+k+1)=var(j,nkt)*var(j,2)
        enddo

        nkt=nkt+k+1
        if(nkt.gt.nterm) then
           write (*,*) 'problem in vsum2 ',nterm,nkt
           stop
        elseif(nkt.lt.nterm) then
             go to 50
        endif

        endif
      endif

c now do table look-up-for nterm large the loops should be inverted
      do 40 l=1,nterm
        do 40 j=1,m
40       u(j)=u(j)+(t(i(j),1,l)
     &                 +p(j)*(t(i(j),2,l)
     &                        +p(j)*(t(i(j),3,l)
     &                               +p(j)*t(i(j),4,l))))*var(j,l)
      return
      end

