      program stable
      implicit none
c version of 6/10/93 by D. Ceperley NCSA-UIUC
c  this program calculates the sampling table density matrix 

      integer mx,ldim,mtrm,mx2,mmt,mdata,mn,mnsq,nkv
      real*8 umax
      parameter (mx=150,ldim=64,mtrm=10,mx2=mx*(mx+1)/2)
      parameter (mmt=3,mdata=10000,mn=10,mnsq=5,nkv=2000,umax=300.)

c ldim are the maximum number of partial waves
c nmt is the order of the polynomial fit .le. mmt
c nx.le.mx are the number of radial grid points
c mdata is space for the polynomial fit
c ntemp.le.mnsq is number of density matrix files output
c nkv are total number of k-values in fourier transforms for sampling tables
c mn is the maximum number of parameters in an input line
c umax=largest argument of exponential function

      real*8 uold(0:ldim,mx2,2),unew(0:ldim,mx2,2),pott(mx)
     +,vint(mx),di(0:ldim,2),dj(0:ldim,2),rv(mx),gdx(mx,2),xint(8)
     +,weight(8),u2(2),t(mtrm),ufit(mtrm),cl(0:ldim)
     +,f(0:ldim,2),uend(2),chis(mx,mmt,2,mnsq),drt(mx),ua(2)
     +,udata(mdata,mtrm),b(mdata,2),v(mtrm,mtrm),w(mtrm)
     +,utemp(mdata,mtrm),di0(0:ldim,2),dj0(0:ldim,2),rho0(0:ldim,2)
     +,fitdm(mx,mtrm,mmt,mnsq,2),gfun(mx),rkv(nkv),samtab(mx,2,mnsq,2)
     +,gk(nkv)
      integer lpos(mx)
      integer nkt(mmt),ipoint,ln,ntypes,i,ngrid,n,nx,ntemp,ndim,nmt,luse
      integer nsquare,l,k,ntrm,itemp,ii,j,ipickoff,intread,isym,mdatam
      integer isq,ind,jl,lul,nint,nk,is,kp,indl,id,its,lmax,nc,ndata
      integer i1,ix,ix1,ix2,ix3,ix4,ic,k1,ktrm1,ktrm,ll,npv,ns,it,nneg
      real*8 ehbs2m,tlow,tau,tauhigh,taulow,zero,pi,cutl,rvmax,rvmin,dr
      real*8 dri,s,uu,rlread,etau,width,cut,delr,rbar,rk,wt,temp,rinv,up
      real*8 rr2,coefr,cp,s1,s2,s3,s4,e0,eul,c,rhol0,rhol,drhol0,gs
      real*8 corr,cutfit,err1,err2,sc,thetam,cmin,dc,dt,p11,r1,r2,z2,zn
      real*8 a1,a2,a3,a4,emax,vstar,ustar,cns,cll,wtinv,pf,rocut,rozero
      real*8 rozerod,ro,u,ud,wc,swc,wmax,thresh,chisq,sum,ftnorm,wdt,dk
      real*8 wtt,gwt,gfun0,delta,f1,f2,sdot,sang
      common /ipp/ipoint(628)
      
      character fname*14,p(mn)*28,grid(mn)*28

      data pi/3.14159265358979/

      write (*,*)' input prefix of files '
      read (*,99) fname
99    format(a14)
      ln=index(fname,' ')-1
      open (3,file=fname(1:ln)//'.dm',status='unknown')
c*** read input file dm

      ntypes=0
      ehbs2m=0.
      tlow=0.

c input hbar energy units and length units
1     if(ipickoff(3,p,n,mn).eq.1)stop

      if(p(1).eq.'TYPE') then
c input type of particles and lambda
        ntypes=ntypes+1
        ehbs2m=ehbs2m+rlread(p(3))

      elseif(p(1).eq.'GRID') then
c save away grid
        do i=1,n
          grid(i)=p(i)
        enddo
        ngrid=n
c input grid parameters
        nx=intread(p(2))
        call setgrid(mx,nx,rv,grid(3))
        do i=2,nx-1
          drt(i)=.5*abs(rv(i+1)-rv(i-1))
        enddo
        drt(1)=abs(rv(2)-rv(1))
        drt(nx)=abs(rv(nx)-rv(nx-1))
  

      elseif(p(1).eq.'SQUARER') then
c now input parameters having to do with squaring
c tlow is the  lowest temperature calculated(true temperature)
        tlow=rlread(p(2))
        if(tlow.le.0.) stop
c  ntemp is number of temperatures output.
        ntemp=intread(p(3))
        if(ntemp.lt.1.or.ntemp.gt.mnsq)stop
c spatial dimensionality (1,2,3)
        ndim=intread(p(4))
c nmt is the number of approximations generated (1=diagonal etc.)
        nmt=intread(p(5))
        if(nmt.gt.mmt.or.nmt.lt.1)stop
c number of partial waves
        luse=intread(p(6))
c   number of squarings from lowest temperature
        nsquare=intread(p(7))
c nsquare .le.0 is flag for primitive approximation
        if(nsquare.le.0) then
            write (*,*) 'primitive approximation'
            nmt=1
        else
           if(nsquare.lt.ntemp) then
            write (*,*) 'nsquare.lt.ntemp'
            stop
           endif
           tau=1./(2**nsquare*tlow)
        endif
        write (*,*) 'lowest temp=',tlow,' no. squarings=',nsquare
     +    ,' no. temps=',ntemp,' no. fits=',nmt

c initial tau
        tauhigh=1./tlow
        taulow=tauhigh/2**(ntemp-1)
        
 
        if(ndim.eq.1) then
         zero=-1.e100
         luse=0
         cl(0)=1.
        elseif(ndim.eq.2) then
         zero=0.
         cl(0)=.5/pi
         do l=1,ldim
           cl(l)=1./pi
         enddo
        elseif(ndim.eq.3) then
         zero=0.
         do l=0,ldim
           cl(l)=(2*l+1)/(4.*pi)
         enddo
        else  
          write (*,*) 'error in ndim'
          stop
        endif
        if(luse.gt.ldim) then
         write (*,*)luse.gt.ldim
         stop
        endif

      elseif(p(1).eq.'RANK') then
c check to see if all other data is present before continuing
        if(nx.eq.0)stop
        if(ehbs2m.le.0)stop
        if(ntypes.ne.2)stop
        if(tlow.le.0.) stop
c input potential
        call findbegn(3)
        read (3,*) (pott(i),i=1,nx)
        go to 2

      endif
      go to 1
2     continue
c
c****end of input section***********************************
c
      cutl=-log(1.e-10)

c these are the appended max and min of our grid.
      rvmax=2*rv(nx)-rv(nx-2)
      rvmin=max(2*rv(1)-rv(3),zero)

c the following if has an else at line 203 and ends to line 633
      if(nsquare.le.0) then
c primitive approximation


c now write out all the data
      do 2000 id=1,2
       do 2000 k=1,nmt
        ns=nkt(k)
        if(k.gt.1)ns=ns+1
        write (3,*)'RANK 3 ',nx,' ',ns,' ',ntemp
        grid(2)='1 '
        call echo(3,grid,ngrid)
        write (3,*)'LABEL 1 r'
        write (3,889)  3,taulow,tauhigh
889     format(' GRID ',i3,' LOG ',2e17.9)
        write (3,*)'LABEL 2 terms'
        write (3,*)'LABEL 3 time'
        write (3,*)'BEGIN density matrix table fit=',k,' derv = ',id
        do 2000 l=1,ntemp
c first diagonal
         write (3,888) (fitdm(i,1,1,l,id),i=1,nx)
c now off-diagonal
         if(k.gt.1) then
          do 2001 j=1,nkt(k)
2001      write (3,888) (fitdm(i,j,k,l,id),i=1,nx)
         endif
888      format(5e17.9)
2000  continue

c now do sampling tables
c convolute with a gaussian to find sampling functions
      if(ndim.eq.1)ftnorm=1./(2*pi)
      if(ndim.eq.2)ftnorm=1.
      if(ndim.eq.3)ftnorm=2./pi

c     write (38,*)'RANK 3 ',nx,' 2 ',ntemp
c     call echo(38,grid,ngrid)
c     write (38,*)' BEGIN gfun'

      do 3000 l=1,ntemp
       wdt=.5*ehbs2m*taulow*2**(l-1)

c first make a table of gfun(r)=exp(-u(r))-1
       do 3132 i=1,nx
        u=fitdm(i,1,1,l,1)
        gfun(i)=exp(-u)-1.
3132   if(ndim.ge.2) gfun(i)=gfun(i)*rv(i)

c gaussian will drop by a factor of 1.e-9 at edge of grid
       dk=sqrt(-2*log(1.e-9)/wdt)/nkv
c make a grid in k-space
       do 3150 k=1,nkv
3150   rkv(k)=k*dk
c take fourier transform into gk
       call strans(gfun,rv,nx,gk,rkv,nkv,ndim)

       if(ndim.eq.2) then
        do 3051 k=1,nkv
3051    gk(k)=rkv(k)*gk(k)
       endif

c now multiply by a gaussian-to perform convolution
c l=1 is for mover-nonmover , l=2 is for mover-mover
       do 3070 j=1,2
        do 3054 k=1,nkv
3054    gk(k)=gk(k)*exp(-.5*wdt*rkv(k)**2)
c now transform back
        call strans(gk,rkv,nkv,gfun,rv,nx,ndim)

c normalize and take logarithm
        if(ndim.eq.3) then
         do 3052 i=1,nx
3052     gfun(i)=ftnorm*gfun(i)/rv(i)
        elseif(ndim.le.2) then
         do i=1,nx
          gfun(i)=ftnorm*gfun(i)
         enddo
        endif

c find value at r=0 and interpolate from that
        wtt=1./(2*j*wdt)
        gwt=.5*sang(ndim)*(wtt/pi)**(.5*ndim)
        gfun0=0.
        do i=1,nx-1
          if(i.eq.1) then
            delta=gwt*rv(2)
          else
            delta=gwt*(rv(i+1)-rv(i-1))
          endif
          gfun0=gfun0+delta*rv(i)**(ndim-1)
     +       *exp(-fitdm(i,1,1,l,1)-wtt*rv(i)**2)
        enddo
        gfun0=-log(gfun0)

        do i=nx,1,-1
         if(gfun(i).le.-.999) go to 707
        enddo
        i=-1
707     nneg=i
        if(nneg.ge.nx-2)stop
        f1=(-log(gfun(nneg+2)+1.)-gfun0)/rv(nneg+2)**2
        f2=(-log(gfun(nneg+3)+1.)-gfun0)/rv(nneg+3)**2
        a2=(f2-f1)/(rv(nneg+3)**2-rv(nneg+2)**2)
        a1=f1-a2*rv(nneg+2)**2

        do i=1,nx
         if(i.le.nneg+1)then
c now interpolate assuming gfun=gfun0+ cnst*r**2
          gfun(i)=gfun0+rv(i)**2*(a1+a2*rv(i)**2)
         else
          gfun(i)=-log(1.+gfun(i))
         endif
        enddo

c     write (38,*) (gfun(i),i=1,nx)

        if(ndim.eq.1) then
         do i=2,nx-1
c this is first derivative for the drift -wdt*(dw/dr)
          samtab(i,j,l,1)=-wdt*(gfun(i+1)-gfun(i-1))/(rv(i+1)-rv(i-1))
c this is second derivative for the covariance matrix
          samtab(i,j,l,2)=-wdt**2*( gfun(i+1)+gfun(i-1)-2*gfun(i) )
     +                     /(.5*(rv(i+1)-rv(i-1)) )**2
         enddo

        else
         do i=2,nx-1
c this is first derivative for the drift -wdt*(1/r)*(dw/dr)
          samtab(i,j,l,1)=-wdt*(gfun(i+1)-gfun(i-1))
     +                     /((rv(i+1)-rv(i-1))*rv(i))
c this is second derivative for the covariance matrix
c    -wdt**2 (1/r)*d/dr[ (1/r)*(dw/dr) ]
          samtab(i,j,l,2)=wdt*(-samtab(i,j,l,1)-wdt*(gfun(i+1)
     &                     +gfun(i-1)-2*gfun(i) )
     &                    /(.5*(rv(i+1)-rv(i-1)))**2  )  /rv(i)**2
         enddo
        endif

        do id=1,2
         samtab(1,j,l,id)=samtab(2,j,l,id)
         samtab(nx,j,l,id)=0.
        enddo
3070   continue

3000  continue

      do 3010 id=1,2
       write (3,*)'RANK 3 ',nx,' 2 ',ntemp
       write (3,*)'LABEL 1 r'
       write (3,*)'LABEL 2 movers/nonmovers'
       write (3,*)'LABEL 3 time'
       write (3,889)  3 ,taulow,tauhigh
       call echo(3,grid,ngrid)
       write (3,*)'BEGIN sampling table  ',2+id
       do 3510 l=1,ntemp
        do 3510 j=1,2
3510   write (3,888)(samtab(i,j,l,id),i=1,nx)
3010  continue
      close(3)


      stop
      end


      subroutine strans(gr,rv,nr,gk,rkv,nk,ndim)
      implicit none
      real*8 gr(nr),gk(nk),rv(nr),rkv(nk)
      real*8 g0,wt,bessj0
      integer nr,nk,ndim,k,i
c puts the  transform of gr into gk (from 0 to rv)
c     integral of cos(kr)*gr(r)     if ndim=1
c     integral of jo(kr) *gr(r)     if ndim=2
c     integral of sin(kr)*gr(r)     if ndim=3
 
      g0=0.
      if(ndim.eq.1)g0=.5*gr(1)*rv(1)
      do k=1,nk
       gk(k)= g0
      enddo
 
      do 1 i=1,nr
       wt=.5*gr(i)
       if(i.eq.1) then
        wt=wt*rv(2)
       elseif(i.eq.nr) then
        wt=wt*(rv(nr)-rv(nr-1))
       else
        wt=wt*(rv(i+1)-rv(i-1))
       endif
 
       if(ndim.eq.1) then
        do  k=1,nk
         gk(k)=gk(k)+wt*cos(rv(i)*rkv(k))
        enddo
       elseif(ndim.eq.2) then
        do  k=1,nk
         gk(k)=gk(k)+wt*bessj0(rv(i)*rkv(k))
        enddo
       elseif(ndim.eq.3) then
        do  k=1,nk
         gk(k)=gk(k)+wt*sin(rv(i)*rkv(k))
        enddo
       endif

1     continue
      return
      end
