      subroutine mdlng(ndim,p,ell,e2,v)
c Computes the madelung constant for r**-p interaction in ndim dimensions.
      implicit real*8 (a-h,o-z)
      dimension ell(ndim),icount(3)
      pi=3.1415 92653 58979
c This is accuracy of the constant. (but check how accurate gammi is?)
      eps=1.e-9
      limit=1+sqrt(-log(eps)/pi)
      vol=1.  
      do l=1,ndim
          vol=vol*ell(l)
          icount(l)=-limit
      enddo

      alpha=pi*vol**(-2./ndim)

      g5=gamma(.5*p)
      v1=-2*alpha**(.5*p)/(p*g5)
      v2=-2*pi**(.5*ndim)/((ndim-p)*vol*g5*alpha**(.5*(ndim-p)))
      v=v1+v2 

      do 2 i=1,(2*limit+1)**ndim
      r2=0.   
      rk2=0.
      do l=1,ndim
           r2=r2+(icount(l)*ell(l))**2
           rk2=rk2+(2*pi*icount(l)/ell(l))**2
      enddo
      if(r2.gt.0)  then
         p2=.5*p 
         call gammi(gr,p2,alpha*r2,gr0)
         call gammi(gk,.5*(ndim-p),rk2/(4.*alpha),gk0)
         v=v+pi**(.5*ndim)*(4./rk2)**(.5*(ndim-p))*gk/(vol*gr0)
     +       +gr/(gr0*r2**(p2))
      endif

      do 5 l=1,ndim
      icount(l)=icount(l)+1
      if(icount(l).le.limit) go to 2
5     icount(l)=-limit

2     continue

c multiply by charged**2
      v=v*e2
      return
      end
