      subroutine backflow(it,rtl,refpt,sdetc,imt,detlog)
      include 'upi.cm'
      integer itype,ispin,nfirst,nf,im,idiff,
     . it,ntime,la,lb,i,imt,j,i1,icmax,ic,etaexp
      parameter (etaexp=5)
      real*8 refpt(ndim,mnp),bfdnode,sdetc,det(2),rtl(ndim,mnp)
     .   ,quasinew(ndim,mnp),quasiref(ndim,mnp),detlog
     . ,dxj(ndim,mnp,2),rj(mnp,2),eta(mnp,2),etahat(mnp,2)
     . ,temp,x2,x4,e2,amat(ndim,ndim,mnp,mnp)
     . , eta0,eta0hat,eta1,eta1hat,etaf
      include 'cpbc.cm'

      idiff=iabs(ntime(it,iref,irev,nslices))
      if(idiff.eq.0) then
         write (*,*)' idiff 0 in backflow'
         stop
      endif

      icmax=2
      if(iref.eq.0)icmax=1
       etaf=bfp(5)*(idiff*tau)**2

! compute quasi-coordinate s
      do i=1,nparts
      do la=1,ndim
        quasinew(la,i)=rtl(la,i) ! non-backflow term
        quasiref(la,i)=refpt(la,i) ! non-backflow term
        gradnode(la,i,it,imt)=0.d0 !gradient of product of determinants
        do lb=1,ndim
        do j=1,nparts
          amat(la,lb,i,j)=0.d0
        enddo
        enddo
          amat(la,la,i,i)=1.d0
      enddo
        if(i.gt.1.and.bfp(1).ne.0.d0) then !pair interactions 
        i1=i-1

        do ic=1,2  !loop over two endpoints

        if(ic.eq.1) then
        call deltar(rtl(1,i),rtl,dxj,rj,i1,ndim,nprojn,projn) ! find distances and differences
                         ! rj is distance dxj(j)=r(i)-r(j)
        else
        call deltar(refpt(1,i),refpt,dxj(1,1,2),rj(1,2),i1,ndim
     .          ,nprojn,projn) 
        endif

        do j=1,i1 ! explicit coding of bf function=eta and its derivative/r=etahat
          x4=min(rj(j,ic)-bfp(4),0.d0)
          x2=rj(j,ic)-bfp(2)
          e2=bfp(1)*exp(-bfp(3)*x2*x2)*x4*x4
          eta(j,ic)=e2*x4
          etahat(j,ic)=(3.d0-2.d0*bfp(3)*x2*x4)*e2/rj(j,ic)
        enddo

! for time dependant bf we need to scale it
        if(iref.gt.0) then
        do j=1,i1
          if(rj(j,ic).lt.bfp(4)) then
          eta0=eta(j,ic)
          eta0hat=etahat(j,ic)
          eta1=etaf/rj(j,ic)**etaexp
          eta1hat=eta1/rj(j,ic)**2
          eta(j,ic)= eta0*eta1/(eta0+eta1 )
          etahat(j,ic)=eta0*eta1*eta(j,ic)*(eta0hat*eta1 + eta1hat*eta0)
          endif
        enddo
        endif
        enddo ! end of loop over ic

        do la=1,ndim
          do j=1,i1
           temp=eta(j,1)*dxj(la,j,1) !for non-ref point
           quasinew(la,i)=quasinew(la,i)+temp
           quasinew(la,j)=quasinew(la,j)-temp

           if(iref.ne.0) then
             temp=eta(j,2)*dxj(la,j,2) !for reference point
             quasiref(la,i)=quasiref(la,i)+temp
             quasiref(la,j)=quasiref(la,j)-temp
           endif

           temp=eta(j,1)
           amat(la,la,i,j)=amat(la,la,i,j)-temp
           amat(la,la,j,i)=amat(la,la,j,i)-temp
           amat(la,la,i,i)=amat(la,la,i,i)+temp
           amat(la,la,j,j)=amat(la,la,j,j)+temp
           do lb=1,ndim
           temp=etahat(j,1)*dxj(la,j,1)*dxj(lb,j,1)
           amat(la,lb,i,j)=amat(la,lb,i,j)-temp
           amat(la,lb,j,i)=amat(la,lb,j,i)-temp
           amat(la,lb,i,i)=amat(la,lb,i,i)+temp
           amat(la,lb,j,j)=amat(la,lb,j,j)+temp
           enddo
          enddo
        enddo
        endif

      enddo

      do i=1,nparts
      do la=1,ndim
        quasinew(la,i)=fpbc(quasinew(la,i),la)
        quasiref(la,i)=fpbc(quasiref(la,i),la)
      enddo
      enddo

      detlog=0.d0 !  log of the product of determinants
      sdetc=savesign ! savesign is old sign
!     sdetc=1.d0
!sdetc = product of changes in determinants

      do itype=1,ntypes
      do ispin=1,nspins(itype)
      nfirst=nfpss(ispin,itype)
      nf=nppss(ispin,itype)
      im=imatno(ispin,itype)
       call ofill(nf,nfirst,quasinew(1,nfirst),fdenmat(im,1,it,imt)
     +               ,mmsize,iref,iabs(idiff),quasiref(1,nfirst),1)

       call invert(nf,fdenmat(im,1,it,imt)
     +                ,fdenmat(im,ndim2,it,imt),det)
       detlog=detlog+det(2)
       sdetc=sdetc*det(1)
        dstnode(ispin,itype,it,imt) = bfdnode(amat,fdenmat(im,1,it,imt)
     . ,rtl(1,nfirst),ispin,itype,ipopt,gradnode(1,nfirst,it,imt) )
!    . ,rtl(1,nfirst),ispin,itype,ipopt,gradnod(1,1,ispin,itype,it,imt)) !CHANGE


        enddo
        enddo

      return
      end
