      subroutine codrift(nmovers,movers,rl,rmid,ilv,wdthl,covar,drift
     +   ,nv)
      include 'upi.cm'
      integer nmovers,movers,ilv,nv,indx,k,ipn,j1,itype,jpn,mi,j
      integer la,lb,mj,l,il,i
      real*8 rl,rmid,wdthl,covar,drift,p1,rem,rold,p2,dx,dxmag,sp1,dd2
      real*8 dd,dum,dxdr
      dimension p1(mnp),rem(mnp)
      dimension rold(ndim,mnmovers),p2(mnp),dx(ndim,mnp),dxmag(mnp)
      dimension indx(mnp),dxdr(mnp)
      dimension rmid(ndim,mnmovers),rl(ndim,nparts)
      dimension covar(nv,nv),drift(ndim,mnmovers), movers(nmovers)
      include 'cpbc.cm'
c  rmid is the midpoint of the free particle distribution.
c drift and covariance (output) are computed from samtab1 and samtab2
c ilv is the level, nv=nmovers*ndim
c wdthl is the width of free particle gaussian for this mover;
c the convention is that only the lower triangular part of the
c (symmetric) covariance matrix is computed and used
      k=0
      do 10 ipn=1,nmovers
      do 10 l=1,ndim
           k=k+1
           covar(k,k)=wdthl
           do j1=k+1,nv
              covar(j1,k)=0.
           enddo
c save original value of rl
           rold(l,ipn)=rl(l,movers(ipn))
c insert midpoint into rl so distances from midpoint will be calculated
           rl(l,movers(ipn))=rmid(l,ipn)
10    drift(l,ipn)=0.

      itype=idtype(movers(1))
      if(mod(ifsamp(itype),2).eq.1) then
c note that if level requested is not in table we go to lower tau.
      il=min(ilv,nlvld)
c find drift and covariance matrix 
      do 30 ipn=1,nmovers
          call deltar(rmid(1,ipn),rl,dx,dxmag,nparts,ndim,nprojn,projn)
          call tentry(dxmag,nparts,itype,indx,rem,dxdr)
c push self-interaction out of range of table
          indx(movers(ipn))=1
c for comovers map into second table
          do jpn=ipn+1,nmovers
               indx(movers(jpn))=indx(movers(jpn))+mntab
          enddo
c gather up first and second derivatives
          sp1=0.
          do i=1,nparts
              p1(i)=samtab1(indx(i),1,il)
              p2(i)=samtab2(indx(i),1,il)
              sp1=sp1+p1(i)
          enddo

          sp1=sp1*wdthl
c this is for the drift
          do 80 l=1,ndim
          do 80 i=1,nparts
80        drift(l,ipn)=drift(l,ipn)+p1(i)*dx(l,i)
c and this for the covariance
c         if(ilv.eq.1) then
          mi=(ipn-1)*ndim
          do l=1,ndim
            covar(mi+l,mi+l)=covar(mi+l,mi+l)+sp1
          enddo

          do 100 j=1,nparts
             dd2=p2(j)
             do 100 la=1,ndim
             do 100 lb=1,la
100       covar(mi+la,mi+lb)=covar(mi+la,mi+lb)+dd2*dx(la,j)*dx(lb,j)

c now add off diagonal elements with other movers
          do 110 jpn=ipn+1,nmovers
              j=movers(jpn)
              dd=p1(j)
              dd2=p2(j)
              mj=(jpn-1)*ndim
                  do 110 la=1,ndim
c first diagonal elements
                  covar(mj+la,mi+la)=-(dd+dd2*dx(la,j)*dx(la,j))
                  do 110 lb=1,la-1
c thereafter off-diagonal elements
                  dum=-dd2*dx(la,j)*dx(lb,j)
                  covar(mj+la,mi+lb)=dum
110               covar(mj+lb,mi+la)=dum
c     endif

30    continue
      endif

c restore rl to original value
      do 120 ipn=1,nmovers
      do 120 l=1,ndim
120   rl(l,movers(ipn))=rold(l,ipn)

      return
      end
