      subroutine fdminit(ireft,irevt,pnx,ich)
c ireft is the trial reference point, pnx will be the probablity of not crossing
c if ich>0 print out if nodal distances have changed
      include 'upi.cm'
      integer ireft,irevt,ich,ncalls,it,is,nf,nfirst,im,idiff,n2
      integer ntime,i,l,j,num
      real*8 pnx,hbi,refpt,tm,det,dnow,dnode
      real*8 dleak,rmin,trhok,tpwmat,sdetc,detlog
      dimension det(2),tm(mmsize,ndim2),refpt(ndim,mnp)
     +,trhok(mnkv2,mnc),tpwmat(mnkv2,mnp)
      save ncalls
      include 'cpbc.cm'

       data ncalls/0/
c for stopping at a particular step
       ncalls=ncalls+1
       if(ncalls.ge.nstop) call stopper(ncalls,nstop)

c initialize/check plane waves and rhok
      if(nvects.gt.0) then
        do i=1,nslices
         if(ich.ge.1.and.idebug.ge.2) then
          do it=1,ntypes
           call scopy(2*nvects,rhok(1,it,i),1,trhok(1,it),1)
          enddo
          do j=1,nparts
           call scopy(2*nvects,pwmat(1,j,i),1,tpwmat(1,j),1)
          enddo
         endif
         call rhokall(r(1,1,i),rhok(1,1,i),pwmat(1,1,i),nvects)
         if(ich.ge.1.and.idebug.ge.2) then
          do j=1,nparts
           call checkm(2*nvects,pwmat(1,j,i),tpwmat(1,j),i,ich*2)
          enddo
          do it=1,ntypes
           call checkm(2*nvects,rhok(1,it,i),trhok(1,it),i,ich)
          enddo
         endif
        enddo
      endif
c initialize fermion sign
      call cycle(0)
c initialize winding numbers
      call wind(0)
      call windup(0,ireft,irevt)

c pnx  will be exp(-action)  resulting from the nodes
      pnx=1.d0

      if (ifixnd.eq.1) then !do the rest for fixed node only

        if(ireft.ne.0) then
c set up reference point
         do l=1,ndim
          do i=1,nparts
            if(ireft.eq.join)refpt(l,i)=rperm(l,i)
            if(ireft.ne.join)refpt(l,i)=r(l,i,ireft)
          enddo
          enddo
        endif
      

      if(ifabf) then ! back flow case
         savesign=1.d0
         do i=1,nslices
         idiff=ntime(i,ireft,irevt,nslices)
         if(idiff.ne.0) then
            call backflow(i,r(1,1,i),refpt,sdetc,imatf,detlog)

            if(ireft.eq.0) then
              if(i.gt.1) then
                if(sdetc.le.0.d0)
     .          write (*,*)'problem with savesign in fdminit',i,sdetc
              else
                  if(sdetc.lt.0.d0) savesign=-1.d0
              endif
            else
               if(sdetc.le.0.d0) 
     .         write (*,*)'problem with savesign in fdminit'
            endif	

         else ! at reference point this is a bound.
         do it=1,ntypes
         do is=1,nspins(it)
            nf=nppss(is,it)
            nfirst=nfpss(is,it)
            dstnode(is,it,i,imatf)=
     .        rmin(r(1,nfirst,i),ndim,nf,gradnode(1,nfirst,i,imatf))
          enddo
          enddo
         endif

         enddo ! end of nslices
      else !decoupled columns

      do it=1,ntypes
      do is=1,nspins(it)

        hbi=1.d0/(hbs2m(it)*tau)
        nf=nppss(is,it)
        nfirst=nfpss(is,it)
        im=imatno(is,it)


c find determinant and nodal distance for this link
        do i=1,nslices ! loop over time slices starting at the ref point
         idiff=ntime(i,ireft,irevt,nslices)

         if(idiff.ne.0) then

c copy out to test if it has changed
          if(ich.ge.1.and.idebug.ge.2) then
            n2=nf*nf
            do 55 l=1,ndim2
55          call scopy(n2,fdenmat(im,l,i,imatf),1,tm(1,l),1)
          endif

          call ofill(nf,nfirst,r(1,nfirst,i),fdenmat(im,1,i,imatf)
     +               ,mmsize,ireft,iabs(idiff),refpt(1,nfirst),1)

          call invert(nf,fdenmat(im,1,i,imatf)
     +                ,fdenmat(im,ndim2,i,imatf),det)

          if(ich.ge.1.and.idebug.ge.2) then
           do 56 l=1,ndim2
56         call checkm(n2,fdenmat(im,l,i,imatf),tm(1,l),l,ich)
           call scopy(nf*ndim,gradnode(1,nfirst,i,imatf),1,tm,1) !to check gradients
          endif

c check sign
c plane wave case
          if(ireft.eq.0) then
           if(i.gt.1) then
            if(savesign*det(1).le.0.d0) then
             pnx=0.d0
             go to 200
            endif
           endif
           savesign=det(1)

c time-dependent case
          else
           if(det(1).le.0.d0) then
            pnx=0.d0
            go to 200
           endif
          endif

c now find the distance to the node
          dnow=dnode(nf,fdenmat(im,1,i,imatf),mmsize,ndim,ipopt
     +               ,r(1,nfirst,i),gradnode(1,nfirst,i,imatf))
          if(ich.ge.1.and.idebug.ge.2)  !check if gradients are correct
     &     call checkm(nf*ndim,gradnode(1,nfirst,i,imatf),tm,100,ich)
         else
c at reference point this is a bound.
          dnow=rmin(r(1,nfirst,i),ndim,nf,gradnode(1,nfirst,i,imatf))
         endif

          if(ich.ne.0.and.
     +       abs(dnow-dstnode(is,it,i,imatf)).gt.1.e-4*ell(1))
     +       then
           write (*,*)' fdm node error ',ncalls,i,ich,ireft,is,it,dnow
     +                ,dstnode(is,it,i,imatf)
            stop
          endif

c now find the nodal action
        if(i.gt.1)pnx=pnx*dleak(0,dstnode(is,it,i-1,imatf)*dnow*hbi)
        dstnode(is,it,i,imatf)=dnow
        enddo
c finish up last link
        pnx=pnx*dleak(0,dnow*dstnode(is,it,1,imatf)*hbi)

      enddo
      enddo

      endif ! end of backflow/no backflow

      endif ! end if fixed-node stuff
c exit in case determinant is negative
200   continue
!     if(ich.ge.1)then
!       if(abs(pnx/actnode-1.).gt.1.e-3) then
!        write (*,*)' action not right in fdminit',ncalls,pnx,actnode
!        stop
!       endif
!     endif

!     write (*,*) 'finished fdminit'
!     write (*,'(10f10.5)') ((dstnode(l,1,i,imatf),i=1,nslices),l=1,2)
!     do j=1,nslices
!     do i=1,nparts
!     write (*,'(2i3,3f10.5)')j,i,(gradnode(l,i,j,imatf),l=1,ndim)
!     enddo
!     enddo
!     stop
      actnode=pnx
      return
      end
