      subroutine goffd(ip,r1,r2,v1,v2,lvl,act,g1,g2,comp,vel)
      include 'upi.cm'
      real*8 r1(mnp),r2(mnp),g1(ndim,mnp),g2(ndim,mnp),r1i,r2i,u1,u2
     +,v1(ndim,mnp),v2(ndim,mnp),act,comp(mnc)
     +,var(mnp,mterms+1),remx(mnp),rb(mnp),dxdr(mnp)
     + ,us(mnp),uz(mnp),uq(mnp),vel(ndim,mnp)
     ., dvel,dd
      integer ip,nterme,nterma,j,l,it,jt,n1,n2,idim,nfile,lvl
     +,indx(mnp),nn

       include 'cpbc.cm'
c this computes the off-digonal part of the log of the density matrix
c goffd is like offd but it computes gradients and beta derivatives only.
c r1 and r2 are the old and new distances, v1 and v2 are the vectors
c and ip is the particle being moved. There are ip-1 terms added
c lvl is level and type specific energy is stored in comp
c g1 and g2 are the gradients of the action at points r1 and r2 (they are incremented).

!     do j=1,ip-1 ! test out the distances !DEBUG ONLY
!     do l=1,ndim
!     dvel=vel(l,j)-vel(l,ip)
!     dd=fpbc(v1(l,j)-v2(l,j),l)
!     if(abs(dvel-dd).gt.1.e-5)
!    .    write (*,'(a6,2i2,6f12.5)')'goffd ',j,l,dvel,dd
!     enddo
!     enddo

      it=idtype(ip)
      do jt=1,it ! loop over types of particles
      nfile=pairtof(it,jt)
      comp(jt)=0.
c first last and total number of particles of this type
      n1=nfpty(jt)
      n2=min(ip-1,nlpty(jt))
      nn=n2-n1+1
      if(nfile.gt.0.and.nn.gt.0) then

        nterma=ipfilep(3,nfile)-1
        nterme=ipfilep(4,nfile)-1
        if(max(nterma,nterme).gt.0) then
          idim=ipfilep(2,nfile)
          if(lvl.gt.nlvld)stop

       ! set 3 variables rb var(1) and var(2)
          do j=n1,n2
            rb(j)=.5*(r1(j)+r2(j)) ! rb=q
            var(j,1)=(vel(1,j)-vel(1,ip))**2 ! var(1) = s
            var(j,2)=(r1(j)-r2(j))**2 ! var(2) = z
          enddo
          do l=2,ndim
            do j=n1,n2
              var(j,1)=var(j,1)+(vel(l,j)-vel(l,ip))**2
            enddo
          enddo

c get table indices for rb
          call tentry1(rb,n1,n2,nfile,indx,remx,dxdr)

c us uz and uq will hold the derivatives wrt to the variables
          call gvsum(nn,indx(n1),remx(n1),dmtable(1,1,2,lvl,1)
     &         ,var(n1,1),nterma,nterme,mnp,mntab,morder,mterms,mlevels
     &         ,idim,us(n1),uz(n1),uq(n1),dxdr(n1),rb(n1),act,comp(jt))


c now compute g1 and g2 using chain rule
      do j=n1,n2
      r1i=1.d0/r1(j)
      r2i=1.d0/r2(j)
      do l=1,ndim
        u1= 2.d0*us(j)*(vel(l,j)-vel(l,ip))
     +          +r1i*v1(l,j)*(.5d0*uq(j)+2.d0*uz(j)*(r1(j)-r2(j)))
        g1(l,ip)=g1(l,ip)+u1
        g1(l, j)=g1(l, j)-u1

        u2=-2.d0*us(j)*(vel(l,j)-vel(l,ip))
     +          +r2i*v2(l,j)*(.5d0*uq(j)-2.d0*uz(j)*(r1(j)-r2(j)))
        g2(l,ip)=g2(l,ip)+u2
        g2(l, j)=g2(l, j)-u2
      enddo
      enddo

      endif
      endif
      enddo
      return
      end

