      subroutine pairact(itorg,itspan,lvl,act,gradt,vel)
c calculate pair link actions and gradients starting
c itorg= first time slice
c itspan= total number of time slices computed
c 2**lvl = spacing between time slices 
      include 'upi.cm'
      integer itorg,itspan,lvl,ilvl,k,js,ls,it,i1,is,l,i,indx(mnp),j
     +,jt, idn,num,itm,ind,iother,me
cdmc me is for the kinetic energy term
      parameter (me=2)
      real*8 rj(mnp,2),dxj(ndim,mnp,2),gradt(ndim,mnp,0:mslices)
     +,act,remx(mnp),dxdr(mnp),pact,fr,ddm(mnp),tp,dmcomp(mnc)
     +,v,vir,ht,s,vsum0,psi,grad2(mnc),gradd(ndim,mnp,0:mslices)
     +,vel(ndim,mnp,mslices)

      ilvl=2**(lvl-1)

c zero the interaction and the gradient.
      act=0.d0
      do js=0,itspan
      do l=1,ndim
        do i=1,nparts
             gradt(l,i,js)=0.d0
             gradd(l,i,js)=0.d0
        enddo
      enddo
      enddo
      do it=1,ntypes
          grad2(it)=0.d0
      enddo

c calculate pair interactions
      if(npfilen.gt.0) then
      do i=1,nparts
        it=idtype(i)
c loop over smaller labeled particles
        i1=i-1

c 'is' is place where distances (rj dxj) are kept = 1,2
      k=itorg
      is=1
      do js=0,itspan

c find distances at k for particles with a smaller index and put them in is
      is=3-is

!     if(k.eq.join) then
!         call deltar(rperm(1,i),rperm,dxj(1,1,is),rj(1,is),i1,ndim
!    &               ,nprojn,projn)
!     else
          call deltar(r(1,i,k),r(1,1,k),dxj(1,1,is),rj(1,is),i1,ndim
     &               ,nprojn,projn)
!     endif
      if(k.eq.join.and.js.ne.itspan) then
         write(*,*)' problem in pairact ',k,js,join
         stop
       endif

        
      if(js.gt.0) then
          ls=3-is
          call goffd(i,rj(1,ls),rj(1,is),dxj(1,1,ls),dxj(1,1,is)
     +    ,lvl,act,gradt(1,1,js-1),gradt(1,1,js),dmcomp,vel(1,1,js))
      endif

c calculate endpoint part
      if(js.gt.0.and.js.lt.itspan) then
      call tentry(rj(1,is),i1,it,indx,remx,dxdr)

      do jt=1,it
           idn=nfpty(jt)
           num=min(nlpty(jt),i1) -idn +1
           call vandvir(num,indx(idn),remx(idn),vtable,mntab,v,vir
     +                 ,dxdr(idn))
           avtemp(jpeij(jt,it))=avtemp(jpeij(jt,it))+v*psign
           avtemp(jpress)=avtemp(jpress)+vir*psign
           ht=hbs2m(it)+hbs2m(jt)
           if(ht.ne.0) then
c determine the beta derivative of the action
            s=vsum0(num,indx(idn),remx(idn),dmtable(1,1,1,lvl,me),mntab)
            if(js.gt.0) s=s+dmcomp(jt)
c put in fractions
             if(hbs2m(it).gt.0.)
     &       avtemp(jke(it)+2)=avtemp(jke(it)+2)+s*psign*hbs2m(it)/ht
             if(hbs2m(jt).gt.0.)
     &       avtemp(jke(jt)+2)=avtemp(jke(jt)+2)+s*psign*hbs2m(jt)/ht
           endif
      enddo


c add to pair correlation function
      if(iref.eq.0.or.(k.eq.iref.or.k.eq.iother)) then
c note that we have not implement Carlo's spin dependance
        if(i.eq.1) grcnt=grcnt+psign
        psi=lptable/el2max
        itm=it*(it-1)/2

        do jt=1,it
        itm=itm+1

c general pointer table
c       ik=igtable(i)
c       do l=1,ngtype
c         itm=igpnt(l,ik)
c         do j=nfg(l,ik),min(i1,nlg(l,ik))

          do j=nfpty(jt),min(i1,nlpty(jt))
            ind=1+psi*rj(j,is)
            if(ind.le.lptable) grsum(ind,itm)=grsum(ind,itm)+psign
          enddo
        enddo
      endif

      call gradtabl(i1,indx,remx,dmtable(1,1,1,lvl,1),ddm
     &                  ,mntab,dxdr,rj(1,is),pact)
         act=act+pact

           do  l=1,ndim
            do  j=1,i1
             tp=dxj(l,j,is)*ddm(j)
             jt=idtype(j)
             grad2(it)=grad2(it)+tp**2
             grad2(jt)=grad2(jt)+tp**2
             gradd(l,j,js)=gradd(l,j,js)-tp
             gradd(l,i,js)=gradd(l,i,js)+tp
            enddo
          enddo

      if(ifewald.ne.0) then
        call gradew(rhok(1,1,k),pwmat(1,1,k),gradd(1,1,js),lvl,pact)
          act=act+fr*pact
      endif
      endif

      k=k+ilvl
      if(k.gt.nslices)k=k-nslices
c end of js loop
      enddo
c end of particle loop
      enddo
c end of pair computation
      endif
!     do i=1,nparts
!     write (*,'(i5,6f10.3)')i
!    .,(gradt(l,i,itspan-1),l=1,ndim)
!    .,(gradd(l,i,itspan-1),l=1,ndim)
!     enddo

c combine end-point and off-diagonal and find diagonal-force^2
      do it=1,ntypes
      do js=1,itspan-1
      do l=1,ndim
      do i=nfpty(it),nlpty(it)
         grad2(it)=grad2(it)-gradd(l,i,js)**2
         gradt(l,i,js)=gradt(l,i,js)+gradd(l,i,js)
      enddo
      enddo
      enddo
        avtemp(jke(it)+3)=avtemp(jke(it)+3)+.25*hbs2m(it)*grad2(it)
      enddo

      return
      end
