      subroutine ptable(ipf,ipv,iorg,ispan)
      include 'upi.cm'
      real*8 hpmin,hppmin,dx,wi,hij,hperm,hi,pp,ppk,hijg3,hijg4
     +   ,hp3cut,hp4cut,hmax
      integer ipf,ipv,iorg,ispan,nptm,itar,it,is,j,jp,k,l,i,n1,np
      parameter(hpmin=1.e-5,hppmin=1.e-5)
c the table will be set for the permutation ipv
c between slices iorg and itar;
c generated table will be stored in location ipf
      dimension ipv(mnp),dx(ndim,mnp),hperm(mnp,mnp)
      include 'cpbc.cm'

      if(mnmovers.le.1)stop
c target time
      itar=iwrap(iorg+ispan)
c number of permutations  and probability so far
      nptm=0
      cump(0,ipf)=0.

      do 5 it=1,ntypes
       if(hbs2m(it).gt.0. .and. nspins(it).ge.0) then
        wi=.25/(hbs2m(it)*tau*ispan)
c set up hperm table. rperm contains the permuted coordinates
c dx the unpermuted ones
        do 15 is=1,max(1,nspins(it))
        np=nlpss(is,it)-nfpss(is,it)+1
        n1=nfpss(is,it)
         do 20 j=n1,nlpss(is,it)
          jp=ipv(j)
          do 20 l=1,ndim
           dx(l,j)=rperm(l,jp)
20       continue
     
      call distable(r(1,n1,iorg),dx(1,n1),np,hperm(n1,n1),mnp,ndim,wi
     +     ,1,hperm)

c divide out by diagonal
         hmax=0.
         do 50 i=nfpss(is,it),nlpss(is,it)
          hi=1./hperm(i,i)
c elements less than hpmin will be deleted
          hperm(i,i)=0.
          do 50 j=nfpss(is,it),nlpss(is,it)
           if(hperm(i,j).lt.hpmin) then 
            hperm(i,j)=0. 
           else 
            hperm(i,j)=hi*hperm(i,j) 
           endif 
           hmax=max(hmax,hperm(i,j))
50       continue
         if (hmax.gt.0.) then
           hp3cut=hppmin/hmax**2
           hp4cut=hppmin/hmax**3
         else 
           hp3cut = 0.
           hp4cut = 0.
         end if

c single particle moves
         if(gamma(1,it).gt.0.) then
          do 60 i=nfpss(is,it),nlpss(is,it)
           nptm=nptm+1
           cump(nptm,ipf)=cump(nptm-1,ipf)+gamma(1,it)
           lenp(nptm,ipf)=1
           nmvr(1,nptm,ipf)=i
60        continue
         endif

         do 10 i=nfpss(is,it),nlpss(is,it)-1
c look for j's sufficently close; j is the '2nd' particle
          do 10 j=i+1,nlpss(is,it)
           hij=hperm(i,j)

           if(hij.gt.0.) then
c worthwhile to try

            pp=hij*hperm(j,i)*gamma(2,it)
            if(pp.gt.hppmin) then
             nptm=min(nptm+1,mspermt)
             cump(nptm,ipf)=cump(nptm-1,ipf)+pp
             lenp(nptm,ipf)=2
             nmvr(1,nptm,ipf)=i
             nmvr(2,nptm,ipf)=j
            endif

c now look for triplets
           if(mnmovers.lt.3) go to 10
             hijg3=hij*gamma(3,it)
            if(hijg3.gt.hp3cut) then
             do 70 k=i+1,nlpss(is,it)
              pp=hijg3*hperm(j,k)*hperm(k,i)
              if(pp.gt.hppmin) then
               nptm=min(nptm+1,mspermt)
               cump(nptm,ipf)=cump(nptm-1,ipf)+pp
               lenp(nptm,ipf)=3
               nmvr(1,nptm,ipf)=i
               nmvr(2,nptm,ipf)=j
               nmvr(3,nptm,ipf)=k
              endif
70           continue
            endif
ccc
          if(mnmovers.lt.4) go to 10
c now look for quadruplets
          hijg4=hij*gamma(4,it)
          if(hijg4.gt.hp4cut) then
          do 80 k=i+1,nlpss(is,it)
              ppk=hijg4*hperm(j,k)
              if(ppk.gt.hp3cut) then
              do 90 l=i+1,nlpss(is,it)
                if(l.ne.j ) then
                  pp=ppk*hperm(k,l)*hperm(l,i)
                  if(pp.gt.hppmin) then
                    nptm=min(nptm+1,mspermt)
                    cump(nptm,ipf)=cump(nptm-1,ipf)+pp
                    lenp(nptm,ipf)=4
                    nmvr(1,nptm,ipf)=i
                    nmvr(2,nptm,ipf)=j
                    nmvr(3,nptm,ipf)=k
                    nmvr(4,nptm,ipf)=l
                  endif
                endif
   90         continue
            endif
   80     continue
        endif
ccc
           endif
10      continue
15     continue
       endif
5     continue

c keep track of total number of permutations
      nprmx=max(nprmx,nptm)
      nprm(ipf)=nptm
      if(nptm.ge.mspermt) then
        write(*,*)' over flow of permutation table in ptable ',nptm
        stop
      endif
      return
      end
