      subroutine tentry(rl,n,it,indx,rem,rdxdr)
      include 'upi.cm'
      real*8 rl,rem,rdxdr,yy,aa,x,rlim
      integer it,indx,n1,n2,jt,ig,j,n,nfile
      dimension rl(n),indx(n),rem(n),rdxdr(n)
c finds the table entry between a particle of it type and n other
c particles whose distance is in rl. rdxdr is rdx/dr
c the other particles are labelled 1 through n
      do jt=1,ntypes
      n1=nfpty(jt)
      n2=min(n,nlpty(jt))
      if(n1.gt.n2)return
c find relevant grid type
      nfile=pairtof(jt,it)

      if(nfile.gt.0) then
      ig=ipfilep(1,nfile)

      if(ig.eq.1) then
c linear grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          x= rpfilep(4,nfile)+rpfilep(3,nfile)*rlim
          indx(j)=x
          rem(j)=x-indx(j)
          rdxdr(j)=rpfilep(3,nfile)*rl(j)
        enddo

      elseif(ig.eq.2) then
c log grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          x=rpfilep(4,nfile)+rpfilep(3,nfile)*log(rlim) 
          indx(j)=x
          rem(j)=x-indx(j)
          rdxdr(j)=rpfilep(3,nfile)*rl(j)/rlim
        enddo

      elseif(ig.eq.3) then
c power grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          aa=rpfilep(3,nfile)*(rlim-rpfilep(4,nfile))
          yy=aa**rpfilep(5,nfile)
          x=rpfilep(6,nfile)+ yy
        indx(j)=x
        rem(j)=x-indx(j)
        rdxdr(j)= rl(j)*rpfilep(5,nfile)*rpfilep(3,nfile)*yy/aa
      enddo
      elseif(ig.eq.4) then
c inverse grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          aa=1./(rlim-rpfilep(5,nfile))
          x=rpfilep(4,nfile)+rpfilep(3,nfile)*aa
        indx(j)=x
        rem(j)=x-indx(j)
        rdxdr(j)=- rl(j)*aa*aa*rpfilep(3,nfile)
      enddo

      endif

      else

c zero interaction
      do j=n1,n2
         indx(j)=1
         rem(j)=0.
         rdxdr(j)=0.
      enddo

      endif
      enddo

      return
      end
