      subroutine weave(itorg,nmovers,movers,levels)
#define SIMPLE_SPRNG
#include "sprng_f.h"

c bisection algorithm for nmovers particles across levels slices
      include 'upi.cm'
      integer mpm,itys,isps
      parameter (mpm=mnp*mnmovers)
      integer itar,itype,imvr,ip,ipcyc,nv,inow,kk,kspan,kleft
     +,jdn,itorg,nmovers,levels,itspan,ndiv,kdiv
     +,jmid,jup,itmid,ipn,ic1,ispin,nanti,n2,nfirst
     +,lmat,imatp,jref,j,jint,it,idiff,ntime,ik,l1,l2,l,i,k
     +,ifw,iw(ndim)
     +,iptry(mnmovers),movers(mnmovers),ipermt(mnp)
      real*8 delu,sold,act1,snew,width,ap,accrat,wrap
     +,ratio,dmeval,rnodact,dold,dnew,rmin,deltac,swidth
     +,sdetc(mslices),sdetr(mslices),sprob(msamp+1)
     +,rmid(ndim,mnmovers),covar(mdmovers,mdmovers),drift(ndim,mnmovers)
     +,columns(mpm,ndim+1,mspan),sfree(mslices,2)
     +,refpt(ndim,mnp),rows(mpm,ndim+1,mslices),dum,rndnum

      include 'cpbc.cm'
c input: levels itspan nmovers movers itorg

c initialization ************************************************
c for debugging only
      if(idebug.ge.2)call fdminit(iref,irev,act1,1)

      itspan=2**levels
      itar=iwrap(itorg+itspan)
c implicit assumption that all movers are of the same type
      itype=idtype(movers(1))

c find ratio of trial density matrices
      if(nmovers.eq.1) then
        delu=0.
      else
       delu=log(ppermute)
      endif

c set up temporary arrays rt at endpoints
      do 10 imvr=1,nmovers
c for new path use a new cyclic permutation
       ip=movers(imvr)
       if(imvr.lt.nmovers)then
        ipcyc=movers(imvr+1)
       else
        ipcyc=movers(1)
       endif
       iptry(imvr)=iperm(ipcyc)
c rt contains the coordinates of the moving particles only. the time
c argument is 1 for the time origin etc.
c does not work if itorg=itar
       do 10 l=1,ndim
        rt(l,imvr,1,2)=r(l,ip,itorg)
        rt(l,imvr,itspan+1,2)=r(l,ipcyc,itar)
        rt(l,imvr,1,1)=r(l,ip,itorg)
        rt(l,imvr,itspan+1,1)=r(l,ip,itar)
10    continue

      nv=nmovers*ndim
c setting inddst to -1 is flag for dstnce that inddst is not initialized
      do 20 inow=1,2
       do 20 kk=1,itspan+1
        inddst(1,1,kk,inow)=-1
20    continue

c start of the bisection algorithm**************************************

      kspan=itspan
      ndiv=1
      do 30 kleft=levels,1,-1
c set starting point of bisection
      jdn=1
c time slice displacement
      kspan=kspan/2
c old/new action and sampling width at current level
      sold=0.
      snew=0.
      width=hbs2m(itype)*kspan*tau
c this is an effective sampling width
!     if(ifsamp(itype).eq.0) swidth=width*(1+sampar(itype,1)*kspan*tau)
!    +      /(1+sampar(itype,2)*kspan*tau)
!     if(ifsamp(itype).ne.0) swidth=width
      swidth=width
c loop over slices in one level
      do 40 kdiv=1,ndiv
c update mid/end point of bisection
      jmid=jdn+kspan
      jup=jmid+kspan
      itmid=iwrap(itorg+jmid-1)

c now sample for trial position inow=2
      call midpoint(rt(1,1,jdn,2),rt(1,1,jup,2),rmid,nmovers,ndim)
      if(ifsamp(itype).eq.0) then
!     if(kleft.gt.1) then
        call samfr(rmid,nmovers,ndim,rt(1,1,jmid,2),swidth,sprob(2)
     +  ,2,nsampw)
      else
        call codrift(nmovers,movers,r(1,1,itmid),rmid,kleft,width,covar
     +  ,drift,nv)
        call samcg(rmid,drift,covar,drfmax,nv,ndim,2,rt(1,1,jmid,2)
     +  ,sprob(2),width,nsampw)
       endif
       snew=snew+sprob(2)

c now compute reverse probability for old path
        do 322 ipn=1,nmovers
        do 322 l=1,ndim
322     rt(l,ipn,jmid,1)=r(l,movers(ipn),itmid)
        call midpoint(rt(1,1,jdn,1),rt(1,1,jup,1),rmid,nmovers,ndim)
      if(ifsamp(itype).eq.0) then
!     if(kleft.gt.1) then
        call samfr(rmid,nmovers,ndim,rt(1,1,jmid,1),swidth,sprob,1,1)
      else
        call codrift(nmovers,movers,r(1,1,itmid),rmid,kleft,width,covar
     +  ,drift,nv)
        call samcg(rmid,drift,covar,drfmax,nv,ndim,1,rt(1,1,jmid,1)
     +  ,sprob,width,1)
      endif
      sold=sold+sprob(1)

40    jdn=jup

c find actions for old and new paths
      ap=sold-snew-delu
c the calling order is crucial for the calculation of rhok
      dold= dmeval(itorg,itspan,kleft,1,nmovers,movers,sfree)
      dnew= dmeval(itorg,itspan,kleft,2,nmovers,movers,sfree(1,2))
      delu=dold-dnew
      ap=ap+delu
c accept or reject this level
      ntrys(kleft,nmovers,itype)=ntrys(kleft,nmovers,itype)+1
      if(ap.lt.log(sprng())) return
      nacc(kleft,nmovers,itype)=nacc(kleft,nmovers,itype)+1
30    ndiv=2*ndiv

c for multiparticle moves do we accept permutation step?
      if(nmovers.gt.1.and.iptblnow.gt.0) then
        do 60 i=1,nparts
60      ipermt(i)=iperm(i)
        do 70 ipn=1,nmovers
70      ipermt(movers(ipn))=iptry(ipn)
c put trial permutation table in the other location in cump
        ic1=3-iptblnow
        call ptable(ic1,ipermt,itorg,itspan)
c accept or reject the permutation move
        accrat=cump(nprm(iptblnow),iptblnow)/(cump(nprm(ic1),ic1)
     &         *ppermute)
        ntrysp(nmovers,itype)=ntrysp(nmovers,itype)+1
        if(sprng().gt.accrat) return
        naccp(nmovers,itype)=naccp(nmovers,itype)+1
      endif

! START OF FERMION CODE
      if(nspins(itype).gt.0.and.ifixnd.eq.1)then
        ispin=idspin(movers(1))   ! first we get pointers for matrices
        nanti=nppss(ispin,itype)  ! nanti is number of particles in this spin state
        n2=nanti**2               ! size of slater matrices
        nfirst=nfpss(ispin,itype) ! first particle in spin state
        lmat=imatno(ispin,itype)  ! pointer to memory address of matrix
        imatp=3-imatf             ! imatf is current matrix, imatp is 'trial' matrix

          !jref=time slice of reference point relative to the origin values=(2,...,itspan) 
        jref=0                     ! jref=0 means not a reference point move
        if(iref.ne.0) then  ! iref=0 means ground state nodes
          j=iref-itorg+1
          if(j.le.1) j=j+nslices
          if(j.lt.itspan+1) jref=j
c put reference point in refpt
           if(jref.eq.0) then
           do 820 l=1,ndim
           do 820 i=1,nparts
           if(iref.eq.join) refpt(l,i)=rperm(l,i)
820        if(iref.ne.join) refpt(l,i)=r(l,i,iref)
           else
           do 825 i=1,nparts
           do 825 l=1,ndim
825        refpt(l,i)=rtrial(l,i,jref)
           endif
        endif

      if(jref.eq.0)then
         ntrysx(nmovers,itype)=ntrysx(nmovers,itype)+1
      else
         ntrysf(nmovers,itype)=ntrysf(nmovers,itype)+1
      endif

c find new columns and update the inverses
      do jint=2,itspan
      it=iwrap(itorg+jint-1)
      idiff=iabs(ntime(it,iref,irev,nslices))

      if(idiff.ne.0) then
        if(ifbf(itype)) then  ! backflow case
           call backflow(it,rtrial(1,1,jint),refpt,sdetc(it),imatp,dum)
           if(sdetc(it).le.0.d0) return
        else

         call ofill(nmovers,movers,rt(1,1,jint,2),columns(1,1,jint)
     +              ,mpm,iref,idiff,refpt(1,nfirst),1)
         call newup(fdenmat(lmat,1,it,imatf),fdenmat(lmat,1,it,imatp)
     +          ,columns(1,1,jint),dstnode(ispin,itype,it,imatp),nanti
     .          ,movers,nfirst
     +          ,nmovers,ndim,ipopt,mmsize,mpm,sdetc(it),idebug,1
     .          ,rtrial(1,nfirst,jint),gradnode(1,nfirst,it,imatp))
c reject node crossings
         if(sdetc(it).eq.0.d0) return
         if(sdetc(it).lt.0.d0.and.jref.eq.0) return
        endif
      else ! at the reference point
          do itys=1,ntypes
          do isps=1,nspins(itys)
            dstnode(isps,itys,it,imatp)=dstnode(isps,itys,it,imatf)
          enddo
          enddo
          dstnode(ispin,itype,it,imatp)=rmin(rtrial(1,nfirst,jint),ndim
     .     ,nanti,gradnode(1,nfirst,it,imatp))

      endif
      enddo ! end loop over moving time slices (jint)

c find nodal action 
      if(jref.eq.0 ) then  ! not a reference point move
         sdetc(itorg)=1.d0
         ratio=rnodact(itspan,itorg,movers,jref)
         ! now accept or reject based on the leakage probability
         rndnum=sprng()
         if(ifleak.eq.1.and.ratio.lt.rndnum) return
         naccx(nmovers,itype)=naccx(nmovers,itype)+1
!     write (*,*)'nr ', (movers(ipn),ipn=1,nmovers),itorg,ratio

      else ! reference point move
      
      do j=1,nslices !update all rows in all time slices (columns done already)
        it=iwrap(itorg+j)
        idiff=iabs(ntime(it,iref,irev,nslices))

        if(idiff.ne.0) then

        if(ifbf(itype))then  !NEW BACKFLOW CODE
           if(j.ge.itspan) then
              call backflow(it,r(1,1,it),refpt,sdetr(it),imatp,dum)
           else
              sdetr(it)=1.d0
           endif
        else !non backflow case

        if(j.lt.itspan) then
        !find density matrix between ref. pt. and other point
         call ofill(nmovers,movers,rt(1,1,jref,2),rows(1,1,it)
     +   ,mpm,iref,idiff,rtrial(1,nfirst,j+1),0 )
         call newup(fdenmat(lmat,1,it,imatp),fdenmat(lmat,1,it,imatp)
     +  ,rows(1,1,it),dstnode(ispin,itype,it,imatp),nanti,movers,nfirst
     .  ,nmovers
     +  ,ndim,ipopt,mmsize,mpm,sdetr(it),idebug,0,rtrial(1,nfirst,j+1)
     .           ,gradnode(1,nfirst,it,imatp))

         sdetr(it)=sdetc(it)*sdetr(it) ! sign is product of row and column signs

        else
         call ofill(nmovers,movers,rt(1,1,jref,2),rows(1,1,it)
     +   ,mpm,iref,idiff,r(1,nfirst,it),0 )
         call newup(fdenmat(lmat,1,it,imatf),fdenmat(lmat,1,it,imatp)
     +   ,rows(1,1,it),dstnode(ispin,itype,it,imatp),nanti,movers
     .   ,nfirst,nmovers
     +   ,ndim,ipopt,mmsize,mpm,sdetr(it),idebug,0,r(1,nfirst,it)
     .   ,gradnode(1,nfirst,it,imatp))
        endif

        endif
        if(sdetr(it).le.0.d0)return !finally reject
        endif
!       write (*,'(6i5,f10.5)') j,it,idiff,itype,ispin,imatp
!    .     ,dstnode(ispin,itype,it,imatp)
       enddo ! end loop over all time slices (j)

      ratio=rnodact(nslices,itorg,movers,jref)
      rndnum=sprng()
      if(ifleak.eq.1.and.ratio.lt.rndnum) return
      naccf(nmovers,itype)=naccf(nmovers,itype)+1
!     write (*,*)' r ', (movers(ipn),ipn=1,nmovers),itorg,ratio
      endif

      endif ! END OF FERMION STUFF

C HURRAY FINALLY ACCEPTED!

c find diffusion constant of center of mass
      do l=1,ndim
      do ipn=1,nmovers
      deltac=0.d0
      do j=2,itspan
        deltac=deltac+fpbc(rt(l,ipn,j,2)-rt(l,ipn,j,1),l)
      enddo
        avtemp(jdcr)=avtemp(jdcr)+(tau*deltac)**2
      enddo
      enddo

      if(nmovers.gt.1) then
        avtemp(jdcp)=avtemp(jdcp)+nmovers
c for acceptances update cycle length statistics for old permutation
        call cycle(1)
        if(iptblnow.gt.0)iptblnow=ic1
c change permutation and inverse permutation
        do ipn=1,nmovers
         iperm(movers(ipn))=iptry(ipn)
        enddo
        do ipn=1,nmovers
         ipermi(iperm(movers(ipn)))= movers(ipn)
        enddo
        if(nspins(itype).gt.0.and.mod(nmovers,2).eq.0) psign =-psign
      endif

      ntryswn(nmovers,itype)=ntryswn(nmovers,itype)+1 ! keep winding number change statistics
      ifw=0
      do l=1,ndim
      wrap=0.
      do j=2,itspan+1
      do ipn=1,nmovers
      wrap=wrap+fpbc(rt(l,ipn,j,2)-rt(l,ipn,j-1,2),l)-
     &      fpbc(rt(l,ipn,j,1)-rt(l,ipn,j-1,1),l)
      enddo
      enddo
      wrap=wrap/ell(l)
      iw(l)=nint(wrap) !  absolute value of the winding number in the lth dimension
c     if(abs(wrap-iw(l)).gt.1.e-4) then
c        write (*,66) itype,l,iw(l),wrap,ell(l)
66       format('  danger in weave wrap ell ',3i5,2f15.8)
c     endif
      if(iw(l).ne.0)ifw=1 
      enddo
      if(ifw.eq.1) then
        naccwn(nmovers,itype)=naccwn(nmovers,itype)+1
        call windup(1,iw,itype)
      endif

c update coordinates rhok and plane waves
      do 110 j=2,itspan+1
        it=iwrap(itorg+j-1)

        do ipn=1,nmovers
          ik=movers(ipn)
          do k=1,2*nvects
             pwmat(k,ik,it)=pwnew(k,ipn,j)
          enddo
          do l=1,ndim
            r(l,ik,it)=rt(l,ipn,j,2)
          enddo
        enddo

        do k=1,2*nvects
        rhok(k,itype,it)=rhoknew(k,j)
        enddo

      if (ifixnd.eq.1.and.(j.le.itspan.or.jref.ne.0)) then
c for fermions copy all the matrices over

        if(ifabf) then !BACKFLOW CASE
         do itys=1,ntypes
         do isps=1,nspins(itys)
           dstnode(isps,itys,it,imatf)=dstnode(isps,itys,it,imatp)
!        enddo
!        enddo
           do l=1,ndim
           do i=1,nparts
           gradnode(l,i,it,imatf) = gradnode(l,i,it,imatp) 
!          gradnod(l,i,isps,itys,it,imatf) 
!    .       = gradnod(l,i,isps,itys,it,imatp) !CHANGE
           enddo
           enddo
           enddo !change
           enddo !change
        else ! NOT BACKFLOW JUST ONE SPIN TYPE
         if(nspins(itype).gt.0) then
         do  l=1,ndim2
             call scopy(n2,fdenmat(lmat,l,it,imatp),1,
     +                     fdenmat(lmat,l,it,imatf),1)
         enddo
         dstnode(ispin,itype,it,imatf)=dstnode(ispin,itype,it,imatp)
           do l=1,ndim
           do i=nfirst,nlpss(ispin,itype)
           gradnode(l,i,it,imatf) = gradnode(l,i,it,imatp)
           enddo
           enddo
         endif
        endif
      endif

110   continue

      if(nspins(itype).gt.0.and.ifixnd.eq.1) then

        if(.not.ifabf) then
        do imvr=1,nmovers-1 ! apply permutation to columns of fdenmat at itar
          l1=(movers(imvr)-nfirst)*nanti+lmat
          l2=(movers(imvr+1)-nfirst)*nanti+lmat
          do l=1,ndim2
            call sswap(nanti,fdenmat(l1,l,itar,imatf),1,
     +                       fdenmat(l2,l,itar,imatf),1)
          enddo
            call sswap(ndim,gradnode(1,movers(imvr),itar,imatf),
     .        1,gradnode(1,movers(imvr+1),itar,imatf),1)

        enddo
        endif

        actnode=actnode*ratio

        if(jref.ne.0) then      ! reference move
         do  j=itspan+1,nslices !  copy fdenmat and dstnode
          it=iwrap(itorg+j)

          if(ifabf) then ! backflow case
         do itys=1,ntypes
         do isps=1,nspins(itys)
           dstnode(isps,itys,it,imatf)=dstnode(isps,itys,it,imatp)
         enddo
         enddo
          do l=1,ndim
           do i=1,nparts
           gradnode(l,i,it,imatf) = gradnode(l,i,it,imatp)
           enddo
           enddo

          else ! non-backflow
          do  l=1,ndim2
              call scopy(n2,fdenmat(lmat,l,it,imatp),1,
     +                      fdenmat(lmat,l,it,imatf),1)
          enddo
          dstnode(ispin,itype,it,imatf)=dstnode(ispin,itype,it,imatp)
          do l=1,ndim
           do i=nfirst,nlpss(ispin,itype)
           gradnode(l,i,it,imatf) = gradnode(l,i,it,imatp)
           enddo
           enddo
          endif

        enddo ! END OF LOOP OVER j=itspan+1,nslices
        endif

      endif
c test if fermion density matrices are current
      if(idebug.ge.2)call fdminit(iref,irev,act1,3)

      return
      end
