      program tcset
      include 'mach.p'
c generates fnpimc input for electron/proton mixtures
c version of 06/14/93, W. Magro UIUC, based on ocset by D. Ceperley
c      integer mnp,mnkv,mnsh,ndim,mn,mnt,iwrap,ipickoff,intread
      integer mnp,mnkv,mnsh,ndim,mn,mnt,ipickoff,intread
       integer isite, mini !delete this later
      integer lf,nspins,nk,ifermi,iunits,iseed,nppss,nb,nvects
      integer np,ncell,nhits,nl,n,l,i,ntail,kmult,number
      integer ln,nspec,nmt,nparts,ischarged,ntemp,nslices,k
      integer ld,j,nxtalp,nexp,m,nlamb
      integer cells
      real*8  pesign,check,vkzero,pre
c      real*8  pi,fpbc,fabc,fpbct,rlread,ranf,u,wsites,expon,d
      real*8  pi,rlread,ranf,u,wsites,expon,d
      real*8  rk,vtail,tpiell,rkcomp,cexpon,vk,uk,duk,prtail,psite
c      real*8  charge,accuracy,hbs2m,cutk,vol,rho,enorm,rnn,el2
      real*8  charge,accuracy,hbs2m,cutk,vol,rho,enorm,rnn,el2(3)
c      real*8  ell,ellsave,tlow,elli,cutr,beta,tslice,xx,del,e2,alpha
      real*8  ell(3),ellsave,tlow,cutr,beta,tslice,xx,del,e2,alpha
      real*8  tau,temp,cc,gam,zz,gr,gr0,vimage,rs
      real*8  vself,vn,sang,pot0,fract,volcut2
      
      parameter (mnp=220,mnkv=1000,mnsh=100,ndim=3,mn=10,mnt=3)
      parameter (pi=3.14159265358979)
      dimension tpiell(ndim),ncell(3),rkcomp(ndim,mnkv),rk(mnsh)
     +,kmult(mnsh),u(0:mnsh,mnt,mnt,4),nppss(2),wsites(ndim,mnp)
     +,expon(20),cexpon(20),charge(mnt,mnt),accuracy(mnt,mnt),iseed(2)
     +,hbs2m(mnt),number(mnt),psite(ndim,mnp),vk(6),uk(6),duk(6)
     +,prtail(mnt,mnt),vimage(mnt,mnt),ellsave(ndim)
      character qid*8,filen*14,ptype*3,dmfile*10,p(mn)*28,fname*24,
     +          eunit*5,lunit*5,pott*10
      character*1 pname(4)
c     common/copenfn/filen
c     include 'cpbc.cm'

      iseed(2)=111
      iseed(1)=0
      write(*,*) 'input seed'
      read (*,*) iseed(1), iseed(2)
      call iranset(iseed)
      ntail=-1
c     charge=0.
c the zero value is a flag that these vars have not yet been set.
      tlow=0.
      ntemp=0
      nmt=0

      write (*,*) 'input name of run'
      read (*,55) qid
55    format(a)

      nspec = 2 ! two species in this system

      ! a single letter identifier for each species
      pname(1)='e'
      pname(2)='p'

      ! read number of electrons
      write(*,*) 'input number of electrons'
      read(*,*) nparts
      number(1) = nparts
      number(2) = 1

c     nspec = 3 ! three species in this system
c     pname(3)='v'
c     number(3) = 1

      ln=index(qid,' ')-1
      open(1,file=qid(1:ln)//'.sy',status='unknown')
      open(7,file=qid(1:ln)//'.os',status='unknown')
      ! Identify this program on the .os file
      write(7,*) 'tcset'

      ! pott needs to be initialized
      pott = ' ' 

      write (*,*) 'input dm file prefix'
      read (*,55) dmfile

      iunits=0
      cutr=0.

      do i=1,nspec
       do j=1,i
         if(i.eq.j.and.number(i).eq.1) then
          write(*,*) 'No ',pname(j),pname(i),'interactions'
          goto 2
         endif
        ld=index(dmfile,' ')-1
        fname=dmfile(1:ld)//'.'//pname(j)//pname(i)//'.dm'
        write(*,*) 'Opening file ',fname
        open(8,file=fname)

1       k=ipickoff(8,p,n,mn)

        if(p(1).eq.'UNITS') then
         if(iunits.eq.0) then
          iunits=1
          eunit=p(2)
          lunit=p(3)
          call echo(1,p,n)
         else
          if(eunit.ne.p(2).or.lunit.ne.p(3)) then
           write(*,*) 'Unit mismatch in pair',pname(j),pname(i)
           stop
          endif
         endif

	elseif(p(1).eq.'POTTAIL') then
         ! tail for this pair
         prtail(j,i)=rlread(p(2))

        elseif(p(1).eq.'VIMAGE') then
         vimage(i,j) = rlread(p(2))

        elseif(p(1).eq.'TYPE') then
         ! particle label
         ptype=p(2)
         if (ptype(1:1).eq.pname(i)) then
          hbs2m(i)=rlread(p(3))
          write(*,*) 'hbs2m for particle ',pname(i),hbs2m(i)
         elseif (ptype(1:1).eq.pname(j)) then
          hbs2m(j)=rlread(p(3))
          write(*,*) 'hbs2m for particle ',pname(j),hbs2m(j)
         else
          write (*,*) 'unknown particle type ', ptype(1:1)
          stop
         endif

        elseif(p(1).eq.'SQUARER') then

         ! read squaring parameters
         if(tlow.eq.0.) then
          tlow=rlread(p(2))
         elseif(tlow.ne.rlread(p(2))) then
          write (*,*) 'tlow mismatch in ',pname(j), pname(i) 
         endif

         if(ntemp.eq.0) then
          ntemp=intread(p(3))
         elseif(ntemp.ne.intread(p(3))) then
          write (*,*) 'ntemp mismatch in ',pname(j), pname(i) 
         endif

         if(ndim.ne.intread(p(4)))stop

         if(nmt.eq.0) then
          nmt=intread(p(5))
         elseif(nmt.ne.intread(p(5))) then
          write (*,*) 'nmt mismatch in ',pname(j), pname(i) 
         endif

        elseif(p(1).eq.'POT')then
         ! look at potential type, and save it for later
         if(pott(1:1).eq.' ') then
          pott = p(2)
         elseif (p(2).ne.pott) then
          write(*,*) 'Pot. type mismatch in ',pname(j),pname(i)
          stop
         endif
         if(cutr.eq.0.) then
          cutr=rlread(p(3))
         elseif(cutr.ne.rlread(p(3))) then
          write (*,*) 'cutr mismatch in ',pname(j), pname(i) 
         endif

         if(p(2).eq.'COUL') then
          charge(i,j)=rlread(p(4))
          accuracy(i,j)=rlread(p(5))
          ! 05/20/93 david changed definition of accuracy...argh
          ! alpha=-log(accuracy(i,j))/cutr**2
          alpha=-.5*log(accuracy(i,j)*
     +            cutr/abs(charge(i,j)))/cutr**2

         elseif(p(2).eq.'COULOPT') then
          charge(i,j) = rlread(p(4))
          ! i should check that all three nlamb are the same
          nlamb = intread(p(6))
          do l=1,ndim
           if(l+6.le.n) then
            ! only read box size if it hasn't already been set
            if(ell(l).le.0.0) then
             ell(l)=rlread(p(l+6))
            elseif(ell(l).ne.rlread(p(l+6))) then
             write(*,*) 'Box mismatch in ',pname(j), pname(i)
             stop
            endif
           else
            ell(l)=ell(l-1)
           endif
          enddo


         else
          write (*,*) 'unknown potential'
          stop
         endif


        elseif(p(1).eq.'RANK') then
         go to 2
        endif
        go to 1

2       continue
       enddo
      enddo

      ! input crystal structure and simulation cell dimensions
      ! crystal:1=sc,2=bcc,3=hcp,4=fcc(3d)
      write(*,*) 'input crystal:1=sc,2=bcc,3=hcp,4=fcc(3d)'
      write (*,*) 'input box size (in lattice units)'
      read (*,*) nxtalp
      read (*,*) (ncell(i),i=1,3)


      ! if the box has already been defined (for COULOPT potential)
      !  use this box instead of prompting for density.
      if (ell(1).ne.0.0) then
       vol = 1.
       do l=1,ndim
        vol = vol*ell(l)
        ! save the box for later comparison with output of sites
        ellsave(l) = ell(l)
       enddo
       rho=nparts/vol
       ! compute an equivalent rs value from the density
       rs = .6203505*(rho)**(-1./3.)
      else
       ! read the density (as an rs value)
       write(*,*) 'input rs'
       read (*,*) rs
       ! convert rs to density in angstroms
c      rho = nspec*1.6110/rs**3.
c      vol = nspec*nparts/rho
      endif

      ! record the density, volume, and rs in the .os file
      write (7,*)  'total density: rho = ',rho
      write (7,*)  'electron rs: rs = ',rs
      write (7,*)  'vol = ',vol

      ! rnn is the nearest neighbor distance, cube edge is 
      !  sqrt(2.)*rnn.  The NaCl nearest neighbor distance is
      !  half that, thus rnn/sqrt(2.)
      call sites(1,wsites,nparts,ndim,nxtalp,vol,ncell,ell,rnn,3)
      do l=1,ndim
       
       if(pott.eq.'COULOPT'.and.(ell(l)-ellsave(l)).gt.1e-4) then
        write(*,*)
     +   'WARNING!: Box mismatch in sites: new, old:'
     +   ,ell(l), ellsave(l)
       endif
      enddo
      write(*,*) 'sites gives rnn of: ',rnn
      write(7,*) 'box :',(ell(l),l=1,3)

      !!!!!!!!!!!!  Setup the box parameters  !!!!!!!!!!!
      ! cutoff radial tables at 1/2 the smallest box dimension
      e2=.5*ell(1)
      do l=1,ndim
       tpiell(l)=2*pi/ell(l)
       el2(l)=.5*ell(l)
       e2=min(e2,.5*ell(l))
      enddo
      if(e2.lt.cutr)then
       write (*,*) ' potential sticks out of box ',cutr,e2
       stop
      endif
      write (1,88) (ell(l),l=1,ndim)
88    format(' BOXSIZE',3e18.10)

      ! set the energy normalization
      enorm=1.
      write (1,89) ' ENORM ',enorm
89    format(a10,e17.8)
      write (*,*) ' possible fits=',nmt
      write (*,*) ' possible tslice ',(tlow*2**(l-1),l=1,ntemp)
      write (*,*) ' input Temp, tslice '
      read (*,*) temp,tau
      tslice=0.
      ! match the input to a temperature on the file
      do l=1,ntemp
       if(abs(tau/(tlow*2**(l-1))-1.).lt..001) then
        tslice=tlow*2**(l-1)
       endif
      enddo

      if(tslice.eq.0.)stop
      nslices=tslice/temp+.001
      beta=nslices/tslice
      write (*,*)' nslices = ',nslices,' temp ',1./beta
      ! thermodynamic temp
      write (1,89)' BETA ',beta
      ! number of time slices per ring
      write (1,*)' NSLICES ',nslices
      ! we have fermions, set number of reference points to be used.
c this is for plane wave-ground state nodes
      write (1,*) 'NREF ',0

      ! loop over particle types
      do j=1,nspec
       filen=qid(1:ln)//'.'//pname(j)//'.ic'
       lf=index(filen,' ')-1

       ! start with the protons and electrons on the same sites
       do l=1,3
        do i=1,nparts
         xx=wsites(l,i)
         psite(l,i)=xx
         !write(*,*) psite(l,i)
        enddo
       enddo

       ! now perturb them by 10% of the neighbor spacing: 0.1*rnn
       del =  0.1*rnn
       write(*,*) 'displacing particles by ', del
       do l=1,ndim
        do i=1,nparts
         xx=wsites(l,i) + del*(ranf()-0.5)
         ! fix up periodic boundaries
         if(xx.gt. el2(l)) xx=xx-ell(l)
         if(xx.lt.-el2(l)) xx=xx+ell(l)
         psite(l,i)=xx
        enddo ! i=1,nparts
       enddo ! l=1,ndim

       ! write out coordinates of type j
       call writecon(psite,ndim,number(j),ell,filen, ndim)

       ! don't bother with statistics for heavy particles
       if(j.eq.1) then
        nspins=2
        nppss(1) = nparts/2
        nppss(2) = nparts - nppss(1)
        if (nparts.ne.nparts/2*2) then
         write(7,*)'system is polarized: nup ndown',nppss(1),nppss(2)
        endif
       else
        nspins=0
       endif

       if(nspins.eq.1) then
        ifermi=1
        write (1,71)pname(j),hbs2m(j),nspins,number(j)
     +  ,(nppss(i),i=1,nspins),filen
71      format('TYPE ',a3,e17.9,3i5,' ',a14)
       elseif(nspins.eq.2) then
        ifermi=1
        write (1,72)pname(j),hbs2m(j),nspins,number(j)
     +  ,(nppss(i),i=1,nspins),filen
72      format('TYPE ',a3,e17.9,4i5,' ',a14)
       elseif(nspins.eq.0) then
        ifermi=0
        write (1,73)pname(j),hbs2m(j),nspins,number(j)
     +  ,(nppss(i),i=1,nspins),filen
73      format('TYPE ',a3,e17.9,2i5,' ',a14)
       endif

       ! specify the .dm file for each pair
       do k=1,j
        ! only write out an interaction for different species or if there
        !  are more than one of a single species.
        if(k.ne.j.or.number(k).ne.1) then
         write (1,*) 'POT PAIR ',pname(k),' ',pname(j),' '
     +             ,dmfile(1:ld)//'.'//pname(k)//pname(j)//'.dm' 
        endif
       enddo ! k=1,j
      enddo ! j=1,nspec

      ! construct the long ranged potential
      ! first treat the case of a traditional Ewald breakup
      if (pott.eq.'COUL') then
      cutk=2.*cutr*alpha
      write (*,*) 'cutk: ',cutk
      call shells(ndim,tpiell,cutk,nk,rkcomp,rk(1),kmult
     +,nvects,mnkv,mnsh,3)

      do i=1,nspec
       do j=1,i
        nexp=1
        cc=charge(i,j)*pi**(.5*ndim)/(vol*gam(dble(.5)*nexp))
        zz=.5*(ndim-nexp)
        do k=1,nk
         call gammi(gr,zz,rk(k)**2/(4*alpha),gr0)
         ! this is the long range potential
         u(k,i,j,1)=cc*gr*(.5*rk(k))**(-ndim+nexp)
         ! this is the (transform of the) short range potential
         u(k,i,j,4)=cc*(1-gr)*(.5*rk(k))**(-ndim+nexp)
         ! symmetrize in i, j
         if(i.ne.j) u(k,j,i,1)=u(k,i,j,1)
        enddo ! k=1,nk
       enddo ! j=1,i
        write(1,*) 'GAMMA 1 ',pname(i),' 1.0'
        write(1,*) 'GAMMA 2 ',pname(i),' 0.0'
       ! don't bother trying to permute heavy particles
       if (hbs2m(i).gt.1.e-2) then
        write(1,*) 'GAMMA 3 ',pname(i),' 40.0'
       else
        write(1,*) 'GAMMA 3 ',pname(i),' 0.0'
       endif
      enddo ! i=1,nspec

      ! do tail corrections to total potential/particle
      ! compute the constant terms in the potential
      ! we compute the full expressions, then divide by enorm
      ! before writing vtail out.
      vtail = 0.
      volcut2 = 0.5*sang(ndim)*cutr**ndim/float(ndim)
      fract = volcut2/vol
      write(*,*) vol, volcut2, volcut2*2, fract
      do i=1,nspec
       ! add in the self interaction for this species
       vself=-2*charge(i,i)*alpha**(.5*nexp)/(nexp*gam(dble(.5)*nexp))
       write(*,*) 'Adding ',vself,' to vtail for spec ',pname(i)
       vtail=vtail+0.5*number(i)*vself
       do j=1,i
        pre=1.0
        if(i.ne.j) pre=2.0
        cc=charge(i,j)*pi**(.5*ndim)/(vol*gam(dble(.5)*nexp))
        vkzero=-cc/(zz*alpha**zz)
        write(*,*) 'Adding ',vkzero,' to vtail for pair ',
     +              pname(i),pname(j)
        ! vn is the part of the potential tructated from vsr
        !  it should really be N(N-1) when i==j
        vn=fract*number(i)*(number(j)-1)*prtail(j,i)
        write(*,*) 'Adding vn:',vn,' to vtail for pair ',
     +              pname(i),pname(j)
        vtail=vtail+pre*0.5*number(i)*number(j)*vkzero+vn
        check=check+pre*0.5*number(i)*number(j)*vkzero
       enddo ! j=1,i
      enddo ! i=1,nspec

      ! now handle the optimal Ewald breakup
      elseif(pott.eq.'COULOPT') then
       cutk = 6*tpiell(1)
       call shells(ndim,tpiell,cutk,nk,rkcomp,rk(1),kmult
     +    ,nvects,mnkv,mnsh,ndim)
       if (nk.lt.nlamb) then
        write(*,*) 'nlamb too large: nlamb, nk',nlamb,nk
        stop
       endif
       nk=nlamb
       cutk=rk(nlamb)*1.001
       write(*,*) 'cutk: ',cutk
       vtail = 0.0
       check = 0.0
       do i=1,nspec
        ! vimage is 0.5 Lim[r->0](vsr(r) - vlr(r))
        write(*,*) 'Adding ',vself,' to vtail for spec ',pname(i)
        vtail=vtail + number(i)*vimage(i,i)
        do j=1,i
         close(4)
         open(4,file=dmfile(1:ld)//'.'//
     +        pname(j)//pname(i)//'.vk',status='old')
         call checkrnk(4,1,nk+1)
         call findbegn(4)
         read (4,*) (u(k,i,j,1),k=0,nk)
         if (i.ne.j) then
          do k=1,nk
           u(k,j,i,1) = u(k,i,j,1)
           ! we don't know the transform of v_short
           u(k,1,1,4) = 0.
           u(k,1,2,4) = 0.
           u(k,2,1,4) = 0.
           u(k,2,2,4) = 0.
          enddo
         endif
         pre = 1.0
         ! we were supposed to sum over _all_ i and j
         if (i.ne.j) pre = 2.0
         vtail = vtail + 0.5*pre*number(i)*number(j)*u(0,i,j,1)
         check = check + 0.5*pre*number(i)*number(j)*u(0,i,j,1)
        enddo ! j=1,i
       enddo ! i=1,nspec
      endif

      ! the vkzero terms should cancel for a neutral system
      write(*,*) 'Check should be zero for neutral systems ',check

      ! specify the long range potential
      write (*,*)' number of k-vectors ',nk,kmult(nk)
      write (1,*)'POT EWALD ',cutk,' ',qid(1:ln)//'.lr'

      ! write out vtail with proper normalization
      write (1,89)' VTAIL ',vtail/enorm
      ! corresponding shift in pressure
      write (1,89)' PTAIL ',rho*vtail/enorm

      ! setup the long range rpa action terms
      do k=1,nk
       ! vk(1..3) are the long range potentials, vpp, vpe, and vee.
       vk(1)=u(k,1,1,1)
       vk(2)=u(k,1,2,1)
       vk(3)=u(k,2,2,1)
       ! vk(4..6) are the short range potentials, vspp, vspe, and vsee.
       vk(4)=u(k,1,1,4)
       vk(5)=u(k,1,2,4)
       vk(6)=u(k,2,2,4)
 
       ! initial conditions are u(k,tau=0)=0 for all six terms
       ! uk(1..6) are the long range action terms, upp, upe, and uee.
       uk(1)=0.
       uk(2)=0.
       uk(3)=0.
       ! uk(4..6) are the short range action terms, wpp, wpe, and wee.
       uk(4)=0.
       uk(5)=0.
       uk(6)=0.
       ! integrate the RPA matrix equation from beta = 0 to tau.
       !  action is returned in uk, its derivative in duk.
       call intrpa(uk,duk,rk(k),0.,1./tslice,number,hbs2m,vk)
       ! u(k,i,j,2) is the (symmetric) action for pair i,j
       u(k,1,1,2)=uk(1)
       u(k,1,2,2)=uk(2)
       u(k,2,1,2)=uk(2)
       u(k,2,2,2)=uk(3)
       ! u(k,i,j,3) is the beta derivative of the action for pair i,j less vk
       u(k,1,1,3)=duk(1) - u(k,1,1,1)
       u(k,1,2,3)=duk(2) - u(k,1,2,1)
       u(k,2,1,3)=duk(2) - u(k,2,1,1)
       u(k,2,2,3)=duk(3) - u(k,2,2,1)
      enddo ! k=1,nk
   
      ! write out the long range part of the potential and action
      open(2,file=qid(1:ln)//'.lr',status='unknown')
      write (2,*)'RANK 5 ',nk,nspec, nspec,' 3  1'
      write (2,*)'BEGIN k-space action'
      write (2,*)((((u(k,i,j,m),k=1,nk),i=1,nspec),j=1,nspec),m=1,3)
      close(2)

      ! write out a table of the p-p and e-e deriv of action
      open(2,file=qid(1:ln)//'.uk',status='unknown')
      do k = 1,nk
      write (2,*) rk(k),u(k,1,1,3)/u(k,1,1,1)
      enddo
      close(2)


      ! use free part sampling and displace moves for the protons
c     write (1,*) 'FREESAMP p'
      write (1,*) 'DISPLACE p ',0.5*rnn
      
      ! try to move the reference point along the chain simply by relabeling
c     write (1,*) 'REFDISP',0

      write (1,*)'RESTART'

      write (*,*)' input blocks passes, levels for omove '
      read (*,*) nb,np,nl
      if(nb.gt.0)write (1,*) 'OMOVE ',nb,' ',np,' ',nl
      write (*,*)' input blocks, passes, levels, hitsfor select '
      read (*,*) nb,np,nl,nhits
      if(nb.gt.0)write (1,*) 'SELECT ',nb,' ',np,' ',nl,' ',nhits
      stop
      end 
